﻿#include "stdafx.h"
#include "main_frame.hpp"
#include "NeMessengerDlg.h"
#include "DuiDefine.h"
#include "..\..\DuiLib\Utils\WinImplBase.h"
#include "XDragUtil.h"


#include "NMessageBox.h"
#include "SearchWnd.h"
#include "ProfileWnd.h"
#include "UIMenu.h"
#include "SendNoteMananger.h"
#include "XHyperLink.h"
#include "AESCrypto.h"
#include "WorkGroupDlg.h"
#include "main_frame.hpp"
#include "ChatSearchWnd.h"
#include "SmsSearchWnd.h"
#include "UnReadChatMessage.h"
#include "BannerNoticeWnd.h"
#include "ServerAddrConfig.h"
#include "ConfirmationNumberDlg.h"
#include "CreateNewGroupWnd.h"

//#include <ftlWindow.h>

#define ITEM_LOGO_LEFT_ARROW_IDTH 6
#define MSG_REQUEST_ORGNIZATION_MEMBER (WM_USER+9950)
#define TIMER_RECENT_LIST (24*60*60*1000)

const int c_min_main_search_height = 38;

namespace DuiLib{

	BannerBoard::BannerBoard(CPaintManagerUI& paint_manager, HWND hWnd)
		: paint_manager_(paint_manager)
	{	
		m_hParent = hWnd;
		m_pBannerCtrller = NULL;

	}

	BannerBoard::~BannerBoard()
	{

	}

	void BannerBoard::DoEvent(TEventUI& event) 
	{
		if (!IsMouseEnabled() && event.Type > UIEVENT__MOUSEBEGIN && event.Type < UIEVENT__MOUSEEND)
		{
			if (m_pParent != NULL)
				m_pParent->DoEvent(event);
			else
				CVerticalLayoutUI::DoEvent(event);
			return;
		}
		if (event.Type == UIEVENT_BUTTONDOWN)
		{
			m_pBannerCtrller->OnLButtonDown();
		}
		CVerticalLayoutUI::DoEvent(event);
		return;
	}

	ButtonBoard::ButtonBoard(CPaintManagerUI& paint_manager, HWND hWnd)
		: paint_manager_(paint_manager)
	{	
		m_hParent = hWnd;

	}

	ButtonBoard::~ButtonBoard()
	{

	}

	void ButtonBoard::DoEvent(TEventUI& event) 
	{
		if (!IsMouseEnabled() && event.Type > UIEVENT__MOUSEBEGIN && event.Type < UIEVENT__MOUSEEND)
		{
			if (m_pParent != NULL)
				m_pParent->DoEvent(event);
			else
				CHorizontalLayoutUI::DoEvent(event);
			return;
		}
		if (event.Type == UIEVENT_BUTTONDOWN)
		{
			//int i=0;
		}
		CHorizontalLayoutUI::DoEvent(event);
		return;
	}


}

BOOL IsFindByID_UserVector(std::vector<const IGTBuddyUser*>& vecSelectedBuddyUser, LPCTSTR strID)
{
	CString strFindID = strID;
	for (size_t j = 0; j < vecSelectedBuddyUser.size(); j++)
	{
		CString strUserID = vecSelectedBuddyUser[j]->GetUserID();
		if (strUserID.CompareNoCase(strFindID) == 0)
		{
			return TRUE;
		}
	}
	return FALSE;
}

BOOL IsFindByID_UserNodeVector(std::vector<Node*>& vecSelectedBuddyUser, LPCTSTR strID)
{
	CString strFindID = strID;
	for (size_t j = 0; j < vecSelectedBuddyUser.size(); j++)
	{
		CString strUserID = vecSelectedBuddyUser[j]->data().value;
		if (strUserID.CompareNoCase(strFindID) == 0)
		{
			return TRUE;
		}
	}
	return FALSE;
}


const int kBackgroundSkinImageCount = 3;

DUI_BEGIN_MESSAGE_MAP(MainFrame, WindowImplBase, FALSE)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_WINDOWINIT, OnPrepare)
    //DUI_ON_MSGTYPE(DUI_MSGTYPE_SETFOCUS, OnNotifySetFocus)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_KILLFOCUS, OnNotifyCtrlKillFocus)
    
    //Ctrl Click  -- //DUI_ON_MSGTYPE(DUI_MSGTYPE_CLICK, OnNotifyCtrlClick)
    DUI_ON_CLICK_CTRNAME(kInfoMe, _OnCtrlBtnInfoMeClick)
    DUI_ON_CLICK_CTRNAME(kIptStatusBtn, _OnCtrlBtnIptStatusClick)
    DUI_ON_CLICK_CTRNAME(kFavorite, _OnCtrlBtnFavoriteClick)
    DUI_ON_CLICK_CTRNAME(kCloseBanner, _OnCtrlCloseBannerClick)
    DUI_ON_CLICK_CTRNAME(kCloseButtonControlName, _OnCtrlBtnCloseClick)
    DUI_ON_CLICK_CTRNAME(kMinButtonControlName, _OnCtrlBtnMinClick)
    DUI_ON_CLICK_CTRNAME(kMaxButtonControlName, _OnCtrlBtnMaxClick)
    DUI_ON_CLICK_CTRNAME(kRestoreButtonControlName, _OnCtrlBtnRestoreClick)
    DUI_ON_CLICK_CTRNAME(kMenuButtonControlName, _OnCtrlBtnMenuClick)

	DUI_ON_CLICK_CTRNAME(kMenuOptionChatHistory, _OnMenuOptionChatWebClick) // chat history
	DUI_ON_CLICK_CTRNAME(kMenuOptionMemo, _OnMenuOptionMemoClick)   //memo

	DUI_ON_CLICK_CTRNAME(kMenuOptionMail, _OnMenuOptionMailClick) //mail
	DUI_ON_CLICK_CTRNAME(kMenuOptionApprove, _OnMenuOptionSignClick) // sign

	DUI_ON_CLICK_CTRNAME(kMenuOptionVOC, _OnMenuOptionVOCClick) // voc
	DUI_ON_CLICK_CTRNAME(kMenuOptionSurvey, _OnMenuOptionSurveyClick)   //survey

	DUI_ON_CLICK_CTRNAME(kMenuOptionIN, _OnMenuOptionINClick) //IN
	DUI_ON_CLICK_CTRNAME(kMenuOptionSAM, _OnMenuOptionSAMClick) // SAM

	DUI_ON_CLICK_CTRNAME(kMenuArrowUp, _OnMenuArrowUp)
	DUI_ON_CLICK_CTRNAME(kMenuArrowDown, _OnMenuArrowDown)
    DUI_ON_CLICK_CTRNAME(kOrgBtnPopup, _OnCtrlBtnOrgPopClick)
    DUI_ON_CLICK_CTRNAME(kOrgBtnIPT, _OnCtrlBtnOrgIptClick)
    DUI_ON_CLICK_CTRNAME(kTabBookmark, _OnCtrlTabBookmarkClick)
    DUI_ON_CLICK_CTRNAME(kSearchLabel, _OnCtrSearchLabelClick)
    DUI_ON_CLICK_CTRNAME(kSearchBtn, _OnCtrlSearchBtnClick)
    DUI_ON_CLICK_CTRNAME(kSearchCancel, _OnCtrlSearchCancelClick)
    DUI_ON_CLICK_CTRNAME(kHideLeftMainPannelControlName, _OnCtrlHideLeftMainPannelClick)
    DUI_ON_CLICK_CTRNAME(kShowLeftMainPannelControlName, _OnCtrlShowLeftMainPannelClick)
    DUI_ON_CLICK_CTRNAME(kChangeBkSkinControlName, _OnCtrlChangeBkSkinClick)
    DUI_ON_CLICK_CTRNAME(kChangeColorSkinControlName, _OnCtrlChangeColorSkinClick)
    DUI_ON_CLICK_CTRNAME(kBtnStatus, _OnCtrlStatusBtnClick)

    DUI_ON_CLICK_CTRNAME(kBtnNoteControlName, _OnCtrlButtonBoardClick)

	DUI_ON_CLICK_CTRNAME(kBtnSignControlName, _OnCtrlButtonBoardClick)
	DUI_ON_CLICK_CTRNAME(kBtnMailControlName, _OnCtrlButtonBoardClick)
	DUI_ON_CLICK_CTRNAME(kBtnVocControlName, _OnCtrlButtonBoardClick)
	DUI_ON_CLICK_CTRNAME(kBtnSurveyControlName, _OnCtrlButtonBoardClick)
	DUI_ON_CLICK_CTRNAME(kBtnInControlName, _OnCtrlButtonBoardClick)
	DUI_ON_CLICK_CTRNAME(kBtnSamControlName, _OnCtrlButtonBoardClick)

    //DUI_ON_CLICK_CTRNAME(xxxx, _OnCtrlxxxxxx)

    DUI_ON_MSGTYPE(DUI_MSGTYPE_TIMER, OnNotifyTimer)
    //DUI_ON_MSGTYPE(DUI_MSGTYPE_ESCAPE, OnNotifyItemEsc)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_RETURN, OnNotifyItemEnter)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_SELECTCHANGED, OnNotifyTabSelectChange)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_DRAGSTART, OnNotifyItemDrag)

    DUI_ON_MSGTYPE(DUI_MSGTYPE_DRAGMOVING, OnNotifyMainMenuDrag)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_ITEMDBCLICK, OnNotifyItemDoubleClick)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_ITEMCLICK, OnNotifyItemClick)
    //DUI_ON_MSGTYPE(DUI_MSGTYPE_TEXTCHANGED, OnNotifyTextChanged)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_SET_CURSOR, OnNotifySetCurSor)
DUI_END_MESSAGE_MAP()

//LRESULT MainFrame::HandleCustomMessage(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled) \
//{ 
//    LRESULT lResult = 0; 
//    DUMP_WINDOWS_MSG(__FILE__LINE__, DEFAULT_DUMP_FILTER_MESSAGES,
//        _countof(DEFAULT_DUMP_FILTER_MESSAGES), uMsg, wParam, lParam);
//    switch(uMsg){
DUI_BEGIN_CUSTOM_MSG_MAP(MainFrame)
    ON_CUSTOM_MSG(WM_SIZE, _OnMsgSize)
    ON_CUSTOM_MSG(WM_MOUSEWHEEL, _OnMsgMouseWheel)
    ON_CUSTOM_MSG(WM_SYSKEYDOWN, _OnMsgSysKeyDown)
    ON_CUSTOM_MSG(WM_KEYDOWN, _OnMsgKeyDown)
    ON_CUSTOM_MSG(MSG_CLOSE_MAIN_SEARCH, _OnMsgCloseMainSearch)
    ON_CUSTOM_MSG(MSG_REQUEST_ORGNIZATION_MEMBER, _OnMsgRequestOrgnizationMember)
    ON_CUSTOM_MSG(WM_USERIMAGE_UPDATED, _OnMsgUserImageUpdated)

    BEGIN_CUSTOM_COMMAND_GROUP()
        ON_CUSTOM_COMMAND_MSG(ID_MENU_USER_INFO, _OnCommandMenuUserInfo)
        ON_CUSTOM_COMMAND_MSG(ID_MENU_SEND_MEMO, _OnCommandMenuSendMemo)
        ON_CUSTOM_COMMAND_MSG(ID_MENU_TREE_SEND_MEMO, _OnCommandMenuTreeSendMemo)
        ON_CUSTOM_COMMAND_MSG(ID_MENU_CHAT_HISTORY, _OnCommandMenuChatHistory)
        ON_CUSTOM_COMMAND_RANGE_MSG(WM_USER_ID_LIST, (WM_USER_ID_LIST + 1000), _OnCommandRangeUserIdList)
        ON_CUSTOM_COMMAND_RANGE_MSG(WM_USER_ID_TREE, (WM_USER_ID_TREE + 1000), _OnCommandRangeUserIdTree)
        ON_CUSTOM_COMMAND_MSG(ID_MENU_CHAT, _OnCommandMenuChat)
        ON_CUSTOM_COMMAND_MSG(ID_MENU_CREATE_FAVORITE_GROUP, _OnCommandMenuCreateFavoriteGroup)
        ON_CUSTOM_COMMAND_MSG(ID_MENU_SMS, _OnCommandMenuSms)
        ON_CUSTOM_COMMAND_MSG(ID_MENU_TREE_SMS, _OnCommandMenuTreeSms)
    END_CUSTOM_COMMAND_GROUP()

DUI_END_CUSTOM_MSG_MAP()


MainFrame::MainFrame(CNeMessengerDlg* pNeMessageDlg)
: m_pMessengerMain(pNeMessageDlg),
bk_image_index_(0),
m_mainMenuControler(&m_PaintManager),
m_recentContacts(&m_favoriteController),
m_pChatListManager(NULL),
m_DropTarget(this)
, m_bEnableNotice(FALSE)
, m_bEnableBanner(FALSE)
,m_rollingNoticeSeq(0)
{
	m_ePopupMenuType = LIST_POPUP_MENU;
	m_pSearchWnd = NULL;
	m_pCurSelNode = NULL;
	m_pImageDownloadThread = NULL;
	m_hInternetSession = NULL;
	m_hHttpConnection = NULL;
	m_hHttpFile = NULL;
	m_bAbort = FALSE;
	m_bSafeToClose = FALSE;
	m_bShowSearchWnd = FALSE;
	m_bSearchRecentChat = FALSE;
	m_bRequestORGGroup = FALSE;
	m_nUserAuth = AUTH_SHOW_NONE;

	m_pChatSearchWnd = NULL;
	m_pSmsSearchWnd = NULL;
	CUserImageActor::Instance()->RegisterObserver(this);
	m_uClipBoardFormat = RegisterClipboardFormat(_T("CF_NTALK_ID"));
	m_pCallHistoryDlg = NULL;
	TCHAR szFontName[MAX_PATH];
	ZeroMemory(szFontName, sizeof(szFontName));
	_tcscpy(szFontName, GetDefaultFontFaceName() );
	//m_PaintManager.ApplyForceFontName(szFontName);
	m_pImgList = NULL;
    //m_pBannerNotice = NULL;
	m_pBuddyList = new CBuddyTreeCtrl(this);
	m_favoriteController.SetList(m_pBuddyList);

	m_pChatListManager = new CRecentChatListManager(this);
	m_pOrgList = new CDuiOrgList(this);
	m_nSearchWndHeight = c_min_main_search_height;
	m_strMyGroupID = _T("");
	m_pRequestNode = NULL;
    m_nForwardingStatus = 0;
    m_nDndStatus = 0;
    wnd =  NULL;
    refcount = 0;
    m_nPort = 0;
    m_dwServiceType = 0;
    m_eDragDropType = eList;
}

MainFrame::~MainFrame()
{
	RevokeDragDrop(m_hWnd);
	g_pMessengerActor->GetWASActor()->UnRegisterObserver(this);
	CUserImageActor::Instance()->UnRegisterObserver(this);
	
	if (m_pChatListManager != NULL)
	{
		delete m_pChatListManager;
		m_pChatListManager = NULL;
	}
	if (m_pOrgList != NULL)
	{
		delete m_pOrgList;
		m_pOrgList = NULL;
	}
	if (m_pBuddyList != NULL)
	{
		delete m_pBuddyList;
		m_pBuddyList = NULL;
	}
	/*if (m_pBannerNotice != NULL)
	{
		::DestroyWindow(m_pBannerNotice->GetHWND());

		delete m_pBannerNotice;
		m_pBannerNotice = NULL;
	}*/

	//PostQuitMessage(0);
}

LPCTSTR MainFrame::GetWindowClassName() const
{
	return _T("nTalk_MainFrame");
}

CControlUI* MainFrame::CreateControl(LPCTSTR pstrClass)
{
	if (_tcsicmp(pstrClass, _T("FriendList")) == 0)
	{
		return new CFriendsUI(m_PaintManager);
	}
	if (_tcsicmp(pstrClass, _T("GroupList")) == 0)
	{
		return new CChatRoomList(m_PaintManager);
	}
	else if (_tcsicmp(pstrClass, _T("OrganizationTree")) == 0)
	{
		return new COrganizationTreeUI(m_PaintManager, m_hWnd);
	}
	else if (_tcsicmp(pstrClass, _T("BannerBoard")) == 0)
	{
		BannerBoard *pBoard = new BannerBoard(m_PaintManager, m_hWnd);
		pBoard->SetBannerController(&m_InfoBannerCtrller);
		return pBoard;
	}

	else if (_tcsicmp(pstrClass, _T("ButtonBoard")) == 0)
	{
		ButtonBoard *pBoard = new ButtonBoard(m_PaintManager, m_hWnd);
		return pBoard;
	}

	return NULL;
}

void MainFrame::OnFinalMessage(HWND hWnd)
{
    m_DropTarget.Revoke();
	m_pChatSearchWnd = NULL;
	CloseSearchWnd();
	KillAllTimer();
	COrganizationTreeUI* pOrgTreeList = static_cast<COrganizationTreeUI*>(m_PaintManager.FindControl(kOrganization));
	if (pOrgTreeList != NULL)
	{
		pOrgTreeList->RemoveAll();
	}
	
	CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_PaintManager.FindControl(kFriendsListControlName));
	if (pFriendsList != NULL)
	{
		pFriendsList->RemoveAll();
	}

	CloseCallHistoryDlg();
	WindowImplBase::OnFinalMessage(hWnd);
}

void MainFrame::LoadSkin()
{
	m_PaintManager.Init(m_hWnd);
	CDialogBuilder dlgBuilder;
	CDialogBuilderCallbackEx cb(this);
	CControlUI* pRoot = dlgBuilder.Create(_T("skin.xml"), (UINT)0,  &cb, &m_PaintManager);
	ASSERT(pRoot);
	m_PaintManager.AttachDialog(pRoot);
	m_PaintManager.AddNotifier(this);
	InitControls();
}

CDuiString MainFrame::GetSkinFile()
{
	return _T("skin.xml");
}

CDuiString MainFrame::GetSkinFolder()
{
	return _T("skin\\nTalkRes");
}

LRESULT MainFrame::OnClose(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	bHandled = FALSE;
	return 0;
}

LRESULT MainFrame::OnSysCommand(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	BOOL bZoomed = ::IsZoomed(m_hWnd);
	LRESULT lRes = CWindowWnd::HandleMessage(uMsg, wParam, lParam);
	if (::IsZoomed(m_hWnd) != bZoomed)
	{
		if (!bZoomed)
		{
			CControlUI* pControl = static_cast<CControlUI*>(m_PaintManager.FindControl(kMaxButtonControlName));
			if( pControl ) pControl->SetVisible(false);
			pControl = static_cast<CControlUI*>(m_PaintManager.FindControl(kRestoreButtonControlName));
			if( pControl ) pControl->SetVisible(true);
		}
		else 
		{
			CControlUI* pControl = static_cast<CControlUI*>(m_PaintManager.FindControl(kMaxButtonControlName));
			if( pControl ) pControl->SetVisible(true);
			pControl = static_cast<CControlUI*>(m_PaintManager.FindControl(kRestoreButtonControlName));
			if( pControl ) pControl->SetVisible(false);
		}
	}

	return 0;
}

LRESULT MainFrame::OnNcLButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	if ((INT)wParam   ==   HTCAPTION)
	{
		if (m_bShowSearchWnd)
		{
			CloseSearchWnd();

		}

		m_PaintManager.SetFocus(NULL);
	}
	bHandled = FALSE;
	return 0;
}

LRESULT MainFrame::ResponseDefaultKeyEvent(WPARAM wParam)
{
	if (wParam == VK_RETURN)
	{
		return FALSE;
	}
	else if (wParam == VK_ESCAPE)
	{
		return TRUE;
	}
	return FALSE;
}

NE_NOTICE_DATA MainFrame::GetNoticeDataBySeq(unsigned long seq){

	unsigned long index = seq % m_vecNoticeList.size();

	/*std::vector<NE_NOTICE_DATA>::iterator itr = m_vecNoticeList.begin();
	for( unsigned int i = 0; i < index; i++)
		itr++;

	return *itr;*/
	return m_vecNoticeList[index];
}


void MainFrame::OnNotifyTimer(TNotifyUI& msg)
{
    if (msg.wParam == TID_BANNER_ROLLING)
    {
        m_InfoBannerCtrller.OnTimer(TID_BANNER_ROLLING);
		return;
    }
	else if (msg.wParam == LEGACY_COUNT_TIMER)
	{
           m_pMessengerMain->ProcGetHanatourCount();
	}
	else if (msg.wParam == UPDATE_USER_IMAGE)
	{
		list<wstring> listUserIds = m_favoriteController.GetRecentContactUsers();


		GT_MY_USER_DATA myUserData;
		g_pMessengerActor->GetMyUserInfo(myUserData);
		listUserIds.push_back( myUserData.sMyPage.strUserID);

		size_t nBuddyCount = g_pMessengerActor->GetBuddyCount();		
		for (unsigned int index = 0; index < nBuddyCount; index++)
		{
			const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfoFromIndex(index);
			list<std::wstring>::iterator itFind = find(listUserIds.begin(), 
				listUserIds.end(), pUser->GetUserID());
			if(itFind == listUserIds.end())
			{
				listUserIds.push_back(pUser->GetUserID());	
			}
			
		}

		for (list<wstring>::iterator it = listUserIds.begin(); it != listUserIds.end();)
		{
			if(CUserImageActor::Instance()->IsUserImageExist(*it))
			{
				it = listUserIds.erase(it);
			}
			else
				it++;
		}

		if(!listUserIds.empty())CUserImageActor::Instance()->RequestUserImages(listUserIds);
	}
	/*if (msg.wParam == TID_NOTICE_ROLLING)
	{

		KillTimer(TID_NOTICE_ROLLING);

		m_rollingNoticeSeq++;
		NE_NOTICE_DATA data= GetNoticeDataBySeq(m_rollingNoticeSeq);
		m_pBannerNotice->SetNoticeText(data.strTitle);
		
		SetTimer(TID_NOTICE_ROLLING, BANNER_ROLLING_INTERVAL);
		return;
	}*/
	else if(msg.wParam == REFRESH_BANNER_LIST)
	{
		KillTimer(REFRESH_BANNER_LIST);
		g_pMessengerActor->GetWASActor()->RequestListBanner();
	}
	else if (msg.wParam == NOTICE_LIST_TIMER)
	{
		//m_pMessengerMain->ProcListNotice();
	}
// 	else if (msg.wParam == TIMER_CHECK_RECENT_ROOM_LIST)
// 	{
// 		RemoveChatRoomForTimeout();
// 	}


	CControlUI* pControl = m_PaintManager.FindControl(kOrganization);
    ASSERT(pControl);
    if (pControl)
    {
        if (msg.wParam == TIMER_ORG_REQUEST_ORGGROUP)
        {
            m_PaintManager.KillTimer(pControl, TIMER_ORG_REQUEST_ORGGROUP);
            if (HasAuth(AUTH_SHOW_ORG_TREE))
            {
                GET_MESSENGER_DLG()->GetWorkGroupController()->RequestORGGroup(ADD_MAINORGGROUP);
            }
        }
        else if(msg.wParam == REFRESH_TICKET_TIMER)
        {

			m_PaintManager.KillTimer(pControl, REFRESH_TICKET_TIMER);

			m_pMessengerMain->ProcRefreshTicket();


			m_PaintManager.SetTimer(pControl, REFRESH_TICKET_TIMER, 10 * 59 * 1000);

        }
    }
}

void MainFrame::RemoveChatRoomForTimeout()
{
	m_pChatListManager->RemoveChatRoomForTimeout();
}

void MainFrame::SetTimer(UINT nTimerID, UINT uElapse)
{
	CControlUI* pControl = m_PaintManager.FindControl(kOrganization);
    ASSERT(pControl);
    if (pControl != NULL)
	{
		m_PaintManager.SetTimer(pControl, nTimerID, uElapse);
	}
}

void MainFrame::OnExit(TNotifyUI& msg)
{
	g_pMessengerActor->GetWASActor()->UnRegisterObserver(this);
	Close();
	wnd->Detach();
}

BOOL MainFrame::IsFocuseOnSearchEdit()
{
	BOOL bFocuse = FALSE;
	CEditUI* searchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kSearchEdit));
	if (searchEdit != NULL && searchEdit->IsFocused())
	{
		bFocuse = TRUE;
	}
	return bFocuse;
}

void MainFrame::SetRequestSearch(CString strSearch, MemberSearchAction eSearchAction)
{
	if (GET_MESSENGER_DLG()->GetWorkGroupController() != NULL)
	{
		GET_MESSENGER_DLG()->GetWorkGroupController()->SetRequestSearch(strSearch, eSearchAction);
	}
}

void MainFrame::CheckCloseProfileWindow()
{
	if ((g_pProfileWnd != NULL) && (g_pProfileWnd->GetParentHwnd() == m_hWnd || (m_pSearchWnd != NULL && m_pSearchWnd->GetHWND() == g_pProfileWnd->GetParentHwnd())))
	{
		g_pProfileWnd->CloseProfileWnd();
	}
}

void MainFrame::ReloadRecentChatRoomList()
{
	m_pChatListManager->ClearChatRoomList();
	m_pChatListManager->AddAllChatRoomList();
}

void MainFrame::ShowNoUserInRecentChatList()
{
	CLabelUI* pDefaultShow = (CLabelUI*)m_PaintManager.FindControl(kNosearchResult);
	if(NULL != pDefaultShow)
	{
		if (IsRecentChatSearchMode())
		{
			pDefaultShow->SetText(LoadStringFromResource(IDS_STRING_NOSEARCH_RESULT));
		}
		else
		{
			pDefaultShow->SetText(LoadStringFromResource(IDS_CHAR_ROOM_DEFAULT_TEXT));
		}
		
		pDefaultShow->Invalidate();
		if (m_pChatListManager->GetCount() == 0)
		{
			pDefaultShow->SetVisible(true);
		}
		else
		{
			pDefaultShow->SetVisible(false);
		}
	}
}

void MainFrame::CloseSearchWnd()
{
    EMENUTAB curSelect = GetCurrentTabSelect();
    switch (curSelect)
    {
    case eRecentChatTab:
        {
			if (m_bSearchRecentChat)
			{
				m_bSearchRecentChat = FALSE;
				ReloadRecentChatRoomList();
				CButtonUI* search_cancel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSearchCancel));
				if (search_cancel != NULL)
				{
					search_cancel->SetVisible(false);
				}
			}
            ShowNoUserInRecentChatList();
            break;
        }
    default:
        {
            //TODO: original code's default
            if (m_pSearchWnd != NULL && m_pSearchWnd->IsEnableClose())
            {
                if (!m_mapSearchUserIDNode.empty())
                {
                    m_mapSearchUserIDNode.clear();
                }

                m_nSearchWndHeight = c_min_main_search_height;
                CButtonUI* search_cancel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSearchCancel));
                if (search_cancel != NULL)
                {
                    search_cancel->SetVisible(false);
                }
                if (g_pProfileWnd != NULL && g_pProfileWnd->GetParentHwnd() == m_pSearchWnd->GetHWND())
                {
                     g_pProfileWnd->CloseProfileWnd();
                }

                if (m_bShowSearchWnd)
                {
                    m_pSearchWnd->Close();
                    m_bShowSearchWnd = FALSE;
                }
            }
        }
        break;
    }

    CEditUI* searchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kSearchEdit));
    CButtonUI* searchLabel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSearchLabel));
    if (searchEdit != NULL && searchLabel != NULL)
    {
        m_strSearchWord = _T("");//msg.pSender->GetText();
        searchEdit->SetText(m_strSearchWord);
        searchEdit->SetVisible(false);
        CTabLayoutUI* pTabControl = static_cast<CTabLayoutUI*>(m_PaintManager.FindControl(kTabControlName));
        if (pTabControl && pTabControl->GetCurSel() == eRecentChatTab)
        {
            searchLabel->SetText(LoadStringFromResource(IDS_STRING_RECENT_CHAT_SEARCH));
        }
        else
        {
            searchLabel->SetText(LoadStringFromResource(IDS_STRING245));
        }
        searchLabel->SetVisible(true);
    }
}

BOOL MainFrame::IsShowMainSearchWnd()
{
	return m_bShowSearchWnd;
}

CSearchWnd * MainFrame::GetMainSearchWnd()
{
	return m_pSearchWnd;
}

void MainFrame::OnSearchUser()
{
    EMENUTAB curSelect = GetCurrentTabSelect();
    switch (curSelect)
    {
    case eRecentChatTab:
        {
            CEditUI* searchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kSearchEdit));
            if (searchEdit != NULL)
            {
                m_bSearchRecentChat = TRUE;
                m_strSearchWord = searchEdit->GetText();
                CString strSearch = m_strSearchWord.Trim(_T("% "));
                m_pChatListManager->ClearChatRoomList();
				m_pChatListManager->AddAllChatRoomList();
                if (strSearch.IsEmpty())
                {
					ShowNoUserInRecentChatList();
                    return;
                }
                else
                {
                    if(!m_pChatListManager->DisplaySearchChatRoomList(strSearch))
                    {
                        ShowNoUserInRecentChatList();
                    }
                }
                CButtonUI* search_cancel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSearchCancel));
                if (search_cancel != NULL)
                {
                    search_cancel->SetVisible(true);
                }
                SetFocus(m_hWnd);

				CButtonUI* searchLabel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSearchLabel));
				if (searchLabel != NULL)
				{
					m_strSearchWord = searchEdit->GetText();
					searchEdit->SetVisible(false);
					searchLabel->SetVisible(true);
				}
            }
            break;
        }
    default:
        {
            CEditUI* searchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kSearchEdit));
            if (searchEdit != NULL)
            {
                m_strSearchWord = searchEdit->GetText();
                CString strSearch = m_strSearchWord.Trim(_T("% "));
                if (strSearch.GetLength() > 1)
                {
                    CRect rcSearchWnd = GetSearchWndRect();
                    if (!m_bShowSearchWnd)
                    {
                        m_pSearchWnd = new CSearchWnd(m_hWnd, rcSearchWnd);
                        m_pSearchWnd->Create(m_hWnd, _T("SearchWindow"), WS_CHILD, WS_EX_WINDOWEDGE, rcSearchWnd);
                        m_bShowSearchWnd = TRUE;
                    }

                    CSearchWndList* pFriendsList = m_pSearchWnd->GetFriendsCtrl();
                    if (pFriendsList != NULL)
                    {
                        pFriendsList->RemoveAll();
                    }
                    if (g_pProfileWnd != NULL && g_pProfileWnd->GetParentHwnd() == m_pSearchWnd->GetHWND())
                    {
                         g_pProfileWnd->CloseProfileWnd();
                    }
                    m_pSearchWnd->ShowWindow(false, false);
                    SetRequestSearch(strSearch, ORG_SEARCH);


                    CButtonUI* search_cancel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSearchCancel));
                    if (search_cancel != NULL)
                    {
                        search_cancel->SetVisible(true);
                    }
                    CLabelUI* pSearchResult = static_cast<CLabelUI*>(m_pSearchWnd->GetFriendsCtrl()->paint_manager_.FindControl(kNosearchResult));
                    if (pSearchResult != NULL)
                    {
                        pSearchResult->SetVisible(false);
                    }

                    //CEditUI* searchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kSearchEdit));
                    CButtonUI* searchLabel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSearchLabel));
                    if (searchEdit != NULL && searchLabel != NULL)
                    {
                        m_strSearchWord = searchEdit->GetText();
                        searchEdit->SetVisible(false);
                        searchLabel->SetVisible(true);
                    }
                }
                else
                {
                    NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING169));
                    m_strSearchWord = _T("");
                    searchEdit->SetText(m_strSearchWord);
                    searchEdit->SetVisible(true);
                    searchEdit->SetFocus();
                }
            }
        }
        break;
    }
}

void MainFrame::InitWindow()
{
	
}

DWORD MainFrame::GetBkColor()
{
	CControlUI* background = m_PaintManager.FindControl(kBackgroundControlName);
	if (background != NULL)
		return background->GetBkColor();

	return 0;
}

void MainFrame::AddGroup( const IGTBuddyGroup* pGroup, bool bEditLabel /*= false*/ )
{
	m_favoriteController.AddGroup574(pGroup, bEditLabel);
}


void MainFrame::DeleteBuddy(LPCWSTR strUserId)
{
	CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_PaintManager.FindControl(kFriendsListControlName));

	Node* pNode = m_mapFavUserIDNode[strUserId];

	pFriendsList->RemoveNode(pNode);
}


void MainFrame::AddBuddy(const IGTBuddyUser* pUser )
{
	m_favoriteController.AddBuddy(pUser);
	m_vecAllBuddy.push_back(pUser->GetUserID());
	SetBookmark(pUser->GetUserID(), BOOKMARK_ADD);	
	list<std::wstring> listUserId;
	wstring strBuf(pUser->GetUserID());
	listUserId.push_back(strBuf);
	//CUserImageActor::Instance()->RequestUserImages(listUserId);
}

void MainFrame::SetBkColor(DWORD dwBackColor)
{
	CControlUI* background = m_PaintManager.FindControl(kBackgroundControlName);
	if (background != NULL)
	{
		background->SetBkImage(_T(""));
		background->SetBkColor(dwBackColor);
		background->NeedUpdate();
	}
}

void MainFrame::MakeTreeChildNode(COrganizationTreeUI *pTree, Node* pParentNode, std::multimap<CString, CString> &parentChildMap, std::map<CString, CString> &groupNameMap)
{
	CString strParentNodeID = pParentNode->data().value;
	pair<std::multimap<CString, CString>::iterator, std::multimap<CString, CString>::iterator> iter_pair;
	iter_pair = parentChildMap.equal_range(strParentNodeID);

	CString strGroupID = _T("");
	CString strGroupName = _T("");
	OrganizationListItemInfo item;
	GT_MY_USER_DATA myUserData;
	g_pMessengerActor->GetMyUserInfo(myUserData);
	std::multimap<CString, CString>::iterator iter;
	for (iter = iter_pair.first; iter != iter_pair.second; iter++)
	{
		strGroupID = iter->second;
		if (strGroupID.CompareNoCase(strParentNodeID) == 0)
			continue;

		std::map<CString, CString>::iterator groupNameIter = groupNameMap.find(strGroupID);
		strGroupName = groupNameIter->second;
		item.id = strGroupID;
		item.folder = true;
		item.empty = false;
		item.nick_name = strGroupName;
		Node* pNode = pTree->AddNode(item, pParentNode);
		if (item.nick_name == myUserData.sMyPage.strDeptName)
		{
			m_strMyGroupID = item.id;
		}
		m_mapOrgFileIDNode.insert(std::make_pair(item.id, pNode));
		m_vecOrgList.push_back(item);
		MakeTreeChildNode(pTree, pNode, parentChildMap, groupNameMap);
	}
}

CString MainFrame::GetImageFromStatus( GTUserStatusType eUserStatus, BOOL bCombieMobile,BOOL bVacation)
{
	CString strFileName;

	switch (eUserStatus)
	{
// 	case ustOFFLINE:
// 		strFileName = _T("\\img_main_state_offline.png");
// 		break;		
	case ustOFFLINE | ustMOBILE:
		strFileName = _T("\\img_main_state_mobile.png");
		break;		
	case ustONLINE:
		strFileName = _T("\\img_main_state_online.png");
		break;
	case ustONLINE | ustMOBILE:
		strFileName = _T("\\img_main_state_online.png");
		break;
	case ustAWAY:
	case ustAUTOAWAY:
		strFileName = _T("\\img_main_state_seat.png");
		break;
	case ustAWAY | ustMOBILE:
		strFileName = _T("\\img_main_state_seat.png");
		break;
	case ustAUTOAWAY | ustMOBILE:
		strFileName = _T("\\img_main_state_mobile.png");
		break;
	case ustBUSY:
		strFileName = _T("\\img_main_state_different.png");
		break;
	case ustBUSY | ustMOBILE:
		strFileName = _T("\\img_main_state_different.png");
		break;
	case ustEAT:
		strFileName = _T("\\img_main_state_meal.png");
		break;
	case ustEAT | ustMOBILE:
		strFileName = _T("\\img_main_state_meal.png");
		break;
	case ustMEETING:
		strFileName = _T("\\img_main_state_seat.png");
		break;
	case ustMEETING | ustMOBILE:
		strFileName = _T("\\img_main_state_seat.png");
		break;

	case ustOUTSIDE:
		strFileName = _T("\\img_main_state_office.png");
		break;
	case ustOUTSIDE | ustMOBILE:
		strFileName = _T("\\img_main_state_office.png");
		break;
	case ustOFFLINE: 
		{
			if (GET_CONFIG()->EnableFunction(_T("UI_01")) && bVacation)
			{
				strFileName = _T("\\img_stateME_02.png");
			}
			else
			{
				strFileName = _T("\\img_main_state_offline.png");
			}
			break;
		}
	default:
		strFileName = _T("\\img_main_state_offline.png");
		break;		
	}

	strFileName = GetAppDUIImgDir() + strFileName;

	return strFileName;
}


void MainFrame::LoadSearchMemberImage(LPCWSTR strUserID)
{
	if (m_pSearchWnd != NULL && m_bShowSearchWnd && (::IsWindow(m_pSearchWnd->GetHWND())))
	{
		CDuiString strID = strUserID;
		NE_MEMBER_DATA memberData = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMember(strUserID);
		GTUserStatusType eUserStatus = GET_MESSENGER_DLG()->GetWorkGroupController()->GetMemberStatus(strUserID);
		bool mobile = ( eUserStatus & ustMOBILE );
		Node *pNode = m_mapSearchUserIDNode[strID];
		if (pNode != NULL)
		{
			CSearchWndList* pFriendsList = m_pSearchWnd->GetFriendsCtrl();

			CHorizontalLayoutUI* pMobileOnline = static_cast<CHorizontalLayoutUI*>(pFriendsList->paint_manager_.FindSubControlByName(pNode->data().list_elment_, kOrgMobileOnline));
			if (pMobileOnline != NULL)
			{
				pMobileOnline->SetVisible(false);
			}
			CButtonUI* log_button = static_cast<CButtonUI*>(pFriendsList->paint_manager_.FindSubControlByName(pNode->data().list_elment_, kLogoButtonControlName));
			CLabelUI* nick_name = static_cast<CLabelUI*>(pFriendsList->paint_manager_.FindSubControlByName(pNode->data().list_elment_, kNickNameControlName));
			if (log_button != NULL && nick_name != NULL)
			{
				CDuiString strImage = GetImageFromStatus(eUserStatus,FALSE,!memberData.strWorkStatus.empty());
				log_button->SetNormalImage(strImage);
				log_button->SetHotImage(strImage);
				CString strBuf = _T("");
				strBuf.Format(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_3), memberData.strName.c_str(), GetPresenceTip(eUserStatus), memberData.strEmail.c_str());
				//log_button->SetToolTip(strBuf);
				nick_name->SetToolTip(strBuf);

				if (ustOFFLINE == eUserStatus && GET_CONFIG()->EnableFunction(_T("UI_01")) && !memberData.strWorkStatus.empty())
				{
					CString strVal = memberData.strWorkStatus.c_str();
					strVal.Replace(_T(":"),_T("\n"));
					log_button->SetToolTip(strVal);
				}
				else
				{
					log_button->SetToolTip(strBuf);
				}
			}	
		}
	}
}



void MainFrame::LoadSmsSearchMemberImage(LPCWSTR strUserID)
{
	if ((m_pSmsSearchWnd!=NULL) && (::IsWindow(m_pSmsSearchWnd->GetHWND())))
	{
		CSingleLock chatSearchLock(&m_csChatSearch);
		chatSearchLock.Lock();
		CDuiString strID = strUserID;
		NE_MEMBER_DATA memberData = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMember(strUserID);
		GTUserStatusType eUserStatus = GET_MESSENGER_DLG()->GetWorkGroupController()->GetMemberStatus(strUserID);
		bool mobile = ( eUserStatus & ustMOBILE );
		Node *pNode =m_pSmsSearchWnd->FindNode(m_pSmsSearchWnd->GetRootNode(),strUserID);
		if (pNode != NULL)
		{
			CListUI* pFriendsList = m_pSmsSearchWnd->GetFriendsCtrl();

			CButtonUI* log_button = static_cast<CButtonUI*>(m_pSmsSearchWnd->GetPaintManager()->FindSubControlByName(pNode->data().list_elment_, kSmsPopupSearchItemLogo ));
			CLabelUI* nick_name = static_cast<CLabelUI*>(m_pSmsSearchWnd->GetPaintManager()->FindSubControlByName(pNode->data().list_elment_, kSmsPopupSearchItemName));
			if (log_button != NULL && nick_name != NULL)
			{			
				CString strImage = GetImageFromStatus(eUserStatus);
				//CString strUserID = strID;
				log_button->SetBkImage(strImage);	
				CString strBuf = _T("");
				strBuf.Format(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_3), memberData.strName.c_str(), GetPresenceTip(eUserStatus), memberData.strEmail.c_str());
				log_button->SetToolTip(strBuf);
				nick_name->SetToolTip(strBuf);
			}

			CButtonUI* pBtnAdd = static_cast<CButtonUI*>(m_pSmsSearchWnd->GetPaintManager()->FindSubControlByName(pNode->data().list_elment_, kSmsPopupSearchItemAdd ));
			std::vector<CString> vecLeftListUserID = m_pSmsSearchWnd->GetListUserID();
			bool bFind = false;
			for (size_t i=0; i<vecLeftListUserID.size(); ++i)
			{
				if (vecLeftListUserID[i] == strUserID)
				{
					bFind = true;
					break;
				}
			}
			if (pBtnAdd != NULL)
			{
				
				
			}

		}
		chatSearchLock.Unlock();
	}
}



void MainFrame::LoadChatSearchMemberImage(LPCWSTR strUserID)
{
	if ((m_pChatSearchWnd!=NULL) && (::IsWindow(m_pChatSearchWnd->GetHWND())))
	{
		CSingleLock chatSearchLock(&m_csChatSearch);
		chatSearchLock.Lock();
		CDuiString strID = strUserID;
		NE_MEMBER_DATA memberData = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMember(strUserID);
		GTUserStatusType eUserStatus = GET_MESSENGER_DLG()->GetWorkGroupController()->GetMemberStatus(strUserID);
		bool mobile = ( eUserStatus & ustMOBILE );
		Node *pNode = m_mapChatSearchUserIDNode[strID];
		if (pNode != NULL)
		{
			CChatSearchList* pFriendsList = m_pChatSearchWnd->GetFriendsCtrl();

			CButtonUI* log_button = static_cast<CButtonUI*>(pFriendsList->paint_manager_.FindSubControlByName(pNode->data().list_elment_, kLogoButtonControlName));
			CLabelUI* nick_name = static_cast<CLabelUI*>(pFriendsList->paint_manager_.FindSubControlByName(pNode->data().list_elment_, kNickNameControlName));
			if (log_button != NULL && nick_name != NULL)
			{
				//CDuiString strImage;
				//if ((eUserStatus==ustONLINE) || mobile)
				//{
				//	strImage = GetProfileImagePath(strID);//strImage = _T("img_main_state_online.png");
				//}
				//else
				//{
				//	strImage = GetImageFromStatus(eUserStatus);
				//}

				CString strImage = GetImageFromStatus(eUserStatus,FALSE,!memberData.strWorkStatus.empty());
				//CString strUserID = strID;
				//CUserImageActor::Instance()->GetUserImagePath(strUserID, &strImage);
                log_button->SetBkImage(strImage);	
				CString strBuf = _T("");
				strBuf.Format(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_3), memberData.strName.c_str(), GetPresenceTip(eUserStatus), memberData.strEmail.c_str());
				//log_button->SetToolTip(strBuf);
				nick_name->SetToolTip(strBuf);
				if (ustOFFLINE == eUserStatus && GET_CONFIG()->EnableFunction(_T("UI_01")) && !memberData.strWorkStatus.empty())
				{
					CString strVal = memberData.strWorkStatus.c_str();
					strVal.Replace(_T(":"),_T("\n"));
					log_button->SetToolTip(strVal);
				}
				else
				{
					log_button->SetToolTip(strBuf);
				}
			}
			
			CButtonUI* pBtnAdd = static_cast<CButtonUI*>(pFriendsList->paint_manager_.FindSubControlByName(pNode->data().list_elment_, kChatAddBtn));
			//eUserStatus = (GTUserStatusType)((int)eUserStatus & (~ustMOBILE));
			std::vector<CString> vecLeftListUserID = m_pChatSearchWnd->GetLeftListUserID();
			bool bFind = false;
			for (size_t i=0; i<vecLeftListUserID.size(); ++i)
			{
				if (vecLeftListUserID[i] == strUserID)
				{
					bFind = true;
					break;
				}
			}
			if (pBtnAdd != NULL)
			{
				if (bFind)
				{
					CString strImage = GetAppDUIImgDir() + _T("\\btn_chat_memberadd_in.png");
					pBtnAdd->SetDisabledImage(strImage); 
				}
				else
				{
					CString strImage = GetAppDUIImgDir() + _T("\\btn_chat_memberadd_off.png");
					pBtnAdd->SetDisabledImage(strImage);
				}
				if ( eUserStatus == ustOFFLINE || bFind )
				{
					pBtnAdd->SetEnabled(false);
				}
				else 
				{
					pBtnAdd->SetEnabled(true);
					pBtnAdd->SetToolTip(LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_15));
				}
			}

		}
		chatSearchLock.Unlock();
	}
}

void MainFrame::LoadFavoriteImage(LPCWSTR strUserID)
{
	vector<Node*> vecNodes = m_pBuddyList->GetNodesByUserId(strUserID);
	
	CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_PaintManager.FindControl(kFriendsListControlName));
	for(int nIndex = 0; nIndex < vecNodes.size(); nIndex++)
	{
		Node* pNode = vecNodes[nIndex];
		if (pNode != NULL)
		{
			CLabelUI* log_button = static_cast<CLabelUI*>(pFriendsList->paint_manager_.FindSubControlByName(pNode->data().list_elment_, kLogoButtonControlName));
			if (log_button != NULL)
			{
				CDuiString strImage = GET_APP()->GetProfileImagePath(strUserID);
				log_button->SetBkImage(strImage);
			}	
		}
	}
	
}

void MainFrame::LoadRoomListImage(LPCWSTR strUserID)
{
	CChatRoomList* pFriendsList = static_cast<CChatRoomList*>(m_PaintManager.FindControl(kChattingListControlName));
	if(pFriendsList == NULL)
	{
		return;
	}
	Node* pNodeRoot = pFriendsList->GetRoot();

	Node* pNode = NULL;
	for(int i = 0; i < pNodeRoot->num_children(); i++)
	{
		pNode = pNodeRoot->child(i);
		if(pNode == NULL) 
			break;

		CDuiString nID = pNode->data().value;

		if( nID == strUserID)
		{
			break;
		}
		else
		{
			pNode = NULL;
		}
	}

	if(pNode == NULL) 
	{
		return;
	}

	CButtonUI* log_button = static_cast<CButtonUI*>(pFriendsList->paint_manager_.FindSubControlByName(pNode->data().list_elment_, kLogoButtonControlName));
	CLabelUI* pLabProfile = static_cast<CLabelUI*>(pFriendsList->paint_manager_.FindSubControlByName(pNode->data().list_elment_, _T("profile")));
	if (log_button != NULL && pLabProfile != NULL)
	{
		// Modify by sevin, check group type
		CDuiString strImage = _T("");
		BOOL bGroupChat = (BOOL)pLabProfile->GetTag();
		if (bGroupChat)
		{
			strImage = GetAppDUIImgDir() + _T("\\img_main_chat_list_profile_nopic.png");
		}
		else
		{
			strImage = GET_APP()->GetProfileImagePath(strUserID);
		}
		log_button->SetBkImage(strImage);
	}	
	
}
void MainFrame::LoadOrgMemberImage(LPCWSTR strUserID)
{
	GTUserStatusType eUserStatus = GET_MESSENGER_DLG()->GetWorkGroupController()->GetMemberStatus(strUserID);
	NE_MEMBER_DATA memberData = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMember(strUserID);
	bool mobile = ( eUserStatus & ustMOBILE );
	COrganizationTreeUI* pOrgTreeList = static_cast<COrganizationTreeUI*>(m_PaintManager.FindControl(kOrganization));
	if (pOrgTreeList != NULL)
	{
		CDuiString strID = strUserID;
		multimap<CDuiString, Node*>::iterator iter = m_mapOrgUserIDNode.find(strID);
		int nFindCount = m_mapOrgUserIDNode.count(strID);
		for (int i = 0; i < nFindCount; ++i, ++iter)
		{
			Node *pNode = (*iter).second;
			if (pNode != NULL)
			{
				CButtonUI* log_button = static_cast<CButtonUI*>(pOrgTreeList->paint_manager_.FindSubControlByName(pNode->data().list_elment_, kLogoButtonControlName));
				CLabelUI* nick_name = static_cast<CLabelUI*>(pOrgTreeList->paint_manager_.FindSubControlByName(pNode->data().list_elment_, kNickNameControlName));
				CHorizontalLayoutUI* pMobileOnline = static_cast<CHorizontalLayoutUI*>(pOrgTreeList->paint_manager_.FindSubControlByName(pNode->data().list_elment_, kOrgMobileOnline));
				if (pMobileOnline != NULL)
				{
					pMobileOnline->SetVisible(false);
				}
				if (log_button != NULL && nick_name != NULL)
				{
					CDuiString strImage = GetImageFromStatus(eUserStatus,FALSE,!memberData.strWorkStatus.empty());
					log_button->SetNormalImage(strImage);
					log_button->SetHotImage(strImage);
					CString strBuf = _T("");
					strBuf.Format(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_3), memberData.strName.c_str(), GetPresenceTip(eUserStatus), memberData.strEmail.c_str());
					//log_button->SetToolTip(strBuf);
					nick_name->SetToolTip(strBuf);
					if (ustOFFLINE == eUserStatus && GET_CONFIG()->EnableFunction(_T("UI_01")) && !memberData.strWorkStatus.empty())
					{
						CString strVal = memberData.strWorkStatus.c_str();
						strVal.Replace(_T(":"),_T("\n"));
						log_button->SetToolTip(strVal);
					}
					else
					{
						log_button->SetToolTip(strBuf);
					}

				}
			}
		}
	}
}

void MainFrame::UpdateMemberStatus(LPCWSTR strUserID)
{
	LoadOrgMemberImage(strUserID);
	LoadSearchMemberImage(strUserID);
	LoadChatSearchMemberImage(strUserID);
	LoadSmsSearchMemberImage(strUserID);
}

void MainFrame::ChangeMyStatus(GTUserStatusType eMyStatus)
{
	GT_MY_USER_DATA myUserData;
	g_pMessengerActor->GetMyUserInfo(myUserData);
	GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->UpdateMemberStatus(myUserData.strUserID, eMyStatus);
	UpdateMemberStatus(myUserData.strUserID);
}

void MainFrame::UpdateMemberIPTStatus(LPCWSTR strUserId)
{
	NTIPTStatusType eIPTStatus = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMemberIPTStatus(strUserId);
	
	COrganizationTreeUI* pOrgTreeList = static_cast<COrganizationTreeUI*>(m_PaintManager.FindControl(kOrganization));
	if (pOrgTreeList != NULL)
	{
		CDuiString strID = strUserId;
		multimap<CDuiString, Node*>::iterator iter = m_mapOrgUserIDNode.find(strID);
		int nFindCount = m_mapOrgUserIDNode.count(strID);
		for (int i = 0; i < nFindCount; ++i, ++iter)
		{
			Node *pNode = (*iter).second;
			if (pNode != NULL)
			{
				CButtonUI* btn_ipt = static_cast<CButtonUI*>(pOrgTreeList->paint_manager_.FindSubControlByName(pNode->data().list_elment_, kOrgBtnIPT));
				if (btn_ipt != NULL)
				{
					CDuiString strImage = GET_APP()->GetBuddyIPTPresenceImageFilePath(eIPTStatus);
					if (strImage.GetLength() > 1)
					{
						btn_ipt->SetNormalImage(strImage);
						btn_ipt->SetVisible(true);
						CDuiString strStatus = GetIPTPresenceTip(eIPTStatus);
						btn_ipt->SetToolTip(strStatus.GetData());
					}
					else
					{
						btn_ipt->SetVisible(false);
					}
				}
			}
		}
	}

	if (m_pSearchWnd != NULL && m_bShowSearchWnd && (::IsWindow(m_pSearchWnd->GetHWND())))
	{
		CDuiString strID = strUserId;
		Node *pNode = m_mapSearchUserIDNode[strID];
		if (pNode != NULL)
		{
			CSearchWndList* pFriendsList = m_pSearchWnd->GetFriendsCtrl();
			CButtonUI* btn_ipt = static_cast<CButtonUI*>(pFriendsList->paint_manager_.FindSubControlByName(pNode->data().list_elment_, kOrgBtnIPT));
			if (btn_ipt != NULL)
			{
				CDuiString strImage = GET_APP()->GetBuddyIPTPresenceImageFilePath(eIPTStatus);
				if (strImage.GetLength() > 1)
				{
					btn_ipt->SetNormalImage(strImage);
					btn_ipt->SetVisible(true);
					CDuiString strStatus = GetIPTPresenceTip(eIPTStatus);
					btn_ipt->SetToolTip(strStatus.GetData());
				}
				else
				{
					btn_ipt->SetVisible(false);
				}
			}
		}
	}
}

void MainFrame::UpdateOrganizationMember(const std::vector<ORG_MEMBER_DATA> &memberVector)
{
	g_pMessengerActor->RequestUregFavoriteFromPOI(REGPOIGROUP_ORGCHARTDLG);
	COrganizationTreeUI* pOrgTreeList = static_cast<COrganizationTreeUI*>(m_PaintManager.FindControl(kOrganization));
	OrganizationListItemInfo item;
	list<std::wstring> listUserId;
	for (size_t i = 0; i < memberVector.size(); i++)
	{
		NE_MEMBER_DATA sMemberInfo = memberVector[i].neMemberData;
		item.id = sMemberInfo.strUserId.c_str();
		listUserId.push_back(sMemberInfo.strUserId);
		item.folder = false;
		//item.empty = false;
		item.nick_name = sMemberInfo.strName.c_str();
		GTUserStatusType eStatus = ustOFFLINE;
		if (GET_MESSENGER_DLG()->GetWorkGroupController()->IsMyID(sMemberInfo.strUserId.c_str()))
		{
			eStatus = GetMyStatus();
			item.logo = GetImageFromStatus(eStatus);
			GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->UpdateMemberStatus(sMemberInfo.strUserId.c_str(), eStatus);

		}
		else
		{
			item.logo =  GetImageFromStatus(eStatus,FALSE,!sMemberInfo.strWorkStatus.empty());//_T("img_main_state_offline.png");
		}
		item.description = sMemberInfo.strJobPos.c_str();

		CDuiString strParentID = sMemberInfo.strDeptId.c_str();
		Node *pFileNode = m_mapOrgFileIDNode[strParentID];
		
		if(pFileNode != NULL)
		{
			BOOL bFind = FALSE;
			int nNumChild = pFileNode->num_children();
			for (int j=0; j<nNumChild; ++j)
			{
				Node *pChildNode = pFileNode->child(j);
				if(pChildNode->data().value == item.id)
				{
					bFind = TRUE;
					break;
				}
			}
			if (!bFind)
			{
				Node* pUserNode = pOrgTreeList->AddNode(item, pFileNode);
				m_vecOrgList.push_back(item);
				m_mapOrgUserIDNode.insert(std::make_pair(pUserNode->data().value, pUserNode));

				vector<CString>::iterator it = find(m_vecAllBuddy.begin(), m_vecAllBuddy.end(), item.id.GetData());

				CButtonUI* log_button = static_cast<CButtonUI*>(pOrgTreeList->paint_manager_.FindSubControlByName(pUserNode->data().list_elment_, kLogoButtonControlName));
				CLabelUI* nick_name = static_cast<CLabelUI*>(pOrgTreeList->paint_manager_.FindSubControlByName(pUserNode->data().list_elment_, kNickNameControlName));
				if (log_button != NULL && nick_name != NULL)
				{
					CString strBuf = _T("");
					strBuf.Format(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_3), sMemberInfo.strName.c_str(), GetPresenceTip(eStatus), sMemberInfo.strEmail.c_str());
					//log_button->SetToolTip(strBuf);
					nick_name->SetToolTip(strBuf);
					if (ustOFFLINE == eStatus && GET_CONFIG()->EnableFunction(_T("UI_01")) && !sMemberInfo.strWorkStatus.empty())
					{
						CString strVal = sMemberInfo.strWorkStatus.c_str();
						strVal.Replace(_T(":"),_T("\n"));
						log_button->SetToolTip(strVal);
					}
					else
					{
						log_button->SetToolTip(strBuf);
					}

				}
				CButtonUI* pFavorite = static_cast<CButtonUI*>(pOrgTreeList->paint_manager_.FindSubControlByName(pUserNode->data().list_elment_, kFavorite));
				if ((pFavorite != NULL) && (item.id.CompareNoCase(g_pMessengerActor->GetUserID()) != 0))
				{
					if (it != m_vecAllBuddy.end())
					{
						pFavorite->SetBkImage(FAVORITE_SELECT);
						pFavorite->SetToolTip(LoadStringFromResource(IDS_STRING_ORG_4));
					}
					else
					{
						pFavorite->SetBkImage(FAVORITE_NORMAL);
						pFavorite->SetToolTip(LoadStringFromResource(IDS_STRING_ORG_3));
					}
				}
				
			}	
		}
	}

	std::vector<ORG_MEMBER_DATA>::const_iterator itr = memberVector.begin();
	for(; itr != memberVector.end(); itr++)
	{
		m_vecRequsetStatusUsers.push_back(itr->neMemberData.strUserId);
	}

	if (m_pRequestNode != NULL && m_pRequestNode->parent() != NULL)
	{
		::PostMessage(m_hWnd, MSG_REQUEST_ORGNIZATION_MEMBER, 0, 0);
	}
	else
	{
		if (!m_vecRequsetStatusUsers.empty())
		{
			g_pMessengerActor->RequestRegiFavoriteToPOI(m_vecRequsetStatusUsers, REGPOIGROUP_ORGCHARTDLG);
			m_vecRequsetStatusUsers.clear();
		}
	}
}


void MainFrame::SetCurSmsSearchWnd(CSmsSearchWnd *pSearchWnd){
   
	CSingleLock chatSearchLock(&m_csChatSearch, TRUE);
	m_pSmsSearchWnd = pSearchWnd;
}


void MainFrame::SetCurChatSearchWnd(CChatSearchWnd *pSearchWnd)
{
	CSingleLock chatSearchLock(&m_csChatSearch, TRUE);
	m_pChatSearchWnd = pSearchWnd;
	if (!m_mapChatSearchUserIDNode.empty())
	{
		m_mapChatSearchUserIDNode.clear();
	}
}

void MainFrame::UpdateSearchWndMember(const std::vector<ORG_MEMBER_DATA> &memberVector, MemberSearchAction action)
{
	g_pMessengerActor->RequestUregFavoriteFromPOI(REGPOIGROUP_ORGCHARTDLG);
	if (memberVector.size() > 1)
	{
		qsort_s((void*)&(memberVector.at(0)), memberVector.size(), sizeof(ORG_MEMBER_DATA), CAddChatWnd::MemberDataItemComareFunc, this);	
	}

	vector<wstring> vecUsers;
	if (action == ORG_SEARCH)
	{
		if (m_pSearchWnd != NULL)
		{
			CSearchWndList* pFriendsList = m_pSearchWnd->GetFriendsCtrl();
			if (pFriendsList != NULL)
			{
				m_nSearchWndHeight = c_min_main_search_height;
				if (!m_pSearchWnd->m_vecfriend.empty())
				{
					m_pSearchWnd->m_vecfriend.clear();
				}
				if (pFriendsList->GetCount() > 0)
				{
					pFriendsList->RemoveAll();
				}
				if (!m_mapSearchUserIDNode.empty())
				{
					m_mapSearchUserIDNode.clear();
				}

				SearchWndItemInfo item;
				list<wstring> listUserIds;
				for (size_t i = 0; i < memberVector.size(); i++)
				{
					NE_MEMBER_DATA sMemberInfo = memberVector[i].neMemberData;
					item.id = sMemberInfo.strUserId.c_str();
					vecUsers.push_back(sMemberInfo.strUserId);
					listUserIds.push_back(sMemberInfo.strUserId);
					item.folder = false;
					//item.empty = false;
					item.nick_name = sMemberInfo.strName.c_str();
					//WSTRING wstrDes = sMemberInfo.strJobPos + _T(" | ") + sMemberInfo.strDept;
					CString strDes = sMemberInfo.strJobPos.c_str();
					if (strDes.GetLength() > 1)
					{
						strDes += _T(" | ");
					}
					strDes += sMemberInfo.strDept.c_str();
					item.description = strDes;
					GTUserStatusType status = ustOFFLINE;
					if (GET_MESSENGER_DLG()->GetWorkGroupController()->IsMyID(sMemberInfo.strUserId.c_str()))
					{
						status = GetMyStatus();
						item.logo = GetImageFromStatus(status);
						GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->UpdateMemberStatus(sMemberInfo.strUserId.c_str(), status);
					}
					else
					{
						//item.logo =  _T("img_main_state_offline.png");
						item.logo = GetImageFromStatus(status,FALSE,!sMemberInfo.strWorkStatus.empty());
					}
					int nTopPadding = 0;
					if (i == 0)
					{
						nTopPadding = 4;
					}
					Node* pUserNode = pFriendsList->AddNode(item, NULL, nTopPadding);
					m_pSearchWnd->m_vecfriend.push_back(item);
					m_mapSearchUserIDNode.insert(std::make_pair(pUserNode->data().value, pUserNode));

					vector<CString>::iterator it = find(m_vecAllBuddy.begin(), m_vecAllBuddy.end(), item.id.GetData());
					CButtonUI* log_button = static_cast<CButtonUI*>(pFriendsList->paint_manager_.FindSubControlByName(pUserNode->data().list_elment_, kLogoButtonControlName));
					CLabelUI* nickname = static_cast<CLabelUI*>(pFriendsList->paint_manager_.FindSubControlByName(pUserNode->data().list_elment_, kNickNameControlName));
					if (log_button != NULL && nickname != NULL)
					{
						CString strBuf = _T("");
						strBuf.Format(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_3), sMemberInfo.strName.c_str(), GetPresenceTip(status), sMemberInfo.strEmail.c_str());
						if (ustOFFLINE == status && GET_CONFIG()->EnableFunction(_T("UI_01")) && !sMemberInfo.strWorkStatus.empty())
						{
							CString strVal = sMemberInfo.strWorkStatus.c_str();
							strVal.Replace(_T(":"),_T("\n"));
							log_button->SetToolTip(strVal);
						}
						else
						{
							log_button->SetToolTip(strBuf);
						}
						
						nickname->SetToolTip(strBuf);
					}
					CButtonUI* pFavorite = static_cast<CButtonUI*>(pFriendsList->paint_manager_.FindSubControlByName(pUserNode->data().list_elment_, kFavorite));
					if ((pFavorite != NULL) && (item.id.CompareNoCase(g_pMessengerActor->GetUserID()) != 0))
					{
						if (it != m_vecAllBuddy.end())
						{
							pFavorite->SetBkImage(FAVORITE_SELECT);
							pFavorite->SetToolTip(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_5));
						}
						else
						{
							pFavorite->SetBkImage(FAVORITE_NORMAL);
							pFavorite->SetToolTip(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_4));
						}
					}

					if (i > 0 && i < 11)
					{
						m_nSearchWndHeight += 29;
					}
				}
				m_nSearchWndHeight = min(m_nSearchWndHeight, 300);
				m_nSearchWndHeight = max(m_nSearchWndHeight, c_min_main_search_height); 
				CRect rcSearchWnd = GetSearchWndRect();
				m_pSearchWnd->SetClientRect(rcSearchWnd);
				m_pSearchWnd->ShowWindow(true, true);
				//SetFocus(m_pSearchWnd->GetHWND());

				CLabelUI* pSearchResult = static_cast<CLabelUI*>(pFriendsList->paint_manager_.FindControl(kNosearchResult));
				if (pSearchResult != NULL)
				{
					pSearchResult->SetText(LoadStringFromResource(IDS_STRING_NOSEARCH_RESULT));
					if (memberVector.size() == 0)
					{
						pSearchResult->SetVisible(true); 
					}
				}
				//CUserImageActor::Instance()->RequestUserImages(listUserIds);
			}
		}
	}
	else if (SEND_SMS_SEARCH == action)
	{
		if (m_pSmsSearchWnd != NULL && ::IsWindow(m_pSmsSearchWnd->GetHWND())){
			m_pSmsSearchWnd->UpdateSearchWndMember(memberVector);
		}
	}
	else if(action == CHAT_ORG_SEARCH)
	{
		if (m_pChatSearchWnd != NULL && ::IsWindow(m_pChatSearchWnd->GetHWND()))
		{
			CSingleLock chatSearchLock(&m_csChatSearch);
			chatSearchLock.Lock();
			CChatSearchList* pFriendsList = m_pChatSearchWnd->GetFriendsCtrl();
			if (pFriendsList != NULL)
			{
				if (!m_pChatSearchWnd->m_vecfriend.empty())
				{
					m_pChatSearchWnd->m_vecfriend.clear();
				}
				if (pFriendsList->GetCount() > 0)
				{
					pFriendsList->RemoveAll();
				}
				if (!m_mapChatSearchUserIDNode.empty())
				{
					m_mapChatSearchUserIDNode.clear();
				}

				ChatSearchItemInfo item;
				list<wstring> listUserIds;
				int nChatSearchWndHeight = 10;
				for (size_t i = 0; i < memberVector.size(); i++)
				{
					NE_MEMBER_DATA sMemberInfo = memberVector[i].neMemberData;
					item.id = sMemberInfo.strUserId.c_str();
					vecUsers.push_back(sMemberInfo.strUserId);
					listUserIds.push_back(sMemberInfo.strUserId);
					item.folder = false;
					//item.empty = false;
					item.nick_name = sMemberInfo.strName.c_str();
					GTUserStatusType status = ustOFFLINE;
					if (GET_MESSENGER_DLG()->GetWorkGroupController()->IsMyID(sMemberInfo.strUserId.c_str()))
					{
						status = GetMyStatus();
						GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->UpdateMemberStatus(sMemberInfo.strUserId.c_str(), status);
					}

					GTUserStatusType eUserStatus = GET_MESSENGER_DLG()->GetWorkGroupController()->GetMemberStatus(sMemberInfo.strUserId.c_str());
					

					CString strImage = _T("");
				//	CUserImageActor::Instance()->GetUserImagePath(sMemberInfo.strUserId.c_str(), &strImage);
					strImage = GetImageFromStatus(eUserStatus,FALSE,!sMemberInfo.strWorkStatus.empty());
					item.logo = strImage;
					Node* pUserNode = NULL;
					if (i == 0)
					{
						pUserNode = pFriendsList->AddNode(item, NULL, NULL, 6);
					}
					else
					{
						pUserNode = pFriendsList->AddNode(item, NULL);
					}

					CButtonUI* pBtnAdd = static_cast<CButtonUI*>(pFriendsList->paint_manager_.FindSubControlByName(pUserNode->data().list_elment_, kChatAddBtn));
					if (pBtnAdd && eUserStatus == ustOFFLINE)
					{
						pBtnAdd->SetEnabled(false);
					}
					else if(pBtnAdd)
					{
						pBtnAdd->SetEnabled(true);
					}
					CButtonUI* log_button = static_cast<CButtonUI*>(pFriendsList->paint_manager_.FindSubControlByName(pUserNode->data().list_elment_, kLogoButtonControlName));
					CLabelUI* nick_name = static_cast<CLabelUI*>(pFriendsList->paint_manager_.FindSubControlByName(pUserNode->data().list_elment_, kNickNameControlName));
					if (log_button != NULL && nick_name != NULL)
					{
						CString strBuf = _T("");
						strBuf.Format(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_3), sMemberInfo.strName.c_str(), GetPresenceTip(status), sMemberInfo.strEmail.c_str());
						//log_button->SetToolTip(strBuf);
						nick_name->SetToolTip(strBuf);
						if (ustOFFLINE == status && GET_CONFIG()->EnableFunction(_T("UI_01")) && !sMemberInfo.strWorkStatus.empty())
						{
							CString strVal = sMemberInfo.strWorkStatus.c_str();
							strVal.Replace(_T(":"),_T("\n"));
							log_button->SetToolTip(strVal);
						}
						else
						{
							log_button->SetToolTip(strBuf);
						}
					}

					m_pChatSearchWnd->m_vecfriend.push_back(item);
					m_mapChatSearchUserIDNode.insert(std::make_pair(pUserNode->data().value, pUserNode));
			
					nChatSearchWndHeight += 28;
				}

				nChatSearchWndHeight = min(nChatSearchWndHeight, 292);
				nChatSearchWndHeight = max(nChatSearchWndHeight, 40);
				m_pChatSearchWnd->SetChatSearchHeight(nChatSearchWndHeight, TRUE);
				m_pChatSearchWnd->ShowWindow(true, true);
				SetFocus(m_pChatSearchWnd->GetHWND());

				CLabelUI* pSearchResult = static_cast<CLabelUI*>(pFriendsList->paint_manager_.FindControl(kNosearchResult));
				if (pSearchResult != NULL)
				{
					pSearchResult->SetText(LoadStringFromResource(IDS_STRING_NOSEARCH_RESULT));
					if (memberVector.size() == 0)
					{
						pSearchResult->SetVisible(true); 
					}
				}
				chatSearchLock.Unlock();
				//CUserImageActor::Instance()->RequestUserImages(listUserIds);
			}
		}
	}
	g_pMessengerActor->RequestRegiFavoriteToPOI(vecUsers, REGPOIGROUP_ORGCHARTDLG);
}

void MainFrame::UpdateItemImage(LPCTSTR strID)
{
	CTabLayoutUI* pTabControl = static_cast<CTabLayoutUI*>(m_PaintManager.FindControl(kTabControlName));
	if (pTabControl != NULL)
	{

		//if (pTabControl->GetCurSel() == eOrganizationTab)
		//{
			//LoadOrgMemberImage(strID);
	//	}
	//	else if (pTabControl->GetCurSel() == eFavoriteTab)
	//	{
			LoadRoomListImage(strID);
			LoadFavoriteImage(strID);

	//	}
	}

	GT_MY_USER_DATA myUserData;
	g_pMessengerActor->GetMyUserInfo(myUserData);

	CString str = strID;

	if( str == myUserData.strUserID )
	{
		CButtonUI* pHead = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btnInfoMe")));
		CDuiString strImage = GET_APP()->GetProfileImagePath(strID);
        
		pHead->SetBkImage(strImage);
	}

	//LoadSearchMemberImage(strID);
	//LoadChatSearchMemberImage(strID);
		
}

void MainFrame::UpdateOrganizationList(const std::vector<GT_ORG_GROUP_DATA>& list)
{
	GT_MY_USER_DATA myUserData;
	g_pMessengerActor->GetMyUserInfo(myUserData);
	COrganizationTreeUI* pOrgTreeList = static_cast<COrganizationTreeUI*>(m_PaintManager.FindControl(kOrganization));
	if (pOrgTreeList != NULL && m_mapOrgFileIDNode.size() != list.size())
	{
		if (!m_vecOrgList.empty())
			m_vecOrgList.clear();
		if (pOrgTreeList->GetCount() > 0)
			pOrgTreeList->RemoveAll();
		if (!m_mapOrgFileIDNode.empty())
		{
			m_mapOrgFileIDNode.clear();
		}
		if (!m_mapOrgUserIDNode.empty())
		{
			m_mapOrgUserIDNode.clear();
		}

		OrganizationListItemInfo item;
		std::multimap<CString, CString> parentChildMap;
		std::map<CString, CString> groupNameMap;
		Node* pRootNode = NULL;

		for (size_t i = 0; i < list.size(); i++)
		{
			const GT_ORG_GROUP_DATA &sGroupInfo = list[i];
			if (sGroupInfo.strParentGroupID == _T("") || sGroupInfo.strGroupID == sGroupInfo.strParentGroupID)
			{
				item.id = sGroupInfo.strGroupID.c_str();
				item.folder = true;
				item.empty = false;
				item.nick_name = sGroupInfo.strGroupName.c_str();

				pRootNode = pOrgTreeList->AddNode(item, NULL, 4);
				CButtonUI* pBtnPopup = static_cast<CButtonUI*>(pOrgTreeList->paint_manager_.FindSubControlByName(pRootNode->data().list_elment_, kOrgBtnPopup));

				if (pBtnPopup != NULL)
				{
					pBtnPopup->SetVisible(true);
					pBtnPopup->SetToolTip(LoadStringFromResource(IDS_STRING_ORG_2));
				}
				if (item.nick_name == myUserData.sMyPage.strDeptName)
				{
					m_strMyGroupID = item.id;
				}
				m_mapOrgFileIDNode.insert(std::make_pair(item.id, pRootNode));
				m_vecOrgList.push_back(item);
				continue;
			}

			parentChildMap.insert(std::make_pair(sGroupInfo.strParentGroupID.c_str(), sGroupInfo.strGroupID.c_str()));
			groupNameMap.insert(std::make_pair(sGroupInfo.strGroupID.c_str(), sGroupInfo.strGroupName.c_str()));
		}
		if (pRootNode)
		{
			MakeTreeChildNode(pOrgTreeList, pRootNode, parentChildMap, groupNameMap);
		}
		
		Node *pFileNode = m_mapOrgFileIDNode[m_strMyGroupID];
		if (pFileNode != NULL)
		{
			Node *pNode = pFileNode;
			int nLevel = pNode->data().level_;
			for (int i=0; i<=nLevel; ++i)
			{
				pOrgTreeList->ExpandNode(pNode, true);
				pNode = pNode->parent();
			}

			m_pRequestNode = pFileNode;
			if (m_pRequestNode->parent() != NULL)
			{
				CString strParentID = m_pRequestNode->parent()->data().value;
				CString strID = m_pRequestNode->data().value;
				GET_MESSENGER_DLG()->GetWorkGroupController()->RequestORGGroupMemberList(strParentID, strID,  UPDATE_VIEW_ORG);
			}
		}
	}
}


void MainFrame::UpdateInfoAboutIPTStatus()
{
	/*if (!m_wndInfoAboutMe.GetSafeHwnd())
		return;*/

	NTIPTStatusType iptStatus = g_pMessengerActor->GetMyIptStatus();
	if(GET_MESSENGER_DLG()->GetForwardingStatus())
		iptStatus = iptstFWD;
	if (iptStatus == iptstDND)
		GET_MESSENGER_DLG()->SetDND(1);

	BOOL bIPT = GET_APP()->IsAvailableIPT();

	TCHAR szBuf[MAX_PATH] = {0};
	CButtonUI* pBtnIpt =  static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("iptStatusBtn")));
	if(pBtnIpt != NULL)
	{
		if(bIPT == TRUE)
		{
			pBtnIpt->SetVisible(true);
			CDuiString strStatus = GetIPTPresenceTip(iptStatus);
			pBtnIpt->SetToolTip(strStatus.GetData());
			CString imgPath = GET_APP()->GetMyIPTPresenceImageFilePath(iptStatus);
			pBtnIpt->SetBkImage(imgPath);
			if(imgPath.IsEmpty())
				pBtnIpt->SetVisible(false);
		}
		else
		{
			pBtnIpt->SetVisible(false);
		}
	}
}

BOOL MainFrame::MakeAboutIPTSatusPopupMenu( CMenu* pMenu )
{
	CMenuXP* pXpMenu = dynamic_cast<CMenuXP*>(pMenu);
	ASSERT(pXpMenu);
	if (pXpMenu)
	{
		pXpMenu->CreatePopupMenu();
        XpMenuFacadeInit(pXpMenu);

		CString strRes;
		strRes = LoadStringFromResource(IDS_STRING671);
		pXpMenu->AppendODMenu(0, new CMenuXPText(1, strRes, AfxGetApp()->LoadIcon(IDI_ICON_IPT_IDLE)));
		strRes = LoadStringFromResource(IDS_STRING672);
		pXpMenu->AppendODMenu(0, new CMenuXPText(2, strRes, AfxGetApp()->LoadIcon(IDI_ICON_IPT_DND)));
		strRes = LoadStringFromResource(IDS_STRING673);
		pXpMenu->AppendODMenu(0, new CMenuXPText(3, strRes, AfxGetApp()->LoadIcon(IDI_ICON_IPT_FWD)));
		strRes = LoadStringFromResource(IDS_STRING674);
		pXpMenu->AppendODMenu(0, new CMenuXPText(4, strRes, AfxGetApp()->LoadIcon(IDI_ICON_IPT_PAUSE)));
	}

	return TRUE;
}

void MainFrame::LoadAboutIPTStatusPopup( CPoint pt )
{
	CMenuXP* pMenu = new CMenuXP;
	if (!pMenu)
		return;

	MakeAboutIPTSatusPopupMenu(pMenu);

	int nCmdID = pMenu->TrackPopupMenu(TPM_LEFTBUTTON | TPM_RETURNCMD | TPM_RIGHTBUTTON, pt.x, pt.y, this->wnd);

	delete pMenu;
	if (1 == nCmdID)
	{
		if (GET_MESSENGER_DLG()->GetDND())
		{
			GET_MESSENGER_DLG()->SetDND();
		}

		if (GET_MESSENGER_DLG()->GetForwardingStatus())
			g_pMessengerActor->RequestCallForwarding( g_pMessengerActor->GetUserID(), 0, _T("") );


	}
	else if (2 == nCmdID)
	{
		if (!GET_MESSENGER_DLG()->GetDND())
		{
			GET_MESSENGER_DLG()->SetDND();
		}
		else
			g_pMessengerActor->RequestSetDND( g_pMessengerActor->GetUserID(), 1);

	}
	else if(3 == nCmdID)
	{
		if(!GET_MESSENGER_DLG()->GetForwardingStatus())
		{
			GET_MESSENGER_DLG()->OnTopMenuForwarding();
		}
	}
	else if (4 == nCmdID)
	{
		GET_MESSENGER_DLG()->OnTopMenuHoldCall();
	}
}




static bool OnStatusButtonEvent(void* event) {
	TEventUI *pEvent = (TEventUI*)event;
	if( ((TEventUI*)event)->Type == UIEVENT_BUTTONDOWN ) {
		CControlUI* pButton = ((TEventUI*)event)->pSender;		
		CPaintManagerUI* pm = pButton->GetManager();
		CTextUI* pStatusText = static_cast<CTextUI*>(pm->FindControl(_T("status")));

		if(NULL != pStatusText)
		{
			CDuiRect rcWindow;
			GetWindowRect(pm->GetPaintWindow(), &rcWindow);
			CPoint pt(0, 0);
			pt.y = rcWindow.top + pStatusText->GetPos().bottom;
			pt.x = rcWindow.left + pStatusText->GetPos().left;
			GET_MESSENGER_DLG()->GetMainFrame()->LoadAboutMeStatusPopup(pt);
		}
		
	}
	else if( ((TEventUI*)event)->Type == UIEVENT_MOUSEENTER){
		SetCursor(AfxGetApp()->LoadStandardCursor(IDC_HAND));
	}
	else if( ((TEventUI*)event)->Type == UIEVENT_MOUSELEAVE){
		SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
	}
	else if( ((TEventUI*)event)->Type == UIEVENT_MOUSEHOVER){
		SetCursor(AfxGetApp()->LoadStandardCursor(IDC_HAND));
	}
	else if( ((TEventUI*)event)->Type == UIEVENT_MOUSEMOVE){
		SetCursor(AfxGetApp()->LoadStandardCursor(IDC_HAND));
	}
	return true;
}


void MainFrame::OnPrepare(TNotifyUI& msg)
{
	wnd = CWnd::FromHandle(m_hWnd);
	m_InfoBannerCtrller.SetAttachWnd(this);
	m_DropTarget.Register(GetCWnd());
	
	CControlUI* background = m_PaintManager.FindControl(kBackgroundControlName);
	if (background != NULL)
	{
		TCHAR szBuf[MAX_PATH] = {0};
		_stprintf_s(szBuf, MAX_PATH - 1, _T("file='bg%d.png' corner='600,200,1,1'"), bk_image_index_);
	}

	CHorizontalLayoutUI* tabbar = static_cast<CHorizontalLayoutUI*>(m_PaintManager.FindControl(_T("tabbar")));
	CVerticalLayoutUI* pVetticalLayout = static_cast<CVerticalLayoutUI*>(m_dlgBuilder.Create(_T("tabbar.xml"), (UINT)0, NULL, &m_PaintManager));
	tabbar->Add(pVetticalLayout);


	CVerticalLayoutUI* vlActiveMenu = static_cast<CVerticalLayoutUI*>(m_PaintManager.FindControl(_T("ActiveMenu")));
	m_mainMenuControler.SetLayout(vlActiveMenu);
	m_mainMenuControler.InitFixedMenus();
	m_mainMenuControler.LoadActiveMenus();
	
	CTextUI* pNameText =  static_cast<CTextUI*>(m_PaintManager.FindControl(_T("status")));
	int fontIndex = pNameText->GetFont();
	HFONT hfont = m_PaintManager.GetFont(fontIndex);
	TFontInfo* pfontInfo = m_PaintManager.GetFontInfo(hfont);
	RECT rcPaddingName = {0, (28-pfontInfo->tm.tmHeight)/2};
	pNameText->SetPadding(rcPaddingName);



	if( g_stNtalkInfo.strCorp == _T("hanatour") )
	{
		m_bEnableBanner = TRUE;
		m_bEnableNotice = TRUE;

		// delete old log files
		CString logPath =  GetAppDataNtalkDir() + _T("\\log");
		DeleteDirectory(logPath);
		CreateDirectory(logPath, NULL);
	}

	CVerticalLayoutUI* pBanner = static_cast<CVerticalLayoutUI*>(m_PaintManager.FindControl(_T("bannerInfo")));
	if (pBanner){		
		if( !m_bEnableBanner )
		{		
			pBanner->SetVisible(false);			
		}

	}
	InitMyProfile();

	CTextUI* pStatusText = static_cast<CTextUI*>(m_PaintManager.FindControl(_T("status")));

	 pStatusText->OnEvent += MakeDelegate(&OnStatusButtonEvent);
	//UpdateFriendsList();

	//InitFavoriteList();

	CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_PaintManager.FindControl(kFriendsListControlName));

	CButtonUI* searchLabel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSearchLabel));
	if (searchLabel != NULL)
	{
		m_strSearchWord = _T("");
		searchLabel->SetText(LoadStringFromResource(IDS_STRING245));
	}

	SetUserAuth();
	GT_MY_USER_DATA myUserData;
	g_pMessengerActor->GetMyUserInfo(myUserData);

	size_t nBuddyCount = g_pMessengerActor->GetBuddyCount();
	for (unsigned int index = 0; index < nBuddyCount; index++)
	{
		const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfoFromIndex(index);
		m_vecAllBuddy.push_back(pUser->GetUserID());	
	}

	LoadTooltip();
/*
    CRect rc_cli(0, 0, 0, 0);
	GetWindowRect(m_hWnd,&rc_cli);
	int ww = rc_cli.Width();
	CRect rcWnd(1,70,  ww-2,   100);
	if (m_pBannerNotice == NULL)
	{
		m_pBannerNotice = new CBannerNoticeWnd();
		m_pBannerNotice->Create(m_hWnd, _T(""), WS_CHILD, WS_EX_TOOLWINDOW | WS_EX_TOPMOST , rcWnd);
	}
	m_pBannerNotice->SetClientRect(rcWnd);
	m_pBannerNotice->ShowWindow(true,false);*/
    SetAllTimer();
}
void MainFrame::LoadTooltip()
{
	SetToolTip(_T("status"),LoadStringFromResource(IDS_STRING_MAIN_TOOLTIP_5));
	SetToolTip(_T("btnStatus"),LoadStringFromResource(IDS_STRING_MAIN_TOOLTIP_5));
	SetToolTip(_T("iptStatusBtn"),LoadStringFromResource(IDS_STRING_MAIN_TOOLTIP_6));
	SetToolTip(_T("minbtn"),LoadStringFromResource(IDS_STRING_MAIN_TOOLTIP_1));
	SetToolTip(_T("maxbtn"),LoadStringFromResource(IDS_STRING_MAIN_TOOLTIP_2));
	SetToolTip(_T("restorebtn"),LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_6_1));
	SetToolTip(_T("closebtn"),LoadStringFromResource(IDS_STRING_MAIN_TOOLTIP_3));
	SetToolTip(_T("menubtn"),LoadStringFromResource(IDS_STRING_MAIN_TOOLTIP_4));

	SetToolTip(_T("tab_organization"),LoadStringFromResource(IDS_STRING_MAIN_TOOLTIP_7));
	SetToolTip(_T("tab_bookmark"),LoadStringFromResource(IDS_STRING_MAIN_TOOLTIP_8));
	SetToolTip(_T("tab_chatlist"),LoadStringFromResource(IDS_STRING_MAIN_TOOLTIP_9));
	SetToolTip(_T("search_btn"),LoadStringFromResource(IDS_STRING_MAIN_TOOLTIP_17));
}

void MainFrame::KillAllTimer()
{
    CControlUI* pControl = m_PaintManager.FindControl(kOrganization);
    if (pControl)
    {
        m_PaintManager.KillTimer(pControl); //, REFRESH_TICKET_TIMER);
    }
}

void MainFrame::SetAllTimer()
{
    CControlUI* pControl = m_PaintManager.FindControl(kOrganization);
    if (pControl)
    {
        m_PaintManager.SetTimer(pControl, REFRESH_TICKET_TIMER, 10 * 1000); //, NULL
    }
	/*if( m_bEnableNotice )
		SetTimer(NOTICE_LIST_TIMER, 10 * 60 * 1000);*/
    SetTimer(LEGACY_COUNT_TIMER, 5 * 60 * 1000);
	if( m_bEnableBanner )
		SetTimer(REFRESH_BANNER_LIST, 2000);


	SetTimer(UPDATE_USER_IMAGE, 10000);
	//SetTimer(TIMER_CHECK_RECENT_ROOM_LIST, TIMER_RECENT_LIST);
}

vector<CString> MainFrame::GetBookmarkVector()
{
	return m_vecAllBuddy;
}

void MainFrame::InitMyProfile(void)
{
	GT_MY_USER_DATA myUserData;
	g_pMessengerActor->GetMyUserInfo(myUserData);

	CString strMsg = (_T(""));

	//m_wndInfoAboutMe.SetAboutMeStatus(myUserData.eUserStatusType);

	strMsg.Format(_T("%s"), myUserData.sMyPage.strUserName);
	CTextUI* pNameText =  static_cast<CTextUI*>(m_PaintManager.FindControl(_T("status")));
	pNameText->SetText(strMsg);
	//m_wndInfoAboutMe.SetName(strMsg);

	strMsg.Format(_T("%s"), myUserData.sMyPage.strTalkName);
	CEditUI* pEditSign =  static_cast<CEditUI*>(m_PaintManager.FindControl(kMainFrameSignture));
	pEditSign->SetMaxChar(20);
	pEditSign->SetText(strMsg);

	GET_CONFIG()->SetNickName(myUserData.sMyPage.strTalkName);

	//ipt 574

	NTIPTStatusType iptStatus = g_pMessengerActor->GetMyIptStatus();
	if(GET_MESSENGER_DLG()->GetForwardingStatus())
		iptStatus = iptstFWD;
	if (iptStatus == iptstDND)
		GET_MESSENGER_DLG()->SetDND(1);

	CButtonUI* pBtnIpt =  static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("iptStatusBtn")));

	BOOL bIPT = GET_APP()->IsAvailableIPT();

	if(NULL != pBtnIpt)
	{
		if(TRUE == bIPT)
		{		
			CDuiString strStatus = GetIPTPresenceTip(iptStatus);
			pBtnIpt->SetToolTip(strStatus.GetData());
			pBtnIpt->SetVisible(true);
			CString imgPath = GET_APP()->GetMyIPTPresenceImageFilePath(iptStatus);
			pBtnIpt->SetBkImage(imgPath);
			if(imgPath.IsEmpty())
				pBtnIpt->SetVisible(false);
		}
		else
		{
			pBtnIpt->SetVisible(false);
		}
	}
}
void MainFrame::SetToolTip(LPCTSTR lpszCtrlName,LPCTSTR lpszVal)
{
	CControlUI* p = m_PaintManager.FindControl(lpszCtrlName);
	if (p)
	{
		p->SetToolTip(lpszVal);
	}
}

CImageList* MainFrame::CreateDragGroupImageEx(){

	std::vector<const IGTBuddyGroup*> selectGroup;
	m_favoriteController.GetSelectedGroupItems(selectGroup);
	CRect		rectTextArea(0, 0, 0, 0); 
	int			nNumSelected = selectGroup.size(); 
	CClientDC	DraggedNodeDC(wnd); 
	CString		strItemText;
	CBitmap		*pBitmapOldMemDCBitmap = NULL; 		
	CImageList	*pImageListDraggedNode = NULL; 

	if( nNumSelected > 0)
	{
		CDC 		MemoryDC; 	
		if(!MemoryDC.CreateCompatibleDC(&DraggedNodeDC))
			return NULL;
		CBitmap		DraggedNodeBmp; 
		if(!DraggedNodeBmp.CreateCompatibleBitmap(&DraggedNodeDC, 200, 30 * nNumSelected))
			return NULL;
		pBitmapOldMemDCBitmap = MemoryDC.SelectObject( &DraggedNodeBmp );

		MemoryDC.SetBkColor(RGB(255,255,255));
		MemoryDC.SetBkMode(TRANSPARENT);
		MemoryDC.SetTextColor(RGB(34,34,34));

		for( int nIndex = 0; nIndex < nNumSelected; nIndex++)
		{
			const IGTBuddyGroup* pUser = selectGroup[nIndex];
			strItemText = pUser->GetName();
			CRect rcBK(0, 0, 0, 0);
			rcBK.SetRect(0,nIndex * 30,200, nIndex * 30 + 30);
			MemoryDC.FillSolidRect(rcBK,RGB(255,255,255));
			HFONT hOldFont = (HFONT)MemoryDC.SelectObject(g_ftDefault13PXB);
			rcBK.left += 20;
			MemoryDC.DrawText(strItemText, &rcBK, DT_LEFT| DT_SINGLELINE|DT_NOPREFIX);
		}

		MemoryDC.SelectObject( pBitmapOldMemDCBitmap );
		MemoryDC.DeleteDC();
		pImageListDraggedNode = new CImageList;
		pImageListDraggedNode->Create(200, 30 * nNumSelected, 
			ILC_COLOR32 | ILC_MASK, 0, 1);

		pImageListDraggedNode->Add(&DraggedNodeBmp, RGB(255, 255,255)); 
		return pImageListDraggedNode;
	}
	return NULL;
}

CImageList* MainFrame::CreateDragImageEx(vector<CString> vecSelectedName)
{
/*
	std::vector<const IGTBuddyUser*> selectUser;

	std::vector<Node*> vecSelectedItem = m_favoriteController.GetSelectedItems();
	for (size_t i = 0; i < vecSelectedItem.size(); i++)
	{
		if (vecSelectedItem[i]->folder() && !vecSelectedItem[i]->IsRoot())
		{
			continue;
		}

		const IGTBuddyUser *pUser = (const IGTBuddyUser *)vecSelectedItem[i]->GetNodeUserData();

		if (!IsFindByID_UserVector(selectUser, pUser->GetUserID()))
		{
			selectUser.push_back(pUser);
		}
	}*/

	CRect		rectTextArea(0, 0, 0, 0); 
	int			nNumSelected = vecSelectedName.size(); 
	CClientDC	DraggedNodeDC(wnd); 
	CString		strItemText;
	CBitmap		*pBitmapOldMemDCBitmap = NULL; 		
	CImageList	*pImageListDraggedNode = NULL; 

	if( nNumSelected > 0)
	{
		CDC 		MemoryDC; 	
		if(!MemoryDC.CreateCompatibleDC(&DraggedNodeDC))
			return NULL;
		CBitmap		DraggedNodeBmp; 
		if(!DraggedNodeBmp.CreateCompatibleBitmap(&DraggedNodeDC, 200, 30 * nNumSelected))
			return NULL;
		pBitmapOldMemDCBitmap = MemoryDC.SelectObject( &DraggedNodeBmp );

		MemoryDC.SetBkColor(RGB(255,255,255));
		MemoryDC.SetBkMode(TRANSPARENT);
		MemoryDC.SetTextColor(RGB(34,34,34));

		for( int nIndex = 0; nIndex < nNumSelected; nIndex++)
		{
		/*	const IGTBuddyUser* pUser = selectUser[nIndex];
			strItemText = pUser->GetName();*/
			strItemText = vecSelectedName[nIndex];
			CRect rcBK(0, 0, 0, 0);
			rcBK.SetRect(0,nIndex * 30,200, nIndex * 30 + 30);
			MemoryDC.FillSolidRect(rcBK,RGB(255,255,255));
			HFONT hOldFont = (HFONT)MemoryDC.SelectObject(g_ftDefault13PXB);
			rcBK.left += 20;
			MemoryDC.DrawText(strItemText, &rcBK, DT_LEFT| DT_SINGLELINE|DT_NOPREFIX);
		}

		MemoryDC.SelectObject( pBitmapOldMemDCBitmap );
		MemoryDC.DeleteDC();
		pImageListDraggedNode = new CImageList;
		pImageListDraggedNode->Create(200, 30 * nNumSelected, 
			ILC_COLOR32 | ILC_MASK, 0, 1);

		pImageListDraggedNode->Add(&DraggedNodeBmp, RGB(255, 255,255)); 
		return pImageListDraggedNode;
	}
	return NULL;
}

BOOL MainFrame::SetBookmark(CString strUserID, int nOpType)
{
	COrganizationTreeUI* pOrgTreeList = static_cast<COrganizationTreeUI*>(m_PaintManager.FindControl(kOrganization));
	if (pOrgTreeList != NULL)
	{
		CDuiString strID = strUserID;
		multimap<CDuiString, Node*>::iterator iter = m_mapOrgUserIDNode.find(strID);
		int nFindCount = m_mapOrgUserIDNode.count(strID);
		for (int i = 0; i < nFindCount; ++i, ++iter)
		{
			Node *pNode = (*iter).second;
			if (pNode != NULL)
			{
				CButtonUI* pBtnFavorite = static_cast<CButtonUI*>(pOrgTreeList->paint_manager_.FindSubControlByName(pNode->data().list_elment_, kFavorite));
				if ((pBtnFavorite != NULL) && (strID.CompareNoCase(g_pMessengerActor->GetUserID()) != 0))
				{
					if (nOpType == BOOKMARK_ADD)
					{
						pBtnFavorite->SetBkImage(FAVORITE_SELECT);
						pBtnFavorite->SetToolTip(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_5));
					}
					else
					{
						pBtnFavorite->SetBkImage(FAVORITE_NORMAL);
						pBtnFavorite->SetToolTip(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_4));
					}
				}
			}
		}
	}
	if (m_pSearchWnd != NULL && ::IsWindow(m_pSearchWnd->GetHWND()) && m_bShowSearchWnd)
	{
		CDuiString strID = strUserID;
		CSearchWndList* pSearchWndList = m_pSearchWnd->GetFriendsCtrl();
		Node *pNode = m_mapSearchUserIDNode[strID];
		if (pNode != NULL)
		{
			CButtonUI* pBtnFavorite = static_cast<CButtonUI*>(pSearchWndList->paint_manager_.FindSubControlByName(pNode->data().list_elment_, kFavorite));
			{
				if ((pBtnFavorite != NULL) && (strID.CompareNoCase(g_pMessengerActor->GetUserID()) != 0))
				{
					if (nOpType == BOOKMARK_ADD)
					{
						pBtnFavorite->SetBkImage(FAVORITE_SELECT);
						pBtnFavorite->SetToolTip(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_5));
					}
					else
					{
						pBtnFavorite->SetBkImage(FAVORITE_NORMAL);
						pBtnFavorite->SetToolTip(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_4));
					}
				}
			}
		}
	}
	if (g_pProfileWnd != NULL && ::IsWindow(g_pProfileWnd->GetHWND()))
	{
		g_pProfileWnd->SetBookmark(nOpType);
	}

	return TRUE;
}

NTIPTStatusType MainFrame::GetMemberIPTStatus(LPCWSTR strUserID)
{
	NTIPTStatusType iptStatusType = iptstIDLE;
	const IGTBuddyUser* pBuddyUser = g_pMessengerActor->GetBuddyInfo(strUserID);
	if (pBuddyUser != NULL)
	{
		iptStatusType = pBuddyUser->GetIPTStatus();
		return iptStatusType;
	}
	const IGTBuddyUser* pPeristUser = g_pMessengerActor->GetBuddyInfoFromPersist(strUserID);
	if (pPeristUser != NULL)
	{
		iptStatusType = pPeristUser->GetIPTStatus();
		return iptStatusType;
	}
	iptStatusType = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMemberIPTStatus(strUserID);
	return iptStatusType;
}

void MainFrame::MakeIPTMenu( NTIPTStatusType iptMyStatus, NTIPTStatusType iptStatusOfBuddy, const NE_MEMBER_DATA* pMembereData, CMenu* pPopup )
{
	CString strCorpTel = pMembereData->strIncoTel.c_str();
	CString strCellPhone = pMembereData->strCellPhone.c_str();
	CString strExtensionTel = pMembereData->strExtesion.c_str();

	//pPopup->InsertMenu(ID_MENU_CONFER_CALL, MF_BYCOMMAND, MF_SEPARATOR );
	if (!(iptMyStatus == iptstIDLE || iptMyStatus == iptstDND || iptMyStatus == iptstFWD) || iptStatusOfBuddy != iptstIDLE || strExtensionTel.IsEmpty() || !GET_CONFIG()->EnableFunction(_T("SR_08")))
	{
		pPopup->EnableMenuItem(ID_MENU_IPT_EXT_PHONE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	}

	if (!(iptMyStatus == iptstIDLE || iptMyStatus == iptstDND || iptMyStatus == iptstFWD) || iptStatusOfBuddy != iptstIDLE || strCorpTel.IsEmpty() || !GET_CONFIG()->EnableFunction(_T("SR_05")))
	{
		pPopup->EnableMenuItem(ID_MENU_IPT_CORP_PHONE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	}

	if (!(iptMyStatus == iptstIDLE || iptMyStatus == iptstDND || iptMyStatus == iptstFWD) || strCellPhone.IsEmpty() || !GET_CONFIG()->EnableFunction(_T("SR_07")))
	{	
		pPopup->EnableMenuItem(ID_MENU_IPT_CELLPHONE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	}
	if(iptMyStatus != iptstACTIVE || strExtensionTel.IsEmpty() || !GET_CONFIG()->EnableFunction(_T("SR_08")))
	{
		pPopup->EnableMenuItem(ID_MENU_IPT_CONFER, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
		pPopup->EnableMenuItem(ID_MENU_IPT_TRANSFER, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	}

	if (!GET_CONFIG()->EnableFunction(_T("SR_08")))
	{
		pPopup->DeleteMenu(ID_MENU_IPT_CONFER, MF_BYCOMMAND);
		pPopup->DeleteMenu(ID_MENU_IPT_TRANSFER, MF_BYCOMMAND);
		pPopup->DeleteMenu(ID_MENU_IPT_EXT_PHONE, MF_BYCOMMAND);
	}
	if (!GET_CONFIG()->EnableFunction(_T("SR_05")))
	{
		pPopup->DeleteMenu(ID_MENU_IPT_CORP_PHONE, MF_BYCOMMAND);
	}
	if (!GET_CONFIG()->EnableFunction(_T("SR_07")))
	{
		pPopup->DeleteMenu(ID_MENU_IPT_CELLPHONE, MF_BYCOMMAND);
	}
}

void MainFrame::OnMenuIPT(const NE_MEMBER_DATA* pMembereData, WPARAM wParam)
{
	int nID = (int)wParam;
	CString strTelNo = _T("");

	switch (nID)
	{
	case ID_MENU_COMPANY_PHONE:
	case ID_MENU_IPT_CORP_PHONE:
		strTelNo = pMembereData->strIncoTel.c_str();
		break;

	case ID_MENU_CELL_PHONE:
	case ID_MENU_IPT_CELLPHONE:
		strTelNo = pMembereData->strCellPhone.c_str();
		break;

	case ID_MENU_EXT_PHONE:
	case ID_MENU_IPT_EXT_PHONE:
		strTelNo = pMembereData->strExtesion.c_str();
		break;
	}

	CallToIPT(*pMembereData, strTelNo);
}

void MainFrame::CallToIPT(NE_MEMBER_DATA userData, CString strTel)
{
	if (strTel.IsEmpty())
		return;

	CDialPadManager* pManager = CDialPadManager::GetDialpadManager();

	if (pManager)
		pManager->MakeCall(userData, strTel);
}

void MainFrame::OnNotifySetCurSor(TNotifyUI& msg)
{
	CTabLayoutUI* pTabControl = static_cast<CTabLayoutUI*>(m_PaintManager.FindControl(kTabControlName));
	if (pTabControl != NULL)
	{
		if (pTabControl->GetCurSel() == eRecentChatTab)
		{
			if (_tcsicmp(msg.pSender->GetName(), _T("logo")) == 0)
			{
				CListContainerElementUI* pListElement = (CListContainerElementUI*)msg.pSender->GetTag();
				if (pListElement != NULL)
				{
					Node* pNode = (Node*)pListElement->GetTag();
					if ((pNode != NULL) && (pNode->folder()))			// mul-user chat in recent chat.
					{
						::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
					}
				}
			}
		}
	}
}

int MainFrame::_GetSelectedMembers(std::vector<NE_MEMBER_DATA>& rSelectedMembers, 
                                   BOOL bJustOnline /* = TRUE */,
                                   BOOL bSkipSelf /* = TRUE */)
{
    rSelectedMembers.clear();
    
    for (size_t i=0; i<m_vecSelectItems.size(); ++i)
    {
        if (m_vecSelectItems[i]->data().folder_)
        {
            continue;
        }

        if (bSkipSelf && GET_MESSENGER_DLG()->GetWorkGroupController()->IsMyID(m_vecSelectItems[i]->data().value.GetData()))
        {
            continue;
        }
        if (bJustOnline)
        {
            GTUserStatusType userStatus = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMemberStatus(m_vecSelectItems[i]->data().value);
            if (ustOFFLINE == userStatus)
            {
                continue;
            }
        }

        const NE_MEMBER_DATA data = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMember(m_vecSelectItems[i]->data().value);
        rSelectedMembers.push_back(data); 
    }

    return rSelectedMembers.size();
}

void MainFrame::OnNotifyCtrlKillFocus(TNotifyUI& msg)
{
	if (_tcsicmp(msg.pSender->GetName(), kSearchEdit) == 0)
	{
		msg.pSender->SetVisible(false);
		CButtonUI* searchLabel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSearchLabel));
		if (searchLabel != NULL)
		{
			searchLabel->SetVisible(true);
			if (msg.pSender->GetText().GetLength() == 0)
			{
				CTabLayoutUI* pTabControl = static_cast<CTabLayoutUI*>(m_PaintManager.FindControl(kTabControlName));
				if (pTabControl && pTabControl->GetCurSel() == eRecentChatTab)
				{
					searchLabel->SetText(LoadStringFromResource(IDS_STRING_RECENT_CHAT_SEARCH));
				}
				else
				{
					searchLabel->SetText(LoadStringFromResource(IDS_STRING245));
				}
			}
			else
			{
				m_strSearchWord = msg.pSender->GetText();
				searchLabel->SetText(m_strSearchWord);
			}
		}
	}
	else if (_tcsicmp(msg.pSender->GetName(), kMainFrameSignture) == 0)
	{
		GET_MESSENGER_DLG()->ProcRenameTalkname(msg.pSender->GetText().GetData());
	}
	else if (_tcsicmp(msg.pSender->GetName(), _T("edit_groupname")) == 0)
	{
		CEditUI* edit_groupname = static_cast<CEditUI*>(msg.pSender);
		if(edit_groupname != NULL)
		{
			Node* node = (Node*)edit_groupname->GetTag();
			CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_PaintManager.FindControl(kFriendsListControlName));
			if(edit_groupname->IsVisible())
			{
				pFriendsList->SetNodeEditable(node, false);
			}
		}
	}
}

BOOL MainFrame::IsSelectFavoriteBtn(CButtonUI *pBtn)
{
	BOOL bSelect = FALSE;
	CString strImage = pBtn->GetBkImage();
	if (strImage == FAVORITE_SELECT)
	{
		bSelect = TRUE;
	}
	
	return bSelect;
}

void MainFrame::OnBtnFavoriteDelete(CString strUserID)
{
	CStringList selectedIdList;
	selectedIdList.AddTail(strUserID);
	
	size_t nGroupCount = g_pMessengerActor->GetBuddyGroupCount();
	int nAddableBuddyGroupCount = 0;
	int nMenuIndex = 0;
	for (size_t i = 0; i < nGroupCount; i++)
	{
		const IGTBuddyGroup *pGroup = g_pMessengerActor->GetBuddyGroupInfoFromIndex(i);
		CString strGroupName = pGroup->GetName();
		int nGroupID = pGroup->GetID();
		int buddyCount = g_pMessengerActor->GetBuddyCount(nGroupID);
		for (int index = 0; index < buddyCount; index++)
		{
			const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfoFromIndex(nGroupID, index);
			CString strBuddyID = pUser->GetUserID();
			if (strBuddyID == strUserID)
			{
				std::vector<const IGTBuddyUser* > buddyVector;
				buddyVector.push_back(pUser);
				m_favoriteController.RequestDeleteBuddy(buddyVector);
			}
		}

	}
}

void MainFrame::OnBtnFavoriteAdd(CPoint pt, Node* pNode)
{
	CMenu menuFavoriteList;
	if (!menuFavoriteList.CreatePopupMenu())
	{
		return;
	}
	CString strUserID = pNode->data().value;
	if (GET_MESSENGER_DLG()->GetWorkGroupController()->IsMyID(strUserID))
	{
		return;
	}

	m_GroupList.clear();
	CStringList selectedIdList;
	if (pNode != NULL)
	{
		vector<Node*> vecSelNode;
		vecSelNode.push_back(pNode);
		SetSelectItems(vecSelNode);
		selectedIdList.AddTail(strUserID);
	}

	size_t nGroupCount = g_pMessengerActor->GetBuddyGroupCount();
	int nAddableBuddyGroupCount = 0;
	int nMenuIndex = 0;
	for (size_t i = 0; i < nGroupCount; i++)
	{
		const IGTBuddyGroup *pGroup = g_pMessengerActor->GetBuddyGroupInfoFromIndex(i);
		CString strGroupName = pGroup->GetName();
		int nGroupID = pGroup->GetID();
		if (!IsAllIdsInBuddyGroup(selectedIdList, nGroupID))
		{
			m_GroupList.insert(std::make_pair(WM_USER_ID_LIST + nMenuIndex, nGroupID));
			menuFavoriteList.AppendMenu(MF_STRING, WM_USER_ID_LIST + nMenuIndex++, strGroupName);
			nAddableBuddyGroupCount++;
		}

	}
	menuFavoriteList.AppendMenu(MF_STRING, ID_MENU_CREATE_FAVORITE_GROUP, LoadStringFromResource(IDS_STRING261));
	int nCmdID = menuFavoriteList.TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, CWnd::FromHandle(m_hWnd));

}

void MainFrame::OnBtnFavorite(CPoint pt, CButtonUI* pBtnFavorite)
{
	Node* node = (Node*)pBtnFavorite->GetTag();
	if (IsSelectFavoriteBtn(pBtnFavorite))
	{
		if (node != NULL)
		{
			OnBtnFavoriteDelete(node->data().value.GetData());
		}
	}
	else
	{
		OnBtnFavoriteAdd(pt, node);
	}
}

void MainFrame::_OnCtrlBtnInfoMeClick(TNotifyUI& msg)
{
    GET_MESSENGER_DLG()->OnTopMenuMyInfo();
}

void MainFrame::_OnCtrlBtnIptStatusClick(TNotifyUI& msg)
{
    CRect rectIPTMenu(0, 0, 0, 0);
    POINT pt = { 0 };

    CButtonUI* pBtnIpt =  static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("iptStatusBtn")));

    rectIPTMenu = pBtnIpt->GetPos();	

    CRect rtDlg(0, 0, 0, 0);
    GetWindowRect(m_hWnd, &rtDlg);

    pt.x = rtDlg.left + rectIPTMenu.left;
    pt.y = rtDlg.top + rectIPTMenu.bottom;

    LoadAboutIPTStatusPopup(pt);
}
void MainFrame::_OnCtrlBtnFavoriteClick(TNotifyUI& msg)
{
    CPoint point = msg.ptMouse;
    ClientToScreen(m_hWnd, &point);
    OnBtnFavorite(point, (CButtonUI*)msg.pSender);
}
void MainFrame::_OnCtrlCloseBannerClick(TNotifyUI& msg)
{
    CControlUI* pCtrl =  static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("bannerInfo")));
    pCtrl->SetVisible(false);
}

void MainFrame::_OnCtrlBtnCloseClick(TNotifyUI& msg)
{
    if ((g_pProfileWnd != NULL) && (g_pProfileWnd->GetParentHwnd() == m_hWnd || (m_pSearchWnd != NULL && m_pSearchWnd->GetHWND() == g_pProfileWnd->GetParentHwnd())))
    {
         g_pProfileWnd->CloseProfileWnd();
    }
    ShowWindow(false, false);// SW_HIDE);
}
void MainFrame::_OnCtrlBtnMinClick(TNotifyUI& msg)
{
    if ((g_pProfileWnd != NULL) && (g_pProfileWnd->GetParentHwnd() == m_hWnd || (m_pSearchWnd != NULL && m_pSearchWnd->GetHWND() == g_pProfileWnd->GetParentHwnd())))
    {
         g_pProfileWnd->CloseProfileWnd();
    }
    SendMessage(WM_SYSCOMMAND, SC_MINIMIZE, 0);
}
void MainFrame::_OnCtrlBtnMaxClick(TNotifyUI& msg)
{
    SendMessage(WM_SYSCOMMAND, SC_MAXIMIZE, 0);
}
void MainFrame::_OnCtrlBtnRestoreClick(TNotifyUI& msg)
{
    SendMessage(WM_SYSCOMMAND, SC_RESTORE, 0);
}
void MainFrame::_OnCtrlBtnMenuClick(TNotifyUI& msg)
{
    CControlUI* menubtn = m_PaintManager.FindControl(kMenuButtonControlName);
    OnBnClickedTopmenuButton(menubtn);
}
void MainFrame::_OnCtrlBtnOrgPopClick(TNotifyUI& msg)
{
    GET_MESSENGER_DLG()->LoadOrganization(SHOW_ORG);
}
void MainFrame::_OnCtrlBtnOrgIptClick(TNotifyUI& msg)
{
    if(GET_APP()->IsAvailableIPT())
    {
        Node* node = (Node*)msg.pSender->GetTag();
        if (node != NULL)
        {
            NTIPTStatusType iptMyStatus = g_pMessengerActor->GetMyIptStatus();
            NTIPTStatusType iptStatusOfBuddy = GetMemberIPTStatus(node->data().value);
            const NE_MEMBER_DATA MembereData = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMember(node->data().value);
            CMenu menuList;
            menuList.LoadMenu(IDR_MEMU_COMMON_MENU);
            CMenu* pPopup = menuList.GetSubMenu(7);
            MakeIPTMenu(iptMyStatus, iptStatusOfBuddy, &MembereData, pPopup);

            if( pPopup != NULL )
            {
                CPoint point(msg.ptMouse.x, msg.ptMouse.y);
                ::ClientToScreen(m_hWnd, &point);
                int nCmdID = pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RETURNCMD | TPM_RIGHTBUTTON, point.x, point.y, CWnd::FromHandle(m_hWnd));
                OnMenuIPT(&MembereData, nCmdID);
            }
        }
    }
}
void MainFrame::_OnCtrlTabBookmarkClick(TNotifyUI& msg)
{
    CTabLayoutUI* pTabControl = static_cast<CTabLayoutUI*>(m_PaintManager.FindControl(kTabControlName));
    pTabControl->SelectItem(1);
}
void MainFrame::_OnCtrSearchLabelClick(TNotifyUI& msg)
{
    msg.pSender->SetVisible(false);
    CEditUI* searchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kSearchEdit));
    if (searchEdit != NULL)
    {
        m_strSearchWord = _T("");//msg.pSender->GetText();
        searchEdit->SetText(m_strSearchWord);
        searchEdit->SetVisible(true);
        searchEdit->SetFocus();
    }
}
void MainFrame::_OnCtrlSearchBtnClick(TNotifyUI& msg)
{
    OnSearchUser();
}
void MainFrame::_OnCtrlSearchCancelClick(TNotifyUI& msg)
{
    CloseSearchWnd();
}

void MainFrame::_OnCtrlHideLeftMainPannelClick(TNotifyUI& msg)
{
    CControlUI* left_main_pannel = m_PaintManager.FindControl(kLeftMainPannelControlName);
    CControlUI* hide_left_main_pannel = m_PaintManager.FindControl(kHideLeftMainPannelControlName);
    CControlUI* show_left_main_pannel = m_PaintManager.FindControl(kShowLeftMainPannelControlName);
    if ((left_main_pannel != NULL) && (show_left_main_pannel != NULL) && (hide_left_main_pannel != NULL))
    {
        hide_left_main_pannel->SetVisible(false);
        left_main_pannel->SetVisible(false);
        show_left_main_pannel->SetVisible(true);
    }
}
void MainFrame::_OnCtrlShowLeftMainPannelClick(TNotifyUI& msg)
{
    CControlUI* left_main_pannel = m_PaintManager.FindControl(kLeftMainPannelControlName);
    CControlUI* hide_left_main_pannel = m_PaintManager.FindControl(kHideLeftMainPannelControlName);
    CControlUI* show_left_main_pannel = m_PaintManager.FindControl(kShowLeftMainPannelControlName);
    if ((left_main_pannel != NULL) && (show_left_main_pannel != NULL) && (hide_left_main_pannel != NULL))
    {
        hide_left_main_pannel->SetVisible(true);
        left_main_pannel->SetVisible(true);
        show_left_main_pannel->SetVisible(false);
    }
}
void MainFrame::_OnCtrlChangeBkSkinClick(TNotifyUI& msg)
{
    CControlUI* background = m_PaintManager.FindControl(kBackgroundControlName);
    if (background != NULL)
    {
        TCHAR szBuf[MAX_PATH] = {0};
        ++bk_image_index_;
        if (kBackgroundSkinImageCount < bk_image_index_)
            bk_image_index_ = 0;
        _stprintf_s(szBuf, MAX_PATH - 1, _T("file='bg%d.png' corner='600,200,1,1'"), bk_image_index_);
        background->SetBkImage(szBuf);

    }
}

void MainFrame::_OnCtrlChangeColorSkinClick(TNotifyUI& msg)
{
    CDuiRect rcWindow;
    GetWindowRect(m_hWnd, &rcWindow);
    rcWindow.top = rcWindow.top + msg.pSender->GetPos().bottom;
}


void MainFrame::_OnCtrlButtonBoardClick(TNotifyUI& msg){

   // kBtnSignControlName
    if (msg.pSender->GetName() == kBtnNoteControlName)
    {
          int i=0;
    } 
    else if (msg.pSender->GetName() == kBtnMailControlName)
    {
		int i=0;
    }
	else if (msg.pSender->GetName() == kBtnSignControlName)
	{
		int i=0;
	} 
	else if (msg.pSender->GetName() == kBtnVocControlName)
	{
		int i=0;
	}
	else if (msg.pSender->GetName() == kBtnSurveyControlName)
	{
		int i=0;

	}
	else if (msg.pSender->GetName() == kBtnInControlName)
	{

	} 
	else if (msg.pSender->GetName() == kBtnSamControlName)
	{

	}
}

void MainFrame::_OnCtrlStatusBtnClick(TNotifyUI& msg)
{
    CTextUI* pStatusText = static_cast<CTextUI*>(m_PaintManager.FindControl(_T("status")));

    if(NULL != pStatusText)
    {
        CDuiRect rcWindow;
        GetWindowRect(m_hWnd, &rcWindow);
        CPoint pt(0, 0);
        pt.y = rcWindow.top + pStatusText->GetPos().bottom;
        pt.x = rcWindow.left + pStatusText->GetPos().left;
        LoadAboutMeStatusPopup(pt);
    }
}

void MainFrame::OnNotifyMainMenuDrag( TNotifyUI& msg )
{
	m_eDragDropType = eMenu;
	m_mainMenuControler.DragStart(msg);

	/*CSharedFile file;
	CArchive ar(&file, CArchive::store);

	int nIndex = 1;
	ar<<nIndex;
	ar.Close();

	COleDataSource oleDataSource;
	oleDataSource.CacheGlobalData(m_uClipBoardFormat, file.Detach());
	oleDataSource.DoDragDrop();*/

	//OnDragStart();
}

void MainFrame::OnNotifyItemDrag(TNotifyUI& msg)
{
	CTabLayoutUI* pTabControl = static_cast<CTabLayoutUI*>(m_PaintManager.FindControl(kTabControlName));
	if (pTabControl != NULL)
	{
		if (pTabControl->GetCurSel() == eFavoriteTab || pTabControl->GetCurSel() == eOrganizationTab)
		{
			Node* node = (Node*)msg.pSender->GetTag();
			//m_pBuddyList->SetDragNode(node);
			m_eDragDropType = eList;
			OnDragStart((EMENUTAB)pTabControl->GetCurSel());
		}		
	}
}

void MainFrame::OnNotifyItemEsc(TNotifyUI& msg)
{
	if (_tcsicmp(msg.pSender->GetName(), _T("edit_groupname")) == 0)
	{
		CEditUI* pEdit = dynamic_cast<CEditUI*>(msg.pSender);
		if(pEdit != NULL)
		{
			Node* pNode = (Node*)pEdit->GetTag();
			if(pNode != NULL)
			{
				IGTBuddyGroup* pGroup = (IGTBuddyGroup*)pNode->GetNodeUserData();
				if(pGroup != NULL)
				{
					pEdit->SetText(pGroup->GetName());
				}
			}
		}

		m_PaintManager.SetFocus(NULL);
	}
}
void MainFrame::OnNotifyItemEnter(TNotifyUI& msg)
{
	if (IsFocuseOnSearchEdit())
	{
		if (msg.wParam == WM_KEYDOWN)
		{
			OnSearchUser();
		}
	}
	else if (_tcsicmp(msg.pSender->GetName(), kMainFrameSignture) == 0)
	{
		m_PaintManager.SetFocus(NULL);
	}
	else if (_tcsicmp(msg.pSender->GetName(), _T("edit_groupname")) == 0)
	{
		m_PaintManager.SetFocus(NULL);
	}
}

void MainFrame::OnNotifyTabSelectChange(TNotifyUI& msg)
{
	CTabLayoutUI* pTabControl = static_cast<CTabLayoutUI*>(m_PaintManager.FindControl(kTabControlName));
	if (_tcsicmp(msg.pSender->GetName(), kTabOrganization) == 0)
	{
		if (pTabControl && pTabControl->GetCurSel() != eOrganizationTab)
		{
			if (GET_CONFIG()->EnableFunction(_T("ME_02")) == TRUE)
			{
				pTabControl->SelectItem(eOrganizationTab);
				//GET_MESSENGER_DLG()->LoadOrganization(SHOW_ORG, CWnd::FromHandle(m_hWnd));
				if (!m_bRequestORGGroup)
				{
					m_bRequestORGGroup = TRUE;
					GET_MESSENGER_DLG()->GetWorkGroupController()->RequestORGGroup(ADD_MAINORGGROUP);
				}
			}
			else
			{
				pTabControl->SelectItem(pTabControl->GetCurSel());
				GET_MESSENGER_DLG()->LoadOrganization(SHOW_SEARCH);
				
			}
		}
		CloseSearchWnd();
	}
	else if (_tcsicmp(msg.pSender->GetName(), kTabBookmark) == 0)
	{
		if (pTabControl && pTabControl->GetCurSel() != eFavoriteTab)
		{
			pTabControl->SelectItem(eFavoriteTab);
		}
		CloseSearchWnd();
	}
	else if (_tcsicmp(msg.pSender->GetName(), kTabChatlist) == 0)
	{
		if (pTabControl && pTabControl->GetCurSel() != eRecentChatTab)
		{
			pTabControl->SelectItem(eRecentChatTab);
		}
		CloseSearchWnd();
		ShowNoUserInRecentChatList();
	}
}	

void MainFrame::OnNotifyItemClick(TNotifyUI& msg)
{
	CTabLayoutUI* pTabControl = static_cast<CTabLayoutUI*>(m_PaintManager.FindControl(kTabControlName));
	if (pTabControl != NULL)
	{
		if (pTabControl->GetCurSel() == eOrganizationTab)
		{
			COrganizationTreeUI* pOrgTree = static_cast<COrganizationTreeUI*>(m_PaintManager.FindControl(kOrganization));
			if ((pOrgTree != NULL) &&  pOrgTree->GetItemIndex(msg.pSender) != -1)
			{
				if (_tcsicmp(msg.pSender->GetClass(), _T("ListContainerElementUI")) == 0)
				{
					Node* node = (Node*)msg.pSender->GetTag();
					m_pCurSelNode = node;
					if (msg.wParam == UIEVENT_RBUTTONDOWN)
					{
						pOrgTree->OnMouseButtonEvent(UIEVENT_RBUTTONDOWN, msg.lParam);
					}
					else if (msg.wParam == UIEVENT_RBUTTONUP)
					{
						vector<Node*> vecSelID;
                        vecSelID = pOrgTree->GetSelectedItems();
						SetSelectItems(vecSelID);
						CPoint point = msg.ptMouse;
						ClientToScreen(m_hWnd, &point);
						if (node->folder())
						{
							PopupMenuView(point, IDR_MEMU_COMMON_MENU, TREE_POPUP_MENU);
						}
						else
						{
							PopupMenuView(point, IDR_MEMU_COMMON_MENU, LIST_POPUP_MENU);
						}

					}
					else if(msg.wParam == 0)
					{
						if (pOrgTree->CanExpand(node))
						{
							bool bChildNodeVisible = !node->data().child_visible_;
							pOrgTree->SetChildVisible(node, bChildNodeVisible);
							OrganizationListItemInfo item;
							for (std::vector<OrganizationListItemInfo>::const_iterator citer = m_vecOrgList.begin(); citer != m_vecOrgList.end(); ++citer)
							{
								if (_tcsicmp(citer->id, node->data().value) == 0)
								{
									item = *citer;
									if (GET_MESSENGER_DLG()->GetWorkGroupController() != NULL && item.folder && bChildNodeVisible)
									{
										CString strParentID = node->parent()->data().value;
										CString strID = node->data().value;
										GET_MESSENGER_DLG()->GetWorkGroupController()->RequestORGGroupMemberList(strParentID, strID,  UPDATE_VIEW_ORG);
									}
									break;
								}
							}
						}
					}

				}
			}
		}
		else if (pTabControl->GetCurSel() == eFavoriteTab)
		{
			CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_PaintManager.FindControl(kFriendsListControlName));
			if ((pFriendsList != NULL) &&  pFriendsList->GetItemIndex(msg.pSender) != -1)
			{
				if (_tcsicmp(msg.pSender->GetClass(), _T("ListContainerElementUI")) == 0)
				{

					CControlUI* pSelectedCtrl = m_PaintManager.FindSubControlByPoint(msg.pSender,msg.ptMouse);
					if(NULL == pSelectedCtrl)
						return;
					CDuiString strName = pSelectedCtrl->GetName();
					CDuiString strClass = pSelectedCtrl->GetClass();
					/*	CDuiString strDebug;
					strDebug.Format(_)*/

					Node* node = (Node*)msg.pSender->GetTag();

					if (msg.wParam == UIEVENT_RBUTTONDOWN ||
						msg.wParam == UIEVENT_RBUTTONUP)
					{
						m_favoriteController.OnRButtonEvent((bool)(msg.wParam & 0x0F), msg.lParam);
					}
					else if(msg.wParam == 0)
					{						

                      if (node && node->folder() && !node->IsRoot())  //BTS-919: ITEMCLICK whole cell of group node, expand it.
                      {
						  /*if ( _tcsicmp(pSelectedCtrl->GetName(), _T("arrowicon")) != 0 && node->folder())
							{
								return;
							}*/
						  bool bDoExpand = true;
						  if(0x8000 & GetKeyState(VK_CONTROL))
						  {
							  bDoExpand = false;
						  }
						  else if (0x8000 & GetKeyState(VK_SHIFT))
						  {
							  bDoExpand = false;
						  } 

						  if (bDoExpand && pFriendsList->CanExpand(node))
						  {
							  if(!node->data().child_visible_)
							  {
								  const IGTBuddyGroup *pGroup = (IGTBuddyGroup*)node->GetNodeUserData();
								  if (pGroup)
								  {
									  GET_CONFIG()->SetExpandBuddyGroup(pGroup->GetID());
									  GET_CONFIG()->SaveExpandBuddyGroup();
								  }
							  }
							  else
							  {
								  const IGTBuddyGroup *pGroup = (IGTBuddyGroup*)node->GetNodeUserData();
								  if (pGroup)
								  {
									  GET_CONFIG()->SetCollapseBuddyGroup(pGroup->GetID());
									  GET_CONFIG()->SaveExpandBuddyGroup();
								  }
							  }

							  pFriendsList->SetChildVisible(node, !node->data().child_visible_);
						  }

                      }
					  else{

						  if ( _tcsicmp(pSelectedCtrl->GetName(), kLogoButtonControlName) == 0 )
						  {
							  CRect rcItem = pSelectedCtrl->GetPos();

							  RECT rcClient = {};
							  GetWindowRect(m_hWnd, &rcClient);

							  RECT rcAround = {rcClient.left + rcItem.left - ITEM_LOGO_LEFT_ARROW_IDTH, rcClient.top + rcItem.top, rcClient.left + rcItem.right, rcClient.top + rcItem.bottom};
							  if (node != NULL)
							  {
								  GET_MESSENGER_DLG()->GetProfileDlgController()->CreateProfileDlg(node->data().value.GetData(), rcAround, GetSafeHwnd());
							  }
						  }

					  }					
						
					}				

				}

			}
			if((pFriendsList != NULL) &&  pFriendsList->GetItemIndex(msg.pSender) == -1)
			{
				m_favoriteController.OnRButtonEvent((bool)(msg.wParam & 0x0F), msg.lParam);
			}
		}
		else if(pTabControl->GetCurSel() == eRecentChatTab)
		{
			CChatRoomList* pChattingList = static_cast<CChatRoomList*>(m_PaintManager.FindControl(kChattingListControlName));
			if ((pChattingList != NULL) &&  pChattingList->GetItemIndex(msg.pSender) != -1)
			{
				if (_tcsicmp(msg.pSender->GetClass(), _T("ListContainerElementUI")) == 0)
				{
					if (msg.wParam == UIEVENT_RBUTTONUP)
					{
						m_pChatListManager->OnRButtonEvent((bool)(msg.wParam & 0x0F), msg.lParam);
					}
				}
			}
		}

	}
}

void MainFrame::OnNotifyItemDoubleClick(TNotifyUI& msg)
{
	CTabLayoutUI* pTabControl = static_cast<CTabLayoutUI*>(m_PaintManager.FindControl(kTabControlName));
	if (pTabControl != NULL)
	{
		if (pTabControl->GetCurSel() == eOrganizationTab)
		{
			COrganizationTreeUI* pOrgTree = static_cast<COrganizationTreeUI*>(m_PaintManager.FindControl(kOrganization));
			if ((pOrgTree != NULL) &&  pOrgTree->GetItemIndex(msg.pSender) != -1)
			{
				if (_tcsicmp(msg.pSender->GetClass(), _T("ListContainerElementUI")) == 0)
				{
					CControlUI* pSelectedCtrl = m_PaintManager.FindSubControlByPoint(msg.pSender,msg.ptMouse);
					Node* node = (Node*)msg.pSender->GetTag();
					m_pCurSelNode = node;
					if (!node->folder())
					{
						std::vector<NE_MEMBER_DATA> memberVector;
						CString strID = node->data().value;
						const NE_MEMBER_DATA data = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMember(strID);
						GTUserStatusType eUserStatus = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMemberStatus(strID);
						if(eUserStatus != ustOFFLINE)
						{
							memberVector.push_back(data);
							GET_APP()->m_pChatDialogManager->CreateMemberChat(memberVector);
						}
					}

				}
			}
		}
		else if (pTabControl->GetCurSel() == eFavoriteTab)
		{
			CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_PaintManager.FindControl(kFriendsListControlName));
			if ((pFriendsList != NULL) &&  pFriendsList->GetItemIndex(msg.pSender) != -1)
			{
				if (_tcsicmp(msg.pSender->GetClass(), _T("ListContainerElementUI")) == 0)
				{
					CControlUI* pSelectedCtrl = m_PaintManager.FindSubControlByPoint(msg.pSender,msg.ptMouse);					
					Node* node = (Node*)msg.pSender->GetTag();
					m_pCurSelNode = node;
					if (!node->folder())
					{
						if(pSelectedCtrl->GetName() == _T("logo"))
							return;
						std::vector<NE_MEMBER_DATA> memberVector;
						CString strID = node->data().value;
						const NE_MEMBER_DATA data = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMember(strID);
						memberVector.push_back(data);
						//GET_APP()->m_pChatDialogManager->CreateMemberChat(memberVector);

						std::vector<const IGTBuddyUser*> buddyVector;
						m_favoriteController.GetSelectedOnlineFavorites(buddyVector);
						if (buddyVector.size()>0)
						{
							GET_APP()->m_pChatDialogManager->CreateBuddyChat(buddyVector);
						}

						else
						{
							GET_MESSENGER_DLG()->PostMessage(WM_COMMAND, ID__SEND_MEMO, 0);	
						}
					}
					else if (node != NULL && node->folder() && !node->IsRoot()) //group node;							
					{
						/*bool bDoExpand = true;
						if(0x8000 & GetKeyState(VK_CONTROL))
						{
							bDoExpand = false;
						}
						else if (0x8000 & GetKeyState(VK_SHIFT))
						{
							bDoExpand = false;
						} 

					if (bDoExpand && pFriendsList->CanExpand(node))
						{
							if(!node->data().child_visible_)
							{
								const IGTBuddyGroup *pGroup = (IGTBuddyGroup*)node->GetNodeUserData();
								if (pGroup)
								{
									GET_CONFIG()->SetExpandBuddyGroup(pGroup->GetID());
									GET_CONFIG()->SaveExpandBuddyGroup();
								}
							}
							else
							{
								const IGTBuddyGroup *pGroup = (IGTBuddyGroup*)node->GetNodeUserData();
								if (pGroup)
								{
									GET_CONFIG()->SetCollapseBuddyGroup(pGroup->GetID());
									GET_CONFIG()->SaveExpandBuddyGroup();
								}
							}

							pFriendsList->SetChildVisible(node, !node->data().child_visible_);
						}	*/					
					}
				}
			}
		}
		else if(pTabControl->GetCurSel() == eRecentChatTab)
		{
			CChatRoomList* pChattingList = static_cast<CChatRoomList*>(m_PaintManager.FindControl(kChattingListControlName));
			if ((pChattingList != NULL) &&  pChattingList->GetItemIndex(msg.pSender) != -1)
			{
				if (_tcsicmp(msg.pSender->GetClass(), _T("ListContainerElementUI")) == 0)
				{
					m_pChatListManager->MenuCmd(ID_CHAT_ROOM_OPEN);
					
				}
			}
		}
	}
}

void MainFrame::SetSelectItems(vector<Node*>& vecSelectItems)
{
	m_vecSelectItems.clear();
	for (size_t i=0; i<vecSelectItems.size(); ++i)
	{
		if(find(m_vecSelectItems.begin(), m_vecSelectItems.end(), vecSelectItems[i]) == m_vecSelectItems.end())
		{
			m_vecSelectItems.push_back(vecSelectItems[i]);
		}
	}
}

void MainFrame::PopupMenuView(CPoint pt, int nMain, int nSub)
{
	CMenu menuList;
	menuList.LoadMenu(nMain);

	m_ePopupMenuType = (ePOPUP_TYPE)nSub;

	MakeFavoriteMenu(&menuList, nSub);
	menuList.GetSubMenu(nSub)->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, CWnd::FromHandle(m_hWnd));
	
}

void MainFrame::SetUserAuth()
{
	m_nUserAuth = AUTH_SHOW_NAME|AUTH_SHOW_DEPT|AUTH_SHOW_JBPS|AUTH_SHOW_JBDT;	// 扁夯鼻茄

	if (GET_CONFIG()->EnableFunction(_T("ME_02")) == TRUE)
		m_nUserAuth |= AUTH_SHOW_ORG_TREE;

	if (GET_CONFIG()->EnableFunction(_T("ME_03")) == TRUE)
		m_nUserAuth |= AUTH_SHOW_WORK_TREE;

	if (GET_CONFIG()->EnableFunction(_T("SC_12")) == TRUE)
	{
		m_nUserAuth |= AUTH_LEVEL_SEARCH;
	}


	if (GET_CONFIG()->EnableFunction(_T("ME_04")) == TRUE &&
		GET_APP()->IsAvailableIPT())
	{
		if (GET_CONFIG()->EnableFunction(_T("SR_05")) ||
			GET_CONFIG()->EnableFunction(_T("SR_07")) ||
			GET_CONFIG()->EnableFunction(_T("SR_08")))
		{
			m_nUserAuth |= AUTH_SHOW_IPT;
		}
	}

	if (GET_CONFIG()->EnableFunction(_T("SR_08")) == TRUE)
	{
		m_nUserAuth |= AUTH_SHOW_EXT_TEL;
	}

	if (GET_CONFIG()->EnableFunction(_T("SR_05")) == TRUE)
	{
		m_nUserAuth |= AUTH_SHOW_CORP_TEL;
	}

	if (GET_CONFIG()->EnableFunction(_T("SR_07")) == TRUE)
	{
		m_nUserAuth |= AUTH_SHOW_CELL_PH;
	}

	if (GET_CONFIG()->EnableFunction(_T("SR_06")) == TRUE)
	{
		m_nUserAuth |= AUTH_SHOW_FAX;
	}

	if (GET_CONFIG()->EnableFunction(_T("SR_10")) == TRUE)
	{
		m_nUserAuth |= AUTH_SHOW_EMAIL;
	}

	if (GET_CONFIG()->EnableFunction(_T("SR_11")) == TRUE)
	{
		m_nUserAuth |= AUTH_SHOW_ROMNG_PH;
	}

	if (GET_CONFIG()->EnableFunction(_T("SR_09")) == TRUE)
	{
		m_nUserAuth |= AUTH_SHOW_KEYWORD;
	}

	if (GET_CONFIG()->EnableFunction(_T("SR_12")) == TRUE)
	{
		m_nUserAuth |= AUTH_SHOW_WORK_PL;
	}
	if (GET_CONFIG()->EnableFunction(_T("UI_01"))==TRUE)
	{
		m_nUserAuth |= AUTH_SHOW_WORK_STATUS;
	}
}

BOOL MainFrame::HasAuth(DWORD nAuth)
{
	if ((m_nUserAuth & nAuth) == nAuth)
		return TRUE;

	return FALSE;
}

int MainFrame::GetSelectOnlineUserCount()
{
	int nCountOnline = 0;
	for (size_t i=0; i<m_vecSelectItems.size(); ++i)
	{
		CString strID = m_vecSelectItems[i]->data().value;
		GTUserStatusType eUserStatus = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMemberStatus(strID);
		if (eUserStatus != ustOFFLINE)
		{
			nCountOnline++;
		}
	}
	return nCountOnline;
}

BOOL MainFrame::IsSelectMyself()
{
	for (size_t i=0; i<m_vecSelectItems.size(); ++i)
	{
		CString strID = m_vecSelectItems[i]->data().value;
		if (GET_MESSENGER_DLG()->GetWorkGroupController()->IsMyID(strID))
		{
			return TRUE;
		}
	}
	return FALSE;
}

void MainFrame::MakeFavoriteMenu(CMenu* menu, int nSub)
{
	COrganizationTreeUI* pOrgTreeList = static_cast<COrganizationTreeUI*>(m_PaintManager.FindControl(kOrganization));
	const UINT favoriteMenuIndex = 7;
	// 榴败茫扁 弊缝 府胶飘(悼利栏肺 积己)
	CMenu menuFavoriteList;

	if (!menuFavoriteList.CreatePopupMenu())
		return;

	// 扁夯 皋春(榴败茫扁 府胶飘甫 嘿老 何葛 皋春)
	CMenu* pPopup = menu->GetSubMenu(nSub);

	if (!pPopup)
		return;

	int nSelectedCount = 1;//m_pShownList->GetSelectedCount();

	if (nSelectedCount != 1)
	{
		pPopup->EnableMenuItem(ID_MENU_USER_INFO, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);	// 荤侩磊 沥焊
		pPopup->EnableMenuItem(ID_MENU_CHAT_HISTORY, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);	// 措拳 郴开 焊扁
	}

	if (GET_CONFIG()->EnableFunction(_T("UI_03")) == FALSE)
		pPopup->EnableMenuItem(ID_MENU_USER_INFO, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);

#ifdef _DEBUG
#else
	if(GET_CONFIG()->EnableFunction(_T("ME_01")) == FALSE)
		pPopup->EnableMenuItem(ID_MENU_SMS, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);

	if(GET_CONFIG()->EnableFunction(_T("ME_01")) == FALSE)
		pPopup->EnableMenuItem(ID_MENU_TREE_SMS, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
#endif

	m_GroupList.clear();

	size_t nGroupCount = g_pMessengerActor->GetBuddyGroupCount();
	int nAddableBuddyGroupCount = 0;

	int nMenuIndex = 0;

	if ((nGroupCount>0) && (pOrgTreeList!=NULL))
	{
		CStringList selectedIdList;
		for (size_t i=0; i<m_vecSelectItems.size(); ++i)
		{
			CString strID = m_vecSelectItems[i]->data().value;
			if (GET_MESSENGER_DLG()->GetWorkGroupController()->IsMyID(strID))
			{
				continue;
			}
			selectedIdList.AddTail(strID);
		}

		// 榴败茫扁 弊缝
		for (size_t i = 0; i < nGroupCount; i++)
		{
			const IGTBuddyGroup *pGroup = g_pMessengerActor->GetBuddyGroupInfoFromIndex(i);

			CString strGroupName = pGroup->GetName();
			int nGroupID = pGroup->GetID();

			if (nSub == TREE_POPUP_MENU)
			{
				m_GroupList.insert(std::make_pair(WM_USER_ID_TREE + i, nGroupID));
				menuFavoriteList.AppendMenu(MF_STRING, WM_USER_ID_TREE + i, strGroupName);
			}
			else if ((nSub==LIST_POPUP_MENU) || (nSub==CHAT_POPUP_MENU))
			{
				if (!IsAllIdsInBuddyGroup(selectedIdList, nGroupID))
				{
					m_GroupList.insert(std::make_pair(WM_USER_ID_LIST + nMenuIndex, nGroupID));
					menuFavoriteList.AppendMenu(MF_STRING, WM_USER_ID_LIST + nMenuIndex++, strGroupName);
					nAddableBuddyGroupCount++;
				}
			}
		}
	}

	menuFavoriteList.AppendMenu(MF_STRING, ID_MENU_CREATE_FAVORITE_GROUP, LoadStringFromResource(IDS_STRING261));
	//pPopup->AppendMenu(MF_POPUP, (UINT_PTR)menuFavoriteList.m_hMenu, LoadStringFromResource(IDS_STRING262));	// 措拳惑措 眠啊
	pPopup->InsertMenu(favoriteMenuIndex, MF_BYPOSITION | MF_POPUP, (UINT_PTR)menuFavoriteList.m_hMenu, LoadStringFromResource(IDS_STRING262));	// 措拳惑措 眠啊

	// 柯扼牢 惑怕狼 荤侩磊啊 绝阑 版快绰 '措拳窍扁'甫 Disable 惑怕肺 函版茄促.
	// 飘府狼 版快 惑怕蔼捞 词霸 诀单捞飘 登扁 锭巩俊 老窜 劝己拳 矫难初绊 荤侩磊啊 急琶且 版快 贸府窍绰 荐观俊 绝促. 
	// 困客 鞍篮 备泅惑狼 巩力肺 飘府俊辑狼 '措拳窍扁'绰 Spec out. (2012.04.20)
	if ((nSub==LIST_POPUP_MENU) || (nSub==CHAT_POPUP_MENU))
	{
		int nOnlineUserCount = GetSelectOnlineUserCount(); //m_pShownList->GetOnlineUserCount(false);
		if (IsSelectMyself())	
		{
			nOnlineUserCount -= 1;
		}

		if (nSelectedCount == 1 && IsSelectMyself())
		{
			pPopup->EnableMenuItem(ID_MENU_CHAT, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);	// 措拳窍扁
			pPopup->EnableMenuItem(favoriteMenuIndex, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);	// 榴败茫扁
		}
		else if (nOnlineUserCount <= 0)
		{
			pPopup->EnableMenuItem(ID_MENU_CHAT, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);	// 措拳窍扁
		}
		
		//Modify by sevin for bts:NTALKCL-1165
		//if (nGroupCount > 0 && nAddableBuddyGroupCount == 0)	// nGroupCount捞 1 捞惑牢 版快绰 榴败茫扁 弊缝 积己 皋春啊 焊咯具 窃
			//pPopup->EnableMenuItem(favoriteMenuIndex, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);	// 榴败茫扁


		if (HasAuth(AUTH_SHOW_IPT))
		{
			if (nSelectedCount != 1)
			{
				pPopup->EnableMenuItem(5, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);	// 傈拳
			}
			else
			{

				CString strUserID = m_pCurSelNode->data().value;;
				if (GET_MESSENGER_DLG()->GetWorkGroupController()->IsMyID(strUserID))
				{
					pPopup->EnableMenuItem(5, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);	// 傈拳
				}
				else
				{
					NTIPTStatusType iptMyStatus = g_pMessengerActor->GetMyIptStatus();
					NTIPTStatusType iptStatusOfBuddy = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMemberIPTStatus(strUserID);

					//CString strCorpTel = m_pShownList->GetItemText(nSelectedItem, m_nColCorpTel);
					//CString strCellPhone = m_pShownList->GetItemText(nSelectedItem, m_nColCellPhone);
					//CString strExtensionTel = m_pShownList->GetItemText(nSelectedItem, m_nColExtensionTel);

					pPopup->InsertMenu(ID_MENU_CONFER_CALL, MF_BYCOMMAND, MF_SEPARATOR );
					if (!(iptMyStatus == iptstIDLE || iptMyStatus == iptstDND || iptMyStatus == iptstFWD) || iptStatusOfBuddy != iptstIDLE || !GET_CONFIG()->EnableFunction(_T("SR_08")))
					{
						pPopup->EnableMenuItem(ID_MENU_EXT_PHONE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
					}

					if (!(iptMyStatus == iptstIDLE || iptMyStatus == iptstDND || iptMyStatus == iptstFWD) || iptStatusOfBuddy != iptstIDLE || !GET_CONFIG()->EnableFunction(_T("SR_05")))
					{
						pPopup->EnableMenuItem(ID_MENU_COMPANY_PHONE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);

					}

					if (!(iptMyStatus == iptstIDLE || iptMyStatus == iptstDND || iptMyStatus == iptstFWD) || !GET_CONFIG()->EnableFunction(_T("SR_07")))
					{	
						pPopup->EnableMenuItem(ID_MENU_CELL_PHONE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);

					}
					if(iptMyStatus != iptstACTIVE || !GET_CONFIG()->EnableFunction(_T("SR_08")))
					{
						pPopup->EnableMenuItem(ID_MENU_CONFER_CALL, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
						pPopup->EnableMenuItem(ID_MENU_FTRANSFER_CALL, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
					}

					if (!GET_CONFIG()->EnableFunction(_T("SR_08")))
					{
						pPopup->DeleteMenu(ID_MENU_CONFER_CALL, MF_BYCOMMAND);
						pPopup->DeleteMenu(ID_MENU_FTRANSFER_CALL, MF_BYCOMMAND);
						pPopup->DeleteMenu(ID_MENU_EXT_PHONE, MF_BYCOMMAND);
					}
					if (!GET_CONFIG()->EnableFunction(_T("SR_05")))
					{
						pPopup->DeleteMenu(ID_MENU_COMPANY_PHONE, MF_BYCOMMAND);
					}
					if (!GET_CONFIG()->EnableFunction(_T("SR_07")))
					{
						pPopup->DeleteMenu(ID_MENU_CELL_PHONE, MF_BYCOMMAND);
					}
				}
			}
		}
	}
	
	if (!HasAuth(AUTH_SHOW_IPT) && nSub == LIST_POPUP_MENU)
	{
		pPopup->DeleteMenu(5, MF_BYPOSITION);
	}
}

BOOL MainFrame::IsAllIdsInBuddyGroup(CStringList& selectedIdList, int nGroupID)
{
	BOOL bAllUsersAreInTheBuddyGroup = TRUE;	// selectedIdList狼 葛电 荤侩磊啊 nGroupID 救俊 加秦 乐促搁 TRUE

	int buddyCount = g_pMessengerActor->GetBuddyCount(nGroupID);

	CStringList buddyIdInGroup;
	for (int index = 0; index < buddyCount; index++)
	{
		const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfoFromIndex(nGroupID, index);
		CString strBuddyID = pUser->GetUserID();
		buddyIdInGroup.AddTail(strBuddyID);
	}

	POSITION pos = selectedIdList.GetHeadPosition();

	while (pos)
	{
		CString strID = selectedIdList.GetNext(pos);

		if (buddyIdInGroup.Find(strID) == NULL)
		{
			bAllUsersAreInTheBuddyGroup = FALSE;
			break;
		}
	}

	return bAllUsersAreInTheBuddyGroup;
}

void MainFrame::SetSearchWndHeight(int nHeight)
{
	m_nSearchWndHeight = nHeight;
}

CRect MainFrame::GetSearchWndRect()
{
	CRect rcClient(0, 0, 0, 0);
	GetClientRect(m_hWnd, &rcClient);
	CRect rcSearchBox = rcClient;
	CButtonUI* searchLabel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSearchLabel));
	if (searchLabel != NULL)
	{
		rcSearchBox = searchLabel->GetPos();
	}
	//m_nSearchWndHeight = min(m_nSearchWndHeight, 286);
	//m_nSearchWndHeight = min(286, rcClient.Height() - 100);
	rcClient.bottom -= 30;
	rcClient.bottom = rcSearchBox.top - 2;
	rcClient.top = max(rcClient.bottom - m_nSearchWndHeight, 206);
	rcClient.left += 58;
	rcClient.right -= 1;
	return rcClient;
}

LRESULT MainFrame::OnKillFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	//m_PaintManager.SetFocus(NULL, false);

	return WindowImplBase::OnKillFocus(uMsg, wParam, lParam, bHandled);
}

LRESULT MainFrame::_OnMsgSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
//     CRect rcSearchWnd = GetSearchWndRect();
//     if (m_pSearchWnd != NULL && m_bShowSearchWnd)
//     {
//         m_pSearchWnd->SetClientRect(rcSearchWnd);
//     }
	if (m_bShowSearchWnd)
	{
		CloseSearchWnd();
	}
    bHandled = FALSE;
    return 0;
}

LRESULT MainFrame::_OnCommandMenuUserInfo(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled)
{
    CControlUI* pSelectedCtrl = m_PaintManager.FindSubControlByName(m_pCurSelNode->data().list_elment_,_T("logo"));
    CRect rcItem = pSelectedCtrl->GetPos(); 
    RECT rcClient = {0};
    if (m_bShowSearchWnd)
    {
        GetWindowRect(m_pSearchWnd->GetHWND(), &rcClient);
    }
    else
    {
        GetWindowRect(m_hWnd, &rcClient);
    }
    RECT rcAround = {rcClient.left + rcItem.left - 5, rcClient.top + rcItem.top, rcClient.left + rcItem.right + 5, rcClient.top + rcItem.bottom};
    GET_MESSENGER_DLG()->GetProfileDlgController()->CreateProfileDlg(m_pCurSelNode->data().value.GetData(), rcAround, GetSafeHwnd());

    return 0;
}

LRESULT MainFrame::_OnCommandMenuSendMemo(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled)
{
    std::vector<ReceiverInfo> receiverVector;
    ReceiverInfo receiverInfo;
    for (size_t i=0; i<m_vecSelectItems.size(); ++i)
    {
        receiverInfo.strID = m_vecSelectItems[i]->data().value;
        receiverInfo.strName = m_vecSelectItems[i]->data().text_; 
        receiverVector.push_back(receiverInfo);
    }

    GET_APP()->m_pSendNoteManager->CreateReceiverInfoListNote(receiverVector);
    return 0;
}

LRESULT MainFrame::_OnCommandMenuTreeSendMemo(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled)
{
    NE_MEMBER_DATA_LIST DL;
    DL.nSize = 1;

    NE_MEMBER_DATA dlData;
    dlData.strName = m_pCurSelNode->data().text_;
    CString strDL;
    strDL.Format(_T("or_%s"), m_pCurSelNode->data().value);
    dlData.strUserId = strDL;
    DL.pList = &dlData;

    GET_MESSENGER_DLG()->GetWorkGroupController()->SendMemberListMemo(DL);

    return 0;
}

LRESULT MainFrame::_OnCommandMenuChatHistory(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled)
{
    CString strID = m_pCurSelNode->data().value;
    GET_MESSENGER_DLG()->OpenChatHistoryDlg(strID);
    return 0;
}

LRESULT MainFrame::_OnCommandRangeUserIdList(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled)
{

    OnAddFavorite(nID);
    return S_OK;
}

LRESULT MainFrame::_OnCommandRangeUserIdTree(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled)
{

    OnCreateFavoriteGroup(nID);
	return S_OK;
}

LRESULT MainFrame::_OnCommandMenuChat(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled)
{
    std::vector<NE_MEMBER_DATA> memberVector;
    if(_GetSelectedMembers(memberVector, TRUE) > 0)
    {
        GET_APP()->m_pChatDialogManager->CreateMemberChat(memberVector);
    }

    bHandled = TRUE;
    return 0;
}

LRESULT MainFrame::_OnCommandMenuCreateFavoriteGroup(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled)
{

	if (g_pMessengerActor->GetBuddyGroupCount() >= MAX_GROUP)
	{	
		CString strMaxGroupCnt;
		strMaxGroupCnt.Format(IDS_STRING227, MAX_GROUP);
		NMessageBox(CWnd::FromHandle(m_hWnd), strMaxGroupCnt);

		return S_OK;
	}

	if (m_pSearchWnd != NULL)
	{
		m_pSearchWnd->EnableCloseWindow(FALSE);
		m_pSearchWnd->ShowWindow(false, false);
	}

	CCreateNewGroupWnd favCreateDlg(m_hWnd);

    GET_MESSENGER_DLG()->RegisterDuiModalWnd(&favCreateDlg);
    int nRet = favCreateDlg.ShowModal();
    GET_MESSENGER_DLG()->UnRegisterDuiModalWnd(&favCreateDlg);

	if (nRet == IDOK)
	{
		m_GroupList.clear();

		int nGroupID = favCreateDlg.GetCreatedGroupID();
		m_GroupList.insert(std::make_pair(WM_USER_ID_FAVORITE_BUTTON, nGroupID));

		if (m_ePopupMenuType == TREE_POPUP_MENU)
		{
			OnCreateFavoriteGroup(WM_USER_ID_FAVORITE_BUTTON);
		}
		else 
		{
			OnAddFavorite(WM_USER_ID_FAVORITE_BUTTON);
		}
	}

	if (m_pSearchWnd != NULL)
	{
		m_pSearchWnd->EnableCloseWindow(TRUE);
		m_pSearchWnd->Close();
		m_pSearchWnd = NULL;
	}

    return S_OK;
}

LRESULT MainFrame::_OnCommandMenuSms(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled)
{
    std::vector<NE_MEMBER_DATA> memberVector;
    if(_GetSelectedMembers(memberVector, FALSE, TRUE) > 0)
    {
        GET_APP()->m_pSMSDialogManager->CreateMemberSms(memberVector);
    }
        
    bHandled = TRUE;
    return 0;
}

LRESULT MainFrame::_OnCommandMenuTreeSms(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled)
{
    if (m_pCurSelNode != NULL)
    {
        GET_MESSENGER_DLG()->GetWorkGroupController()->RequestORGGroupMemberListSMS(m_pCurSelNode->parent()->data().value, m_pCurSelNode->data().value);
    }
    return 0;
}

LRESULT MainFrame::_OnMsgMouseWheel(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    POINT pt = { GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam) };
    ::ScreenToClient(m_hWnd, &pt);
    CRect rcSearch = GetSearchWndRect();
    if (rcSearch.PtInRect(pt) && m_bShowSearchWnd)
    {
        bHandled = TRUE;
        return S_OK;
    }
    // 以上是对于searchWnd出现的情况；当searchWnd出现的时候mousewheel只对searchWnd有效；否则才会向下判断。
    bool focusAction = false;
    CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_PaintManager.FindControl(kFriendsListControlName));

    for(int i = 0; i < pFriendsList->GetRoot()->num_children(); i++)
    {
        Node* pNode = pFriendsList->GetRoot()->child(i);
        CListContainerElementUI* pListElement = (CListContainerElementUI*)(pNode->data().list_elment_);
        CEditUI* edit_groupname = static_cast<CEditUI*>(m_PaintManager.FindSubControlByName(pListElement,  _T("edit_groupname")));
        //只有在被选中项里包括“edit_groupname”且可见的情况
        if(edit_groupname && edit_groupname->IsVisible())
        {              
            focusAction = true;
            break;
        }
    }		
    if (true == focusAction)
    {
        m_PaintManager.SetFocus(NULL);
    }
    
    bHandled = FALSE;
    return 0;
}

LRESULT MainFrame::_OnMsgSysKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    if((wParam == 'M' || wParam == 'm') && GetKeyState(VK_MENU) < 0)
    {
        CControlUI* menubtn = m_PaintManager.FindControl(kMenuButtonControlName);
        if(menubtn != NULL)
        {
            OnBnClickedTopmenuButton(menubtn);
            return S_OK;
        }
    }
    return 0;
}

LRESULT MainFrame::_OnMsgKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    if((wParam == 'F' || wParam == 'f') && GetKeyState(VK_CONTROL) < 0)
    {
        CControlUI* pSearchEdit = m_PaintManager.FindControl(kSearchEdit);
        CControlUI* pSearchLable = m_PaintManager.FindControl(kSearchLabel);
        if(pSearchEdit != NULL && pSearchLable != NULL)
        {
            pSearchEdit->SetVisible(true);
            pSearchLable->SetVisible(false);
            pSearchEdit->SetFocus();
            return S_OK;
        }
    }
    return 0;
}

LRESULT MainFrame::_OnMsgCloseMainSearch(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    m_bShowSearchWnd = FALSE;
    m_pSearchWnd = NULL;
    ::SetFocus(m_hWnd);
    return 0;
}

LRESULT MainFrame::_OnMsgRequestOrgnizationMember(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    if (m_pRequestNode != NULL)
    {
        m_pRequestNode = m_pRequestNode->parent();
    }
    if (m_pRequestNode != NULL && m_pRequestNode->parent() != NULL)
    {
        CString strParentID = m_pRequestNode->parent()->data().value;
        CString strID = m_pRequestNode->data().value;
        GET_MESSENGER_DLG()->GetWorkGroupController()->RequestORGGroupMemberList(strParentID, strID,  UPDATE_VIEW_ORG);
    }
	else
	{
		if (!m_vecRequsetStatusUsers.empty())
		{
			g_pMessengerActor->RequestRegiFavoriteToPOI(m_vecRequsetStatusUsers, REGPOIGROUP_ORGCHARTDLG);
			m_vecRequsetStatusUsers.clear();
		}
	}
    return 0;
}


void MainFrame::OnCreateFavoriteGroup(int nID)
{

	GROUP_MEMU_LIST::iterator iter = m_GroupList.find(nID);
	int nGroupID = iter->second;
	if (m_pCurSelNode != NULL)
	{

		GET_MESSENGER_DLG()->GetWorkGroupController()->AddORGGroupFavorites(m_pCurSelNode->parent()->data().value, m_pCurSelNode->data().value, nGroupID);
	}
	
	return;
}


void MainFrame::OnAddFavorite(int nID)
{

	GROUP_MEMU_LIST::iterator iter = m_GroupList.find(nID);
	int nGroupID = iter->second;

	size_t nSelCount = m_vecSelectItems.size();
	if (nSelCount == 0)
	{
		NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING218));
		return;
	}

	std::vector<wstring> vecBuddyId;

	for (size_t i=0; i<m_vecSelectItems.size(); ++i)
	{
		const NE_MEMBER_DATA data = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMember(m_vecSelectItems[i]->data().value);
		CString strID = m_vecSelectItems[i]->data().value.GetData();
		if (GET_MESSENGER_DLG()->GetWorkGroupController()->IsMyID(strID))
			continue;
		vecBuddyId.push_back((LPCWSTR)strID) ;
		
	}

	if (vecBuddyId.empty() != true)
		GET_MESSENGER_DLG()->GetWorkGroupController()->AddFavoriteList(vecBuddyId, nGroupID);
}

void MainFrame::SetCurSelCtrl(Node *pNode)
{
	m_pCurSelNode = pNode;
}

UILIB_RESOURCETYPE MainFrame::GetResourceType() const
{
	return UILIB_FILE;
}

LPCTSTR MainFrame::GetResourceID() const
{
	return MAKEINTRESOURCE(101);
}

bool MainFrame::IsWindow()
{
	return true;
}

void MainFrame::DeleteBuddy( LPCWSTR strUserId, int nGroupId )
{
	m_favoriteController.DeleteBuddy(strUserId, nGroupId);

	CString strID = strUserId;
	vector<CString>::iterator it = find(m_vecAllBuddy.begin(), m_vecAllBuddy.end(), strID);
	if (it != m_vecAllBuddy.end())
	{
		m_vecAllBuddy.erase(it);
		SetBookmark(strID, BOOKMARK_DEL);
	}	
}

void MainFrame::MoveBuddy( int nFromGroupID, const IGTBuddyUser* pUser )
{
	m_favoriteController.MoveBuddy(nFromGroupID, pUser);
}

void MainFrame::UpdateStatus( IGTMessengerActor *pActor, LPCWSTR strBuddyID )
{
	m_favoriteController.UpdateStatus(pActor, strBuddyID);
	if (m_pChatListManager != NULL)
	{
		m_pChatListManager->UpdateRecentUserStatus(pActor, strBuddyID);
	}
}

void MainFrame::UpdateGroupName( const IGTBuddyGroup* pGroup )
{
	m_favoriteController.UpdateGroupName(pGroup);
}

void MainFrame::EditLableOn( const IGTBuddyGroup * pGroup /*= NULL*/ )
{
	m_favoriteController.EditLableOn(pGroup);
}

void MainFrame::DeleteGroup( int nGroupID )
{
	m_favoriteController.DeleteGroup(nGroupID);
}

void MainFrame::RedrawGroup()
{
	m_favoriteController.RedrawGroup();
}

void MainFrame::FavoriteGroupResort()
{
	m_favoriteController.GroupResort();
}

void MainFrame::ResortBuddyInGroup(int nGroupID){

   m_favoriteController.ResortBuddyInGroup(nGroupID);

}

void MainFrame::UpdateInfoAboutMeStatus( GTUserStatusType gtStatus )
{
	if(GetSafeHwnd() == NULL)
	{
		return;
	}
	GT_MY_USER_DATA myUserData;
	g_pMessengerActor->GetMyUserInfo(myUserData);

	CString strMsg = (_T(""));
	strMsg.Format(_T("%s"), myUserData.sMyPage.strTalkName);
	CEditUI* pEditSign =  static_cast<CEditUI*>(m_PaintManager.FindControl(kMainFrameSignture));
	pEditSign->SetText(strMsg);

	strMsg.Format(_T("%s"), GetPresenceTip(myUserData.eUserStatusType));
	CTextUI* pNameText =  static_cast<CTextUI*>(m_PaintManager.FindControl(_T("status")));
	pNameText->SetText(strMsg);
	pNameText->GetParent()->NeedUpdate();

	CButtonUI* pHead = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btnInfoMe")));
	
	CDuiString strImage;
	CString strUserImagePath = GET_APP()->GetProfileImagePath(myUserData.strUserID);
	pHead->SetBkImage(strUserImagePath);
}

GTUserStatusType MainFrame::GetMyStatus()
{
	//TODO Fix the 2 lines follows
	GT_MY_USER_DATA myUserData;
	g_pMessengerActor->GetMyUserInfo(myUserData);
	GTUserStatusType gtStatus = myUserData.eUserStatusType;
	return gtStatus;
}

void MainFrame::UpdateInfoAboutMeNickName( CString strNickName )
{
	GT_MY_USER_DATA myUserData;
	g_pMessengerActor->GetMyUserInfo(myUserData);

	CString strMsg = (_T(""));
	strMsg.Format(_T("%s"), myUserData.sMyPage.strTalkName);
	CEditUI* pEditSign =  static_cast<CEditUI*>(m_PaintManager.FindControl(kMainFrameSignture));
	if (pEditSign != NULL)
	{
		pEditSign->SetText(strMsg);
	}

	GET_CONFIG()->SetNickName(myUserData.sMyPage.strTalkName);
}

void MainFrame::SetEditNickName( BOOL bEdit )
{
	//TODO
}

void MainFrame::UpdateInfoVolume( UINT nTotalUsedCapa, UINT nLimitedCapa )
{
	//TODO
	g_stNtalkInfo.nCapacity = nLimitedCapa - nTotalUsedCapa;
	//config a volume control
}

LRESULT MainFrame::_OnMsgUserImageUpdated(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    CString* pStr = NULL;
    pStr = (CString*)wParam;
    if(pStr != NULL)
    {
        OnUserImageUpdated(*pStr);
        if(pStr != NULL)
        {
            delete pStr;
            pStr = NULL;
        }
    }
    return 0;
}

void MainFrame::OnUserImageUpdated(CString strUserId)
{
	UpdateItemImage(strUserId);
}

void MainFrame::CloseAllInternetHandle()
{
	if (m_hHttpFile != NULL)
	{
		InternetCloseHandle(m_hHttpFile);
		m_hHttpFile = NULL;
	}

	if (m_hHttpConnection != NULL)
	{
		InternetCloseHandle(m_hHttpConnection);
		m_hHttpConnection = NULL;
	}

	if (m_hInternetSession != NULL)
	{
		InternetCloseHandle(m_hInternetSession);
		m_hInternetSession = NULL;
	}

	m_FileToWrite.Close();
}


void CALLBACK MainFrame::_OnStatusCallBack(HINTERNET hInternet, DWORD_PTR dwContext, DWORD dwInternetStatus, 
											 LPVOID lpvStatusInformation, DWORD dwStatusInformationLength)
{
	switch (dwInternetStatus)
	{
	case INTERNET_STATUS_RESOLVING_NAME:
		{
			TRACE(_T("INTERNET_STATUS_RESOLVING_NAME\n"));    
			break;
		}
	case INTERNET_STATUS_NAME_RESOLVED:
		{
			TRACE(_T("INTERNET_STATUS_NAME_RESOLVED\n"));    
			break;
		}
	case INTERNET_STATUS_CONNECTING_TO_SERVER:
		{
			TRACE(_T("INTERNET_STATUS_CONNECTING_TO_SERVER\n"));    
			break;
		}
	case INTERNET_STATUS_CONNECTED_TO_SERVER:
		{
			TRACE(_T("INTERNET_STATUS_CONNECTED_TO_SERVER\n"));    
			break;
		}
	case INTERNET_STATUS_REDIRECT:
		{
			TRACE(_T("INTERNET_STATUS_REDIRECT\n"));    
			break;
		}
	case INTERNET_STATUS_REQUEST_SENT:
		{
			TRACE(_T("INTERNET_STATUS_REQUEST_SENT\n"));    
			break;
		}
	case INTERNET_STATUS_REQUEST_COMPLETE:
		{
			TRACE(_T("INTERNET_STATUS_REQUEST_COMPLETE\n"));    
			break;
		}
	default:
		{
			break;
		}
	}
}

void MainFrame::StartNoticeList( const std::vector<NE_NOTICE_DATA> &vecNoticeList )
{

	if (TRUE != m_bEnableNotice)
		return;

	if (vecNoticeList.size() <= 0 )
		return;


	m_vecNoticeList.clear();

	m_vecNoticeList = vecNoticeList;
	/*if (::IsWindow(m_pBannerNotice->GetHWND()))
	{
		m_pBannerNotice->ShowWindow(true,false);
	}

	SetTimer(TID_NOTICE_ROLLING,1000*2);*/

}

void MainFrame::SetBannerList( const std::vector<NE_BANNER_DATA> &vecBannerList )
{
	//TODO
	m_InfoBannerCtrller.SetBannerList(vecBannerList);
}

void MainFrame::SetInfoItemCount( NTHanatourCountType eType, int nCount, CString strURL )
{
	m_mainMenuControler.SetInfoItem(eType,nCount,strURL);
	
}

void MainFrame::RedrawOutlink()
{
	//TODO
}

void MainFrame::SetInfoItemNoteItemCount( int nCount )
{
	//TODO
}

void MainFrame::SetInfoItemMailItemCount( int nCount )
{
	//TODO
}

void MainFrame::CloseCallHistoryDlg()
{
	if (m_pCallHistoryDlg)
	{
		if (m_pCallHistoryDlg->GetSafeHwnd())
			m_pCallHistoryDlg->DestroyWindow();

		delete m_pCallHistoryDlg;
		m_pCallHistoryDlg = NULL;
	}
}

void MainFrame::OpenChatHistoryDlg( CString UserID )
{
	//TODO
	/*CString strTicket = CString(g_pMessengerActor->GetMessengerTicket());

	CString strUrl;	
	strUrl.Format(NTALK_CHAT_HISTORY_URL, strTicket, m_MainDlg.GetUserID_Base64(UserID));
	CXHyperLink::GotoURL(strUrl, SW_SHOWNORMAL);*/
}

void MainFrame::CloseAutoTextDlg()
{
	if(m_AutoTextConfigDlg.GetSafeHwnd())
	{
		m_AutoTextConfigDlg.CloseDlg();
	}
}

BYTE MainFrame::GetDND()
{
	return m_nDndStatus;
}

void MainFrame::SetForwardingStatus( BYTE nForwarding )
{
	m_nForwardingStatus = nForwarding;
}

BYTE MainFrame::GetForwardingStatus()
{
	return m_nForwardingStatus;
}

void MainFrame::SetDND( BYTE nStatus )
{
	m_nDndStatus = nStatus;
}

void MainFrame::OnBnClickedTopmenuButton(CControlUI* pMenuBtn)
{
	//트리 컨트롤이 편집 중인 상태를 종료 시키기 위해 필요
	//pMenuBtn->SetFocus();

	//모달 다이얼로그가 있는 상태이므로 메뉴를 만들지 말아야함.
	if (g_ModalBoxCount != 0)
		return;

	CString strMenuText;

	CRect rectTopMenu(0, 0, 0, 0);
    POINT pt = {0};

	CMenuXP* pMenu = new CMenuXP;
	CMenuXP* pCallGroupItem = NULL;

	rectTopMenu = pMenuBtn->GetPos();	

	CRect rtDlg(0, 0, 0, 0);
	GetWindowRect(m_hWnd, &rtDlg);

	pt.x = rtDlg.left + rectTopMenu.left;
	pt.y = rtDlg.top + rectTopMenu.bottom;

	pMenu->CreatePopupMenu();
    XpMenuFacadeInit(pMenu);

	strMenuText.LoadString(IDS_STRING113);//로그아웃
	pMenu->AppendODMenu(0, new CMenuXPText(ID__LOGOUT, strMenuText));
	strMenuText.LoadString(IDS_STRING114);//항상위

	pMenu->AppendODMenu(GET_MESSENGER_DLG()->IsTopMost() == TRUE ? MF_CHECKED : MF_UNCHECKED, new CMenuXPText(ID__ALWAYSTOP, strMenuText));
	strMenuText.LoadString(IDS_STRING116);//끝내기
	pMenu->AppendODMenu(0, new CMenuXPText(ID__EXIT, strMenuText));

	pMenu->AppendSeparator();	

	int nImage = 0, nSelectedImage = 0;

	// 	UINT nFlags;
	// 
	// 	// 대화 하기
	// 	nFlags = MF_GRAYED;
	// 	const int onlineFavoritesCount = m_MainDlg.GetSelectedOnlineFavoritesCount();
	// 	if (onlineFavoritesCount > 0)
	// 	{
	// 		nFlags = MF_ENABLED;
	// 	}
	// 
	// 	strMenuText.LoadString(IDS_STRING117);	
	// 	pMenu->AppendODMenu(nFlags, new CMenuXPText(ID__CHAT, strMenuText));	

	// 쪽지 보내기
	const int selectedFavoritesCount = GetSelectedFavoritesCount();
	strMenuText.LoadString(IDS_STRING118); 

	// [BTS] NTALKBIZSUS-354 --> 수신자 없는 신규 쪽지 쓰기 창 필요
	//	pMenu->AppendODMenu(selectedFavoritesCount < 1 ? MF_GRAYED : MF_ENABLED, new CMenuXPText(ID__SEND_MEMO, strMenuText));
	pMenu->AppendODMenu(MF_ENABLED, new CMenuXPText(ID__SEND_MEMO, strMenuText));
	// [BTS] NTALKBIZSUS-354 <--

	// SMS 보내기
	strMenuText.LoadString(IDS_STRING293);

#ifdef _DEBUG
	pMenu->AppendODMenu(GET_CONFIG()->EnableFunction(_T("ME_01")) == TRUE ? MF_ENABLED : MF_ENABLED, new CMenuXPText(ID__SMS, strMenuText));
#else
	pMenu->AppendODMenu(GET_CONFIG()->EnableFunction(_T("ME_01")) == TRUE ? MF_ENABLED : MF_GRAYED, new CMenuXPText(ID__SMS, strMenuText));
#endif

	if (GET_APP()->IsAvailableIPT())
	{
		// 전화	
		pCallGroupItem = new CMenuXP;
		pCallGroupItem->CreatePopupMenu();
        XpMenuFacadeInit(pCallGroupItem);

		NTIPTStatusType iptPresence = g_pMessengerActor->GetMyIptStatus();
		int nSelectedUserCnt = GetSelectedFavoritesCount();

		CDialPadManager* pManager = CDialPadManager::GetDialpadManager();

		// 전화 걸기
		strMenuText.LoadString(IDS_TOPMENU_MAKECALL);
		if( iptPresence == iptstIDLE || iptPresence == iptstDND )
			pCallGroupItem->AppendODMenu(MF_ENABLED, new CMenuXPText(ID__MAKE_CALL, strMenuText));
		else
			pCallGroupItem->AppendODMenu(MF_GRAYED, new CMenuXPText(ID__MAKE_CALL, strMenuText));

		// 전화 받기
		strMenuText.LoadString(IDS_TOPMENU_ANSWERCALL);
		if( iptPresence == itpstALERTING && pManager->GetCallingStatus() != true )
			pCallGroupItem->AppendODMenu(MF_ENABLED, new CMenuXPText(ID__ANSWER_CALL, strMenuText));
		else
			pCallGroupItem->AppendODMenu(MF_GRAYED, new CMenuXPText(ID__ANSWER_CALL, strMenuText));

		// 전화 끊기
		strMenuText.LoadString(IDS_TOPMENU_CLEARCONNECTION);
		if( iptPresence == iptstACTIVE || iptPresence == itpstALERTING )
			pCallGroupItem->AppendODMenu(MF_ENABLED, new CMenuXPText(ID__CLEAR_CONNECTION, strMenuText));
		else
			pCallGroupItem->AppendODMenu(MF_GRAYED, new CMenuXPText(ID__CLEAR_CONNECTION, strMenuText));

	

		pCallGroupItem->AppendSeparator();

		strMenuText = LoadStringFromResource(IDS_STRING583);
		if( iptPresence == iptstACTIVE )
			pCallGroupItem->AppendODMenu(MF_ENABLED, new CMenuXPText(ID__CONFERENCE_CALL, strMenuText));
		else
			pCallGroupItem->AppendODMenu(MF_GRAYED | MF_DISABLED, new CMenuXPText(ID__CONFERENCE_CALL, strMenuText));


		// 호 전환
		strMenuText.LoadString(IDS_IPT_CALLTRANSFER);
		if( iptPresence == iptstACTIVE )
			pCallGroupItem->AppendODMenu(MF_ENABLED, new CMenuXPText(ID_IPT_CALLTRANSFER, strMenuText));
		else
			pCallGroupItem->AppendODMenu(MF_GRAYED, new CMenuXPText(ID_IPT_CALLTRANSFER, strMenuText));

		pCallGroupItem->AppendSeparator();

		// 착신전환 설정 / 설정해제
		if( GetForwardingStatus() == 0 )
			strMenuText.LoadString(IDS_TOPMENU_FORWARDING);
		else
			strMenuText = LoadStringFromResource(IDS_STRING608);
		if( iptPresence == iptstACTIVE )
			pCallGroupItem->AppendODMenu(MF_GRAYED, new CMenuXPText(ID__FORWARDING, strMenuText));
		else
			pCallGroupItem->AppendODMenu(MF_ENABLED, new CMenuXPText(ID__FORWARDING, strMenuText));

		// 수신차단(통화차단)
		if( iptPresence == iptstACTIVE )
		{
			if( GetDND() == 0 )
			{
				strMenuText.LoadString(IDS_TOPMENU_DND_TRUE);
				pCallGroupItem->AppendODMenu(MF_GRAYED, new CMenuXPText(ID__DO_NOT_DISTURB_TRUE, strMenuText));
			}
			else
			{
				strMenuText.LoadString(IDS_TOPMENU_DND_FALSE);
				pCallGroupItem->AppendODMenu(MF_GRAYED, new CMenuXPText(ID__DO_NOT_DISTURB_FALSE, strMenuText));
			}
		}
		else
		{
			if( GetDND() == 0 )
			{
				strMenuText.LoadString(IDS_TOPMENU_DND_TRUE);
				pCallGroupItem->AppendODMenu(MF_ENABLED, new CMenuXPText(ID__DO_NOT_DISTURB_TRUE, strMenuText));
			}
			else
			{
				strMenuText.LoadString(IDS_TOPMENU_DND_FALSE);
				pCallGroupItem->AppendODMenu(MF_ENABLED, new CMenuXPText(ID__DO_NOT_DISTURB_FALSE, strMenuText));
			}

		}


		strMenuText.LoadString(IDS_TOPMENU_CALL);
		pMenu->AppendODPopup(MF_ENABLED, pCallGroupItem, new CMenuXPText(0, strMenuText));
	}


	pMenu->AppendSeparator();

	strMenuText.LoadString(IDS_STRWEBSERVICE);		// 받은파일보기
	pMenu->AppendODMenu(MF_ENABLED, new CMenuXPText(ID__WEB_SERVICE, strMenuText));

	strMenuText.LoadString(IDS_STRING480);		// 받은파일보기
	pMenu->AppendODMenu(MF_ENABLED, new CMenuXPText(ID__OPEN_DOWNLOAD_FOLDER, strMenuText));

	
	BOOL bGroup = FALSE;//m_MainDlg.IsGroupSelected();
	

	if( GET_APP()->IsAvailableIPT() )
	{
		strMenuText.LoadString(IDS_TOPMENU_MANAGECALL); //전화내역
		pMenu->AppendODMenu(MF_ENABLED, new CMenuXPText(ID__MANAGE_CALL, strMenuText));
	}
	
	pMenu->AppendSeparator();

	strMenuText.LoadString(IDS_STRING128);		// 환경 설정
	pMenu->AppendODMenu(MF_ENABLED, new CMenuXPText(ID__MANAGE_CONFIG, strMenuText));

	// Add test setting for test new setting by shi yan
	//strMenuText = _T("Test Setting");		// 환경 설정
	//pMenu->AppendODMenu(MF_ENABLED, new CMenuXPText(ID_TEST_SETTING, strMenuText));


	strMenuText.LoadString(IDS_STRING302); // 프로그램 정보
	pMenu->AppendODMenu(MF_ENABLED, new CMenuXPText(ID__ABOUT, strMenuText));


	//strMenuText.LoadString(IDS_STRING129);		// 도움말
	//pMenu->AppendODMenu(MF_ENABLED, new CMenuXPText(ID__HELP_NEMESSENGER, strMenuText));

	if( selectedFavoritesCount < 1 )
	{
		pMenu->EnableMenuItem(ID__CHAT, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
		//		pMenu->EnableMenuItem(ID__SEND_MEMO, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);	// [BTS] NTALKBIZSUS-354
		pMenu->EnableMenuItem(ID__DEL, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	}	
	int nIndex = pMenu->TrackPopupMenu(TPM_LEFTBUTTON | TPM_RETURNCMD | TPM_RIGHTBUTTON, pt.x, pt.y, CWnd::FromHandle(m_hWnd));

	CControlUI* menubtn = m_PaintManager.FindControl(kMenuButtonControlName);
	if(NULL != menubtn)
	{
		m_PaintManager.SetFocus(NULL);
	}
	CommandMessageRouter(nIndex);
	SAFE_DELETE(pCallGroupItem);
	SAFE_DELETE(pMenu);

	PostMessage(WM_NCMOUSELEAVE, 0, 0);

}

void MainFrame::CommandMessageRouter( int nId )
{
	GET_MESSENGER_DLG()->PostMessage(WM_COMMAND, nId, 0);
}

void MainFrame::ReleaseChatRoomList()
{
	//throw std::exception("The method or operation is not implemented.");
}

void MainFrame::GetSelectedOnlineFavorites( std::vector<const IGTBuddyUser *> buddyVector )
{
	m_favoriteController.GetSelectedOnlineFavorites(buddyVector);
}

void MainFrame::GetSelectedBuddyItems( std::vector<const IGTBuddyUser *>& buddyVector )
{
	m_favoriteController.GetSelectedBuddyItems(buddyVector);
}

void MainFrame::GetSelectedGroupItems( std::vector<const IGTBuddyGroup *>& GroupVector )
{
	m_favoriteController.GetSelectedGroupItems(GroupVector);
}

void MainFrame::RequestDeleteBuddy()
{
	m_favoriteController.RequestDeleteBuddy();
}

void MainFrame::RequestAddGroup()
{
	m_favoriteController.RequestAddGroup();
}

void MainFrame::RequestDeleteGroup()
{
	m_favoriteController.RequestDeleteGroup();
}

CString MainFrame::GetLanguage()
{
	CString strLang = _T("");

	if (g_stNtalkInfo.nLang == 0)
		strLang = _T("ko_KR");
	else if (g_stNtalkInfo.nLang == 1)
		strLang = _T("en_US");
	else if (g_stNtalkInfo.nLang == 2)
		strLang = _T("ja_JP");
	else if (g_stNtalkInfo.nLang == 4)
		strLang = _T("zh_CN");
	else if (g_stNtalkInfo.nLang == 3)
		strLang = _T("zh_TW");

	return strLang;
}

CString MainFrame::GetUserID_Base64( CString UserID )
{
	USES_CONVERSION;
	CAESCrypto crypto;

	char *pszAnsiID = W2A(UserID);

	if (!pszAnsiID)
		return _T("");

	char szBase64ID[128] = {0,};
	int nB64Len = 0;

	crypto.Base64Encode((const BYTE*)pszAnsiID, strlen(pszAnsiID), szBase64ID, &nB64Len, BASE64_FLAG_NOCRLF);

	return CString(szBase64ID);
}

void MainFrame::ImportGroup()
{
	m_favoriteController.ImportGroup();
}

void MainFrame::MenuCopyBuddy( UINT nCmdID, int nId )
{
	m_favoriteController.MenuCopyBuddy(nCmdID, nId);
}

void MainFrame::MenuMoveBuddy( UINT nCmdID, int nId )
{
	m_favoriteController.MenuMoveBuddy(nCmdID, nId);
}

//void MainFrame::SetTimer( int nId, int nElapse, void* pProc )
//{
//	::SetTimer(m_hWnd, nId, nElapse, (TIMERPROC)pProc);
//}

void MainFrame::KillTimer( int nId )
{
	//::KillTimer(m_hWnd, nId);
    CControlUI* pControl = m_PaintManager.FindControl(kOrganization);
    if (pControl)
    {
        m_PaintManager.KillTimer(pControl, nId); //, REFRESH_TICKET_TIMER);
    }
}

void MainFrame::SetBannerControl(CString strBannerFilePath){

    CControlUI* pControl = m_PaintManager.FindControl(_T("bannerInfo"));
	static DWORD clr= 0xFFFF0000;
    
	clr = clr >>1;
	if (pControl)
	{
		//pControl->SetBkColor(clr);
		pControl->SetBkImage(strBannerFilePath);
	}
}

void MainFrame::DoInfoItemSurvey()
{
	if (m_mainMenuControler.GetInfoItemURL(hanatourPoll).IsEmpty())
	{
		return;
	}

	CString strLoginParam = MakeHanatourLoginData(LoadStringFromResource(IDS_STRING_MAIN_SURVEY));
	if (strLoginParam.IsEmpty())
		return;

	CString strURL;
	strURL.Format(_T("%s?whoAmI=H&loginType=S&crm=Y&crmTabMenuInit=Y&%s&crmRedirectValue=33"), m_mainMenuControler.GetInfoItemURL(hanatourPoll), strLoginParam);

	OpenURLService(strURL);
}

void MainFrame::DoInfoItemChatHistory(){

	CString strTicket = CString(g_pMessengerActor->GetMessengerTicket());

	CString strUrl;	
	strUrl.Format(CServerAddrConfig::Instance().GetChatHistoryUrl() , strTicket, _T("")); //NTALK_CHAT_HISTORY_URL
	CXHyperLink::GotoURL(strUrl, SW_SHOWNORMAL);
}


void MainFrame::DoInfoItemMail()
{
	CString strTicket = CString(g_pMessengerActor->GetMessengerTicket());
	CString strLang = GetLanguage();

	CString strUrl = _T("");
	if( g_stNtalkInfo.strCorp == _T("hanatour") )
	{
		strUrl.Format(CServerAddrConfig::Instance().GetNTalkMailUrl(), strTicket, strLang); //NHNCORP_MAIL_URL

		if (TRUE == CXHyperLink::UseAlreadyOpenedIE(_T("nmail.ncloudbiz.com")))
			return;
	}
	else
	{
		strUrl.Format(CServerAddrConfig::Instance().GetNhnCorpMailUrl(), strTicket, strLang); //NHNCORP_MAIL_URL

		if (TRUE == CXHyperLink::UseAlreadyOpenedIE(_T("mail.nhncorp.com")))
			return;
	}

	CXHyperLink::GotoURL(strUrl, SW_SHOWNORMAL);
}
void MainFrame::DoInfoItemNote()
{
	CString strTicket = CString(g_pMessengerActor->GetMessengerTicket());
	CString strLang = GetLanguage();

	CString strUrl = _T("");

    strUrl.Format(CServerAddrConfig::Instance().GetMessageUrl() , strTicket, strLang);  //NTALK_MESSAGE_URL

	if (TRUE == CXHyperLink::UseAlreadyOpenedIE(_T("nnote.ncloudbiz.com"), _T("talk")))
		return;

	CXHyperLink::GotoURL(strUrl, SW_SHOWNORMAL);
}

void MainFrame::MoveWindow( CRect rcClient, BOOL bRepaint )
{
	::MoveWindow(m_hWnd, rcClient.left, rcClient.top, rcClient.Width(),
		rcClient.Height(), bRepaint);
}

HWND MainFrame::GetSafeHwnd() const
{
	return this == NULL ? NULL : m_hWnd;
}

void MainFrame::DestroyWindow()
{
	::DestroyWindow(m_hWnd);
}

void MainFrame::SetInfoBtnCount( int nAuthCount )
{
	//m_nInfoBtnCount = nCount;
}

void MainFrame::__ResourceLoad()
{
	//throw std::exception("The method or operation is not implemented.");
}

void MainFrame::LoadAboutMeStatusPopup(CPoint pt)
{
	CMenuXP* pMenu = new CMenuXP;
	if (!pMenu)
		return;

	MakeAboutMeSatusPopupMenu(pMenu);

	int nCmdID = pMenu->TrackPopupMenu(TPM_LEFTBUTTON | TPM_RETURNCMD | TPM_RIGHTBUTTON, pt.x, pt.y, CWnd::FromHandle(m_hWnd));

	delete pMenu;

	//if ((GTUserStatusType)nCmdID < ustONLINE || (GTUserStatusType)nCmdID > ustAUTOAWAY)
	//	return;

	if(nCmdID == 0)
		return;

	if(nCmdID == 2) // new UX set off line to 0x2
	{
		GET_MESSENGER_DLG()->PostMessage(WM_LOGOUT, 0 ,0);
		return;
	}

	if(nCmdID == ustMEETING)
	{
		nCmdID = ustAWAY;
	}

	if(nCmdID == ustEAT)
	{
		nCmdID = ustBUSY;
	}

	else if(nCmdID == ustOUTSIDE)
	{
		nCmdID = ustEAT;
	}

	else if(nCmdID == ustBUSY)
	{
		nCmdID = ustOUTSIDE;
	}

	GET_MESSENGER_DLG()->ProcChangeMyStatus((GTUserStatusType)(nCmdID));
}

BOOL MainFrame::MakeAboutMeSatusPopupMenu( CMenu* pMenuStatus )
{
	CMenuXP* pXpMenu = dynamic_cast<CMenuXP*>(pMenuStatus);
	ASSERT(pXpMenu);
	if (pXpMenu)
	{
		pXpMenu->CreatePopupMenu();
        XpMenuFacadeInit(pXpMenu);

		CString strRes;
		strRes.LoadString(IDS_STRING131);
		pXpMenu->AppendODMenu(0, new CMenuXPText(1, strRes, AfxGetApp()->LoadIcon(IDI_IC_ONLINE)));
// 		strRes.LoadString(IDS_STRING113);
// 		pXpMenu->AppendODMenu(0, new CMenuXPText(2, strRes, AfxGetApp()->LoadIcon(IDI_IC_AFK)));


		//strRes.LoadString(IDS_STRING135);
		//pMenu->AppendODMenu(0, new CMenuXPText(5, strRes, AfxGetApp()->LoadIcon(IDI_IC_TELBUSY)));

		strRes.LoadString(IDS_STRING132);
		pXpMenu->AppendODMenu(0, new CMenuXPText(6, strRes, AfxGetApp()->LoadIcon(IDI_IC_MEETBUSY)));


		strRes.LoadString(IDS_STRING133);
		pXpMenu->AppendODMenu(0, new CMenuXPText(5, strRes, AfxGetApp()->LoadIcon(IDI_IC_OTHERBUSY)));

		strRes.LoadString(IDS_STRING134);
		pXpMenu->AppendODMenu(0, new CMenuXPText(3, strRes, AfxGetApp()->LoadIcon(IDI_IC_STEPOUT)));

		strRes.LoadString(IDS_STRING136);
		pXpMenu->AppendODMenu(0, new CMenuXPText(4, strRes, AfxGetApp()->LoadIcon(IDI_IC_EATBUSY)));

		//strRes.LoadString(IDS_STRING138);
		//pMenu->AppendODMenu(0, new CMenuXPText(8, strRes, AfxGetApp()->LoadIcon(IDI_IC_OFFLINE)));
	}

	return TRUE;
}


BOOL MainFrame::IsMobileOnline()
{
	return FALSE;
	//throw std::exception("The method or operation is not implemented.");
}

void MainFrame::AddChatRoomList(CChatDlg* pChatDlg)
{
	if ((m_pChatListManager != NULL) && (-1 == m_pChatListManager->FindChatRoomIndex(pChatDlg->GetRoomID())))
	{
		m_pChatListManager->AddChatRoomList(pChatDlg);
	}

	CTabLayoutUI* pTabControl = static_cast<CTabLayoutUI*>(m_PaintManager.FindControl(kTabControlName));
	if (pTabControl && (pTabControl->GetCurSel() == eRecentChatTab))
	{
		ShowNoUserInRecentChatList();
	}
}

void MainFrame::UpdateAllChatRoomTime()
{
	if (m_pChatListManager != NULL)
	{
		m_pChatListManager->UpdateAllChatRoomTime();
	}
}

void MainFrame::ResortChatRoomList(vector <ChatRoomItem*> &vecChatItem)// vecChatDlg is Sorted vector（排好序的vector）
{
	if (m_pChatListManager != NULL)
	{
		m_pChatListManager->ResortChatRoomList(vecChatItem);
	}
}

void MainFrame::AddChatRoomList(const NE_MYROOM_DATA& myRoomData)
{
	if ((m_pChatListManager != NULL) && (-1 == m_pChatListManager->FindChatRoomIndex(myRoomData.nRoomID)))
	{
		m_pChatListManager->AddChatRoomList(myRoomData);
	}

	CTabLayoutUI* pTabControl = static_cast<CTabLayoutUI*>(m_PaintManager.FindControl(kTabControlName));
	if (pTabControl && (pTabControl->GetCurSel() == eRecentChatTab))
	{
		ShowNoUserInRecentChatList();
	}
}

void MainFrame::UpdateChatRoomList(CChatDlg* pChatDlg, BOOL bSort )
{
	//NTALK_LOG->Debug(L"void MainFrame::UpdateChatRoomList( int nRoomNo, BOOL bGroup, CString strUserName, CTime time, BOOL bSort )");
	if(m_pChatListManager)
	{
		m_pChatListManager->UpdateChatRoomList(pChatDlg, bSort);
	}
}

BOOL MainFrame::FindSingleChatDlg(LPCTSTR strUserID, int nRoomID)
{
	return m_pChatListManager->FindSingleChatDlg(strUserID, nRoomID);
}

int MainFrame::GetInfoItemNoteItemCount()
{
	return 0;
	//throw std::exception("The method or operation is not implemented.");
}

CRecentContacts* MainFrame::GetRecentContacts()
{
	return &m_recentContacts;
}

void MainFrame::RemoveChatRoom( int nRoomID, BOOL bDeleteData )
{
	if (m_pChatListManager != NULL)
	{
		m_pChatListManager->RemoveChatRoom(nRoomID, bDeleteData);
	}
	CTabLayoutUI* pTabControl = static_cast<CTabLayoutUI*>(m_PaintManager.FindControl(kTabControlName));
	if (pTabControl && (pTabControl->GetCurSel() == eRecentChatTab))
	{
		ShowNoUserInRecentChatList();
	}
}

void MainFrame::SetRecentChatDlg(int nRoomID, CChatDlg *pChatDlg)
{
	if (m_pChatListManager != NULL)
	{
		m_pChatListManager->SetItemChatDlg(nRoomID, pChatDlg);
	}
}

FavoriteController* MainFrame::GetFavoriteController()
{
	return &m_favoriteController;
}

CBuddyTreeCtrl* MainFrame::GetFavoriteTreeCtrl()
{
	return m_favoriteController.GetTreeCtrl();
}

void MainFrame::UpdateAllBuddyDisplayNames()
{
	m_favoriteController.UpdateAllBuddyDisplayNames();
}

void MainFrame::InitControls()
{
	CChatRoomList* pChattingList = static_cast<CChatRoomList*>(m_PaintManager.FindControl(kChattingListControlName));
	ASSERT(pChattingList != NULL);
	m_pChatListManager->InitChatRoomList(pChattingList);
}

void MainFrame::OnUserImageActor_OnResponseUserImageInfo(CString strUserId)
{
	PostMessage(WM_USERIMAGE_UPDATED, (WPARAM)(new CString(strUserId)), 0);
}

vector<CString> MainFrame::GetSelectedItemNameVector(_E_MENUTAB DragType){

   std::vector<CString> selectUserName;
   if (eFavoriteTab == DragType)
   {
	   	std::vector<const IGTBuddyUser*> selectUser;
		

		std::vector<Node*> vecSelectedItem = m_favoriteController.GetSelectedItems();
		for (size_t i = 0; i < vecSelectedItem.size(); i++)
		{
			if (vecSelectedItem[i]->folder() && !vecSelectedItem[i]->IsRoot())
			{
				continue;
			}

			//const IGTBuddyUser *pUser = (const IGTBuddyUser *)vecSelectedItem[i]->GetNodeUserData();

			CString usrID = vecSelectedItem[i]->data().value;
			const IGTBuddyUser* pUser = g_pMessengerActor->GetAvailbeBuddyInfo(usrID); 

			if (!IsFindByID_UserVector(selectUser, pUser->GetUserID()))
			{
				selectUser.push_back(pUser);
				selectUserName.push_back(pUser->GetName());
			}
		}
   }
   else if (eOrganizationTab == DragType)
   {
	   std::vector<Node*> vecSelectedItem = m_pOrgList->GetSelectedItems();

	   for (size_t i = 0; i < vecSelectedItem.size(); i++)
	   {
		   Node* pNode = vecSelectedItem[i];		
    //      if (!pNode->folder() && !pNode->IsRoot()) //It's a leaf node;
           {
			   CString strCurID = pNode->data().value;
			   selectUserName.push_back(strCurID);
           }
		  
	   }
   }
   return selectUserName;

}

void MainFrame::GetSelectedOrgItems(std::vector<Node*> &vecSelectedOrgUser){

	std::vector<Node*> vecSelectedItem = m_pOrgList->GetSelectedItems();

	for (size_t i = 0; i < vecSelectedItem.size(); i++)
	{
		Node* pNode = vecSelectedItem[i];	
		if (!pNode->IsRoot() && !pNode->folder())
		{
			vecSelectedOrgUser.push_back(pNode);			

		}

	}


}
void MainFrame::OnDragStart(_E_MENUTAB DragType)
{
	OutputDebugString(_T("OnDragStart()\n"));
	
	if (eOrganizationTab == DragType)
	{
		if (m_pOrgList == NULL)
		{
			return;
		}
		std::vector<Node*> vecSelectedOrgUser;
		GetSelectedOrgItems(vecSelectedOrgUser);// get user data, folder not included;

		if (vecSelectedOrgUser.size() > 0 )
		{
			vector<CString> vecSelectedName = GetSelectedItemNameVector(eOrganizationTab);
			m_pImgList = CreateDragImageEx(vecSelectedName);

			CSharedFile file;
			CArchive ar(&file, CArchive::store);

			ar << vecSelectedOrgUser.size();

			for (std::vector<Node*>::iterator buddyIter = vecSelectedOrgUser.begin(); buddyIter!=vecSelectedOrgUser.end();
				++buddyIter)
			{
				Node* pNode = *buddyIter;
					
				CString strID = pNode->data().value;// (IGTBuddyUser*)(pNode->GetNodeUserData());			
                const NE_MEMBER_DATA data = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMember(strID);
				
				CNtalkDragData dropUser;
				dropUser.m_hWndSrc = m_hWnd;
				dropUser.SetOrgUser(&data, ar);
				
			} 
			
			
			ar.Close();
			COleDataSource oleDataSource;
			oleDataSource.CacheGlobalData(m_uClipBoardFormat, file.Detach());
			oleDataSource.DoDragDrop();
		} 
	} 
	else if(eFavoriteTab == DragType)
	{
		std::vector<Node*> vecSelectedBuddyUser;// = m_favoriteController.GetSelectedBuddyItems();
		std::vector<CString> vecName;
		std::vector<Node*> vecSelectedGroup;

		std::vector<Node*> vecSelectedItem = m_favoriteController.GetSelectedItems();

		for (size_t i = 0; i < vecSelectedItem.size(); i++)
		{
			Node* pNode = vecSelectedItem[i];
			if (pNode->folder() && !pNode->IsRoot())
			{
				vecSelectedGroup.push_back(pNode);
			}
			else
			{
				CString strCurID = pNode->data().value;
				const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfo(strCurID);
				if ( NULL == pUser )
				{
					pUser = g_pMessengerActor->GetBuddyInfoFromPersist(strCurID);
				}
				if (!IsFindByID_UserNodeVector(vecSelectedBuddyUser, strCurID))
				{
					vecSelectedBuddyUser.push_back(pNode);
					/*const IGTBuddyUser* pUser = (IGTBuddyUser*)(pNode->GetNodeUserData());
					ASSERT(pUser);*/
					vecName.push_back(CString(pNode->data().value));
				}
			}
		}
	   if (vecSelectedBuddyUser.size() > 0 )
		{
	    		m_pImgList = CreateDragImageEx(vecName);

				CSharedFile file;
				CArchive ar(&file, CArchive::store);

				
				ar << vecSelectedBuddyUser.size();
				
				for (std::vector<Node*>::iterator buddyIter = vecSelectedBuddyUser.begin(); buddyIter!=vecSelectedBuddyUser.end();
					++buddyIter)
				{
					Node* pNode = *buddyIter;
					/*const IGTBuddyUser* pUser = (IGTBuddyUser*)(pNode->GetNodeUserData());
					ASSERT(pUser != NULL);*/
					if (NULL != pNode)
					{
						const NE_MEMBER_DATA* data = g_pMessengerActor->GetEmployeeInfo(pNode->data().value);
						CNtalkDragData dropUser;
						dropUser.m_hWndSrc = m_hWnd;
						dropUser.SetBuddyUser(/*pUser,*/ data, ar);
					}
				} 
				ar.Close();

				COleDataSource oleDataSource;
				oleDataSource.CacheGlobalData(m_uClipBoardFormat, file.Detach());
				oleDataSource.DoDragDrop();
		} 
		else if(vecSelectedGroup.size() > 0)
		{
			m_pImgList = CreateDragGroupImageEx();	

			CSharedFile file;
			CArchive ar(&file, CArchive::store);
			int nCount = -2;
			ar << nCount;
			for (std::vector<Node*>::iterator buddyIter = vecSelectedGroup.begin(); buddyIter!=vecSelectedGroup.end();
				++buddyIter)
			{
				//const IGTBuddyGroup* pGroup = *buddyIter;
				//ASSERT(pGroup != NULL);
				//if (NULL != pGroup)
				//{
				/*	const NE_MEMBER_DATA* data = g_pMessengerActor->GetEmployeeInfo(pGroup->GetID());
					CNtalkDragData dropUser;
					dropUser.m_hWndSrc = m_hWnd;*/
					//dropUser.SetBuddyUser(pGroup, data, ar);
				//}
			}
			ar.Close();
			COleDataSource oleDataSource;
			oleDataSource.CacheGlobalData(m_uClipBoardFormat, file.Detach());
			oleDataSource.DoDragDrop();
		
		}
	} 
	
}


DROPEFFECT MainFrame::OnDragEnter( CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point)
{

	if(m_eDragDropType == eMenu)
	{
		return m_mainMenuControler.OnDragEnter(pWnd, pDataObject, dwKeyState, point);
	}

	CPoint      ptAction(0, 0);
	GetCursorPos(&ptAction);
	ScreenToClient(m_hWnd, &ptAction);

	if(m_pImgList != NULL)
	{
		m_pImgList->SetDragCursorImage(0, CPoint(0, 0));
		m_pImgList->BeginDrag(0, CPoint(0,0));
		m_pImgList->DragMove(ptAction);			
		m_pImgList->DragEnter(wnd, ptAction);
	}

	return DROPEFFECT_LINK;
}

DROPEFFECT MainFrame::OnDragOver( CWnd* pWnd , COleDataObject* pDataObject, DWORD dwKeyState, CPoint point )
{
	CString str;
	str.Format(_T("MainFrame::OnDragOver\n"));
	OutputDebugString(str);
	if(m_eDragDropType == eMenu)
	{
		return m_mainMenuControler.OnDragOver(pWnd, pDataObject, dwKeyState, point);
	}
	// in eOrganizationTab
	CTabLayoutUI* pTabControl = static_cast<CTabLayoutUI*>(m_PaintManager.FindControl(kTabControlName));
	if (pTabControl != NULL)
	{
        POINT p= {0}, hs = {0};
		CImageList* pil = CImageList::GetDragImage(&p, &hs);
		CPoint      ptAction(0, 0);
		GetCursorPos(&ptAction);
		ScreenToClient(m_hWnd, &ptAction);

		if(pil != NULL)
		{
			pil->DragMove(ptAction);
		}
		if (pTabControl->GetCurSel() == eOrganizationTab)
			return DROPEFFECT_COPY;

	}
	//in favourite view;
    POINT p= {0}, hs={0};
	CImageList* pil = CImageList::GetDragImage(&p, &hs);
	CPoint      ptAction(0, 0);
	GetCursorPos(&ptAction);
	ScreenToClient(m_hWnd, &ptAction);
	
	if(pil != NULL)
	{
		 pil->DragMove(ptAction);
	}
	
   
	CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_PaintManager.FindControl(kFriendsListControlName));

	Node* HitNode = m_pBuddyList->HitTest(ptAction);

    if (HitNode == NULL)
       return DROPEFFECT_NONE;

    int nTargetID = -2;
    IGTBuddyGroup* pGroup = NULL;
	if(m_pBuddyList->IsGroup(HitNode))
	{
		pGroup = (IGTBuddyGroup*)HitNode->GetNodeUserData();
        if (pGroup)
        {
            nTargetID = pGroup->GetID();
            str.Format(_T("Group : nTargetID-- %d \n"),nTargetID);
        }
	}
	else{
       pGroup = (IGTBuddyGroup*)HitNode->parent()->GetNodeUserData();
       if (pGroup)
       {
           nTargetID = pGroup->GetID();
           str.Format(_T("User : nTargetID-- %d \n"),nTargetID);
       }
	}
	//OutputDebugString(str);
	if(nTargetID == RECENT_CONTACT_GROUP_ID)  //target group == -1; return NONE;
	{
		return  DROPEFFECT_NONE;
	}
	///////////////////////////////////////////////////////////
	std::vector<const IGTBuddyUser *> vecSelectedBuddy;
	std::vector<const IGTBuddyGroup*> vecSelectedGroup;
	std::vector<Node*> vecSelectedItem = m_favoriteController.GetSelectedItems();

	for (size_t i = 0; i < vecSelectedItem.size(); i++)
	{
		Node* pNode = vecSelectedItem[i];
		if (pNode->folder() && !pNode->IsRoot())
		{
			vecSelectedGroup.push_back((IGTBuddyGroup*)pNode->GetNodeUserData());
		}
		else
		{
			CString usrID = pNode->data().value;
			const IGTBuddyUser* pUser = g_pMessengerActor->GetAvailbeBuddyInfo(usrID);   //(IGTBuddyUser*)pNode->GetNodeUserData();
			if (!IsFindByID_UserVector(vecSelectedBuddy, usrID))
			{
				vecSelectedBuddy.push_back(pUser);
			}
			//vecSelectedBuddy.push_back((IGTBuddyUser*)pNode->GetNodeUserData());
		}
	}

	//check buddy from work group
	BOOL bBubbyFromWorkGroup = FALSE;
	if (pDataObject->IsDataAvailable(m_uClipBoardFormat) )
	{
		try
		{
			CFile* pFile = pDataObject->GetFileData(m_uClipBoardFormat);
			if (pFile == NULL) return TRUE;

			CArchive ar(pFile, CArchive::load); 
			int nCount = -1;
			ar >> nCount; 

			CString s1;
			CStringArray arrUser;

			for (int i = 0; i < nCount; ++i)
			{
				CNtalkDragData dropUser;
				dropUser.Serialize(ar);
				if(dropUser.m_hWndSrc != m_hWnd && ::IsWindow(dropUser.m_hWndSrc))
				{
					bBubbyFromWorkGroup = TRUE;
				}
				
			}

			ar.Close();
			delete pFile;
		}
		catch (CException* pEx)
		{
            pEx->ReportError();
			pEx->Delete();
			return DROPEFFECT_NONE;
		}
	}

	
	if(vecSelectedGroup.empty() || bBubbyFromWorkGroup)//No groups
	{
		if(bBubbyFromWorkGroup)
		{
			m_eDragDropType = eList;
			return DROPEFFECT_COPY;
		}
        if(vecSelectedBuddy.empty()) 
			return DROPEFFECT_NONE;
        else
			return DROPEFFECT_MOVE;
	}


    // have group to drag
	const IGTBuddyGroup* pGroupSrc;
	if (vecSelectedGroup.size() > 0)
	{	
		//OutputDebugString(_T("vecSelectedGroup.size() > 0  \n"));
		for (int i=0;i< vecSelectedGroup.size();i++){
            pGroupSrc = vecSelectedGroup[i];
			if(pGroupSrc->GetID() == RECENT_CONTACT_GROUP_ID){
				/*str.Format(_T("pGroupSrc,id-- %d ,== RECENT_CONTACT_GROUP_ID\n"),pGroupSrc->GetID());
				OutputDebugString(str);*/
				return DROPEFFECT_NONE;
			}
	    }
        return DROPEFFECT_MOVE;

	}
	else{
		return DROPEFFECT_NONE;
	} 

	//////////////////////////
	/*GetCursorPos(&ptAction);


	CRect rectClient = pFriendsList->GetPos();
	int nScrollDir;
	pWnd->ClientToScreen(rectClient);
	if (ptAction.y >= rectClient.bottom)
		nScrollDir = SB_LINEDOWN;
	else if (ptAction.y < rectClient.top)
		nScrollDir = SB_LINEUP;

	if (nScrollDir == SB_LINEDOWN) 
	{
		pFriendsList->LineDown();
	}

	if (nScrollDir == SB_LINEUP) 
	{
		pFriendsList->LineUp();
	}*/
	
}

DROPEFFECT MainFrame::OnDragScroll( CWnd* pWnd, DWORD dwKeyState, CPoint point )
{
	CString str;
	str.Format(_T("MainFrame::OnDragScroll\n"));
	OutputDebugString(str);
	if(m_eDragDropType == eMenu)
	{
		return m_mainMenuControler.OnDragScroll(pWnd, dwKeyState, point);
	}

	static CPoint      ptActionOld(0,0);
	CPoint      ptAction(0, 0);
	GetCursorPos(&ptAction);
	//ScreenToClient(m_hWnd, &ptAction);

	CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_PaintManager.FindControl(kFriendsListControlName));
	CRect rectClient = pFriendsList->GetPos();
	pWnd->ClientToScreen(rectClient);
	//pWnd->ClientToScreen(&point);

	int iMaxV = pFriendsList->GetScrollRange().cy;
	int iPosV = pFriendsList->GetScrollPos().cy;

	const int SCROLL_BORDER = 10;
	int nScrollDir = -1;
	if ((ptAction.y > rectClient.bottom - SCROLL_BORDER) && (iPosV != iMaxV))
		nScrollDir = SB_LINEDOWN;
	else if ((ptAction.y < rectClient.top + SCROLL_BORDER) && (iPosV != 0))
		nScrollDir = SB_LINEUP;

	if ( (ptAction.y > rectClient.bottom) || (ptAction.y < rectClient.top ))
		pFriendsList->Invalidate();
	else if (ptAction.x != ptActionOld.x || ptAction.y != ptActionOld.y ) // mouse is moving
	{	
		if (nScrollDir != -1)
		{
			pFriendsList->Invalidate();

		}
		
		ptActionOld = ptAction;
		return DROPEFFECT_MOVE;
	}
	if (nScrollDir == SB_LINEDOWN) 
	{
		pFriendsList->LineDown();
		ptActionOld = ptAction;

		return DROPEFFECT_SCROLL;
	}

	if (nScrollDir == SB_LINEUP) 
	{
		pFriendsList->LineUp();
		ptActionOld = ptAction;

		return DROPEFFECT_SCROLL;
	}
	

	return DROPEFFECT_MOVE;
}

void MainFrame::OnDragLeave()
{
	if(m_eDragDropType == eMenu)
	{
		return m_mainMenuControler.OnDragLeave();
	}

    POINT p={0}, hs={0};
	CImageList* pil = CImageList::GetDragImage(&p, &hs);
	CPoint      ptAction(0, 0);
	GetCursorPos(&ptAction);
	ScreenToClient(m_hWnd, &ptAction);

	if (pil != NULL)
	{
		pil->DragMove(ptAction);
		pil->DragLeave(wnd);
		pil->EndDrag();
		pil->DeleteImageList();
		pil = NULL;
	}
	CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_PaintManager.FindControl(kFriendsListControlName));
    pFriendsList->Invalidate();
}


BOOL MainFrame::OnDrop(CWnd* pWnd, COleDataObject* pDataObject,
		DROPEFFECT dropEffect, CPoint point)
{
	BOOL bRet = FALSE;
	if(m_eDragDropType == eMenu)
	{
		bRet =  m_mainMenuControler.OnDrop(pWnd, pDataObject, dropEffect, point);
	}
	else if(m_eDragDropType == eList)
	{
		CPoint      ptAction(0, 0);
		GetCursorPos(&ptAction);
		ScreenToClient(m_hWnd, &ptAction);

		
        POINT p={0}, hs={0};
		CImageList* pil = CImageList::GetDragImage(&p, &hs);

		if (pil != NULL) 
		{
			pil->DragLeave(wnd);
			pil->EndDrag();
			pil->DeleteImageList();
			pil = NULL;
		}

		SAFE_DELETE(m_pImgList);

		Node* pNode = m_pBuddyList->HitTest(ptAction);
		if(pNode == NULL) return TRUE;
		//copy from work group
		if (pDataObject->IsDataAvailable(m_uClipBoardFormat))
		{
			try
			{
				CWnd* pParentWnd= pWnd->GetParent();		

				CFile* pFile = pDataObject->GetFileData(m_uClipBoardFormat);
				if (pFile == NULL) return TRUE;

				CArchive ar(pFile, CArchive::load); 
				int nCount = -1;
				ar >> nCount; 
				if(nCount == -2)
				{
					m_pBuddyList->HandleDragDrop(pNode);
					return TRUE;		
				}
				CString s1;
				vector<wstring>  vecUserId;

				for (int i = 0; i < nCount; ++i)
				{
					CNtalkDragData dropUser;
					dropUser.Serialize(ar);
					if(dropUser.m_hWndSrc == m_hWnd)
					{
						m_pBuddyList->HandleDragDrop(pNode);
						return TRUE;
					}
					vecUserId.push_back(dropUser.m_strID.GetString());
				}
				
				m_pBuddyList->HandleDragBuddy(pNode, vecUserId);
				ar.Close();
				delete pFile;
			}
			catch (CFileException* pEx)
			{
                pEx->ReportError();
                pEx->Delete();
				return FALSE;
			}	
		}
		else
		{
			if(pNode != NULL)
			{
				m_pBuddyList->HandleDragDrop(pNode);
			}
		}

		bRet = TRUE;
	}
	this->PostMessage(WM_LBUTTONUP, 0, MAKELONG(point.x, point.y));
	return bRet;
}

CWnd* MainFrame::GetCWnd()
{
	return CWnd::FromHandle(m_hWnd);
}

SCODE MainFrame::GiveFeedback( DROPEFFECT dropEffect )
{
	return DRAGDROP_S_USEDEFAULTCURSORS;
}

void MainFrame::UpdateUnReadMessage( BOOL bAdd, int nRoomId )
{	if(bAdd)
	{
		CUnReadChatMessage::Instance()->Add(nRoomId);
	}
	else
	{	
		CUnReadChatMessage::Instance()->Clear(nRoomId);
	}

	int nCount = CUnReadChatMessage::Instance()->GetAllCount();

	CMenuOptionUI* pTabCL = static_cast<CMenuOptionUI*>(m_PaintManager.FindControl(_T("tab_chatlist")));
	if(NULL == pTabCL) return;

	if(nCount == 0)
	{
		pTabCL->ShowTip2(FALSE);
	}
	else
	{
		pTabCL->ShowTip2(TRUE);
	}
}

EMENUTAB MainFrame::GetCurrentTabSelect()
{
    EMENUTAB curSelect = eSelectUnknown;
    CTabLayoutUI* pTabControl = static_cast<CTabLayoutUI*>(m_PaintManager.FindControl(kTabControlName));

    ASSERT(pTabControl);
    if (pTabControl != NULL)
    {
        curSelect = (EMENUTAB)pTabControl->GetCurSel();
    }

    return curSelect;
}

BOOL MainFrame::OnCommandHanaBtn( UINT CtrlID )
{
	switch (CtrlID)
	{
	
	case ID_INFOITEM_VOC:
		{
			DoInfoItemVOC();
		}
		break;
	case ID_INFOITEM_SIGN:
		{
			DoInfoItemSign();
		}
		break;
	case ID_INFOITEM_SURVEY:
		{
			//DoInfoItemSurvey();
		}
		break;
	case ID_INFOITEM_IN:
		{
			DoInfoItemIN();
		}
		break;
	case ID_INFOITEM_SAM:
		{
			DoInfoItemSAM();
		}
		break;

	case ID_INFO_SEARCH:
		{
			/*CString strSearchText = m_wndSearch.GetSearchText();
			DoInfoSearch(strSearchText);*/
		}
		break;
		
	}
   return TRUE;
}

CString MainFrame::StringToHex(char* pData)
{
	CString strToHex = _T("");
	int nLen = strlen(pData);
	char szHex[3] = {0,};

	for (int i = 0; i < nLen; i++)
	{
		sprintf_s(szHex, 3, "%02X", pData[i]);
		strToHex += szHex;
	}

	return strToHex;
}

CString MainFrame::MakeHanatourLoginData(CString strLegacySystemName)
{
	CConfirmationNumberDlg cfDlg(this->GetCWnd(), strLegacySystemName);

    GET_MESSENGER_DLG()->RegisterMfcModalDlg(&cfDlg);
    int nRet = cfDlg.DoModal();
    GET_MESSENGER_DLG()->UnRegisterMfcModalDlg(&cfDlg);

	if (nRet != IDOK)
    {
		return _T("");
    }

	const unsigned int lenSHA256 = 32;

	USES_CONVERSION;
	CAESCrypto crypto;

	char *pszAnsiID = W2A(g_stNtalkInfo.strId);
	char *pszAnsiPW = W2A(g_stNtalkInfo.strPassword);
	char *pszAnsiNo = W2A(cfDlg.GetConfirmNo());

	if (!pszAnsiID || !pszAnsiPW || !pszAnsiNo)
		return _T("");

	char szSHA256PW[lenSHA256] = {0,};
	DWORD dwBufSize = lenSHA256;



	if (crypto.GetSHA256(pszAnsiPW, strlen(pszAnsiPW), (BYTE*)szSHA256PW) == FALSE)
		return _T("");

	char szBase64ID[128] = {0,};
	char szBase64PW[128] = {0,};
	char szBase64PW2[256] = {0,};	// PW 傈崔 规侥 (SHA256 -> Base64encoding -> Base64encoding -> 16柳荐 函券)
	char szBase64No[128] = {0,};
	int nB64Len = 0;

	crypto.Base64Encode((const BYTE*)pszAnsiID, strlen(pszAnsiID), szBase64ID, &nB64Len, BASE64_FLAG_NOCRLF);
	crypto.Base64Encode((const BYTE*)szSHA256PW, lenSHA256, szBase64PW, &nB64Len, BASE64_FLAG_NOCRLF);
	crypto.Base64Encode((const BYTE*)szBase64PW, strlen(szBase64PW), szBase64PW2, &nB64Len, BASE64_FLAG_NOCRLF);
	crypto.Base64Encode((const BYTE*)pszAnsiNo, strlen(pszAnsiNo), szBase64No, &nB64Len, BASE64_FLAG_NOCRLF);

	CString strParam;
	strParam.Format(_T("HanaId=%s&HanaPassword=%s&HanaPassword2=%s"), StringToHex(szBase64ID), StringToHex(szBase64PW2), StringToHex(szBase64No));

	return strParam;
}


void MainFrame::OpenURLService(CString strURL)
{
	if (!strURL.IsEmpty())
	{
		CXHyperLink::GotoURL(strURL, SW_SHOWNORMAL);
	}
}

void MainFrame::DoInfoItemVOC()
{

	if (m_mainMenuControler.GetInfoItemURL(hanatourVoc).IsEmpty())
	{
       return;
	}
	CString strLoginParam = MakeHanatourLoginData(_T("VOC"));
	if (strLoginParam.IsEmpty())
		return;

	CString strURL;
	strURL.Format(_T("%s?whoAmI=H&loginType=S&crm=Y&crmTabMenuInit=Y&%s&crmRedirectValue=06"), m_mainMenuControler.GetInfoItemURL(hanatourVoc), strLoginParam);

	OpenURLService(strURL);
}


void MainFrame::DoInfoItemSign()
{
	//m_wndInfoItemSign.SetItemURL(_T("http://intra.hanatour.co.kr/edin/login.sso"));
	if (m_mainMenuControler.GetInfoItemURL(hanatourSign).IsEmpty())
	{
		return;
	}
	CString strLoginParam = MakeHanatourLoginData(LoadStringFromResource(IDS_STRING_MAIN_APPROVAL));

	if (strLoginParam.IsEmpty())
		return;

	CString strURL;
	strURL.Format(_T("%s?whoAmI=H&loginType=S&crm=Y&crmTabMenuInit=Y&%s&crmRedirectValue=10"), m_mainMenuControler.GetInfoItemURL(hanatourSign), strLoginParam);

	OpenURLService(strURL);
}

void MainFrame::DoInfoItemIN()
{
	if (m_mainMenuControler.GetInfoItemURL(hanatourIN).IsEmpty())
	{
		return;
	}

	CString strLoginParam = MakeHanatourLoginData(LoadStringFromResource(IDS_STRING378));
	if (strLoginParam.IsEmpty())
		return;

	CString strURL;
	strURL.Format(_T("%s?whoAmI=H&loginType=S&crm=Y&crmTabMenuInit=Y&%s&crmRedirectValue=28"),m_mainMenuControler.GetInfoItemURL(hanatourIN), strLoginParam);

	OpenURLService(strURL);
}

void MainFrame::DoInfoItemSAM()
{
	if (m_mainMenuControler.GetInfoItemURL(hanatourSAM).IsEmpty())
	{
		return;
	}
	CString strLoginParam = MakeHanatourLoginData(LoadStringFromResource(IDS_STRING374));
	if (strLoginParam.IsEmpty())
		return;

	CString strURL;
	strURL.Format(_T("%s?whoAmI=H&loginType=S&crm=Y&crmTabMenuInit=Y&%s"), m_mainMenuControler.GetInfoItemURL(hanatourSAM), strLoginParam);

	OpenURLService(strURL);
}

void MainFrame::_OnMenuOptionChatWebClick( TNotifyUI& msg )  // chat history
{
	DoInfoItemChatHistory();
}

void MainFrame::_OnMenuOptionMailClick( TNotifyUI& msg )   //mail
{
	DoInfoItemMail();
}

void MainFrame::_OnMenuOptionMemoClick( TNotifyUI& msg ) //memo
{
	DoInfoItemNote();
}

void MainFrame::_OnMenuOptionSignClick( TNotifyUI& msg )  // sign
{
	DoInfoItemSign();
}

void MainFrame::_OnMenuOptionVOCClick( TNotifyUI& msg )  // VOC
{
	DoInfoItemVOC();
}

void MainFrame::_OnMenuOptionSurveyClick( TNotifyUI& msg )   //survey
{
	DoInfoItemSurvey();
}

void MainFrame::_OnMenuOptionINClick( TNotifyUI& msg ) //IN
{
	DoInfoItemIN();
}

void MainFrame::_OnMenuOptionSAMClick( TNotifyUI& msg )  // SAM
{
	DoInfoItemSAM();
}


void MainFrame::_OnMenuArrowUp( TNotifyUI& msg )
{
	m_mainMenuControler.LineUp();
}

void MainFrame::_OnMenuArrowDown( TNotifyUI& msg )
{
	m_mainMenuControler.LineDown();
}


